
/*调用支付窗口
 * payPressWin.show(success,cancel)
 * 参数：
 * success：fn  输入6位数字后会立即执行此函数,已传入输入的6位数字
 * cancel：fn  点击“取消”后调用此函数
 *
 * 关闭当前支付窗口  关闭窗口时，不会执行已经配置的cancel函数
 * payPressWin.close();
 * */
(function (w) {
    if(document.getElementById("payPressCover")){
        throw new Error("payPressCover节点已存在");
        return;
    }
    //-----------------------------------------------------------------------锁住window滚动
    var lockWinScroll = {};
    var eType=document.addEventListener!==undefined;
    var disWin, enaWin, lockWin, lockKeyWin,listenMouse;
    //禁用窗口滚动事件
    lockWin = function (e) {
        e.preventDefault&&e.preventDefault();
        e.returnValue = false;
        return false
    };
    //禁用上下左右 pagedown等翻页键
    lockKeyWin = function (e) {
        if (e.keyCode&&e.keyCode > 32 && e.keyCode < 41) {
            e.preventDefault&&e.preventDefault();
            return false
        }
        return true
    };
    listenMouse =function(b){
        //确定绑定还是解绑
        var method=b?(eType?"addEventListener":"attachEvent"):(eType?"removeEventListener":"detachEvent");
        //兼容性
        if(eType){
            //火狐鼠标滚轮事件
            window[method]("DOMMouseScroll", lockWin, false);
            //ie9+,chrome滚轮事件
            window[method]("mousewheel", lockWin, false);
            //手机touch事件
            window[method]("touchmove", lockWin, false);
            //键盘输入滚动事件
            document[method]("keydown", lockKeyWin, false);
        }
        else {
            document[method]("onmousewheel", lockWin);
            document[method]("onkeydown", lockKeyWin);
        }
    };
    disWin = function () {
        listenMouse(true);
    };
    enaWin = function () {
        listenMouse(false);
    };
    lockWinScroll.lock = disWin;
    lockWinScroll.clear = enaWin;
    //------------------------------------------------------------------------插入样式表及dom
    var htmls= '<div class="pay_press_main">' +
        '<h2>请输入6位支付密码</h2>' +
        '<div class="pay_press_box">' +
        '<div>*</div><div>*</div><div>*</div><div>*</div><div>*</div><div class="last">*</div>' +
        '</div></div>' +
        '<div class="pay_press_keyboard">' +
        '<div class="pay_press_blank">' +
        '</div><span>1</span><span>2</span><span class="pay_press_border">3</span><span>4</span><span>5</span><span class="pay_press_border">6</span>' +
        '<span>7</span><span>8</span><span class="pay_press_border">9</span><span class="pay_press_text">取消</span> <span>0</span><span class="pay_press_border pay_press_text">删除</span>' +
        '</div>' +
        '<div class="pay_press_wait pay_press_wait_hide">' +
        '<span class="pay_press_wait_block"><b class="pay_press_wait1"></b><b class="pay_press_wait2"></b><b class="pay_press_wait3"></b><b class="pay_press_wait4"></b>' +
        '<b class="pay_press_wait5"></b><b class="pay_press_wait6"></b><b class="pay_press_wait7"></b><b class="pay_press_wait8"></b></span></div>';
    var cssRule={
        '#payPressCover':'box-sizing:content-box;display:none;position:absolute;left:0;top:0;right:0;bottom:0;background-color:rgba(0,0,0,.5);z-index:1000;-webkit-transform:translateZ(0);moz-user-select: -moz-none; -moz-user-select: none; -o-user-select:none; -khtml-user-select:none; -webkit-user-select:none;-ms-user-select:none; user-select:none;',
        '.pay_press_main,.pay_press_main div,.pay_press_main h2,.pay_press_main span,.pay_press_main b':'box-sizing:content-box',
        '.pay_press_main':'height:auto;width:260px;background-color:#fff;position:relative;top:100px;z-index:999;margin:0 auto;padding:20px;',
        '.pay_press_main h2':'font-size:14px;color:#777;font-weight:300;line-height:25px;text-align:center;margin:0 0 15px;',
        '.pay_press_box':'height:39px;width:239px;border:1px solid #999;overflow:hidden;margin:0 auto;',
        '.pay_press_box:after':'content:".";display:block;height:0;width:0;clear:both;opacity:0;overflow:hidden;',
        '.pay_press_box div':'height:39px;width:39px;border-right:1px solid #eee;float:left;font-size:16px;line-height:39px;text-align:center;',
        '.pay_press_box .last':'border-right:0;',
        '.pay_press_keyboard':'height:230px;width:100%;position:absolute;left:0;bottom:0;background-color:#eee;z-index:999;',
        '.pay_press_keyboard span':'box-sizing:border-box;height:50px;width:33.333333%;border-right:1px solid #ccc;border-top:1px solid #ccc;float:left;font-size:24px;text-align:center;line-height:44px;',
        '.pay_press_keyboard .pay_press_border':'border-right:none;',
        '.pay_press_keyboard .pay_press_text':'font-size:14px;color:#777;background-color:#ccc;',
        '.pay_press_keyboard span:active':'background-color:#aaa;border-color:#aaa;',
        '.pay_press_blank':'height:30px;',
        '.pay_press_wait':'height:100%;width:100%;position:absolute;left:0;top:0;z-index:1000;background-color:rgba(0,0,0,.2);',
        '.pay_press_wait_hide':'display:none;',
        '.pay_press_wait_block':'display:block;height:50px;width:50px;position:absolute;left:50%;top:50%;-webkit-transform:rotateZ(0);-moz-transform:rotateZ(0);-ms-transform:rotateZ(0);-o-transform:rotateZ(0);transform:rotateZ(0);margin:-25px 0 0 -25px;',
        '.pay_press_wait_block b':'height:8px;width:2px;position:absolute;left:24px;top:3px;-webkit-transform-origin:1px 22px;-moz-transform-origin:1px 22px;-ms-transform-origin:1px 22px;-o-transform-origin:1px 22px;transform-origin:1px 22px;',
        '#payPressCover .pay_animate_wait':'-webkit-transform-origin:25px 25px;-moz-transform-origin:25px 25px;-ms-transform-origin:25px 25px;-o-transform-origin:25px 25px;transform-origin:25px 25px;-webkit-transform:rotateZ(36000deg);-moz-transform:rotateZ(36000deg);-ms-transform:rotateZ(36000deg);-o-transform:rotateZ(36000deg);transform:rotateZ(36000deg);-webkit-transition:-webkit-transform 80s linear;-moz-transition:-moz-transform 80s linear;-ms-transition:-ms-transform 80s linear;-o-transition:-o-transform 80s linear;transition:transform 80s linear;'
    };
    var cssLoopRule ={
        number:8,
        selector:'.pay_press_wait',
        inset:function(i){
            return i*45
        },
        rule:'background-color:rgba(255,255,255,!);-webkit-transform:rotateZ(?deg);-moz-transform:rotateZ(?deg);-ms-transform:rotateZ(?deg);-o-transform:rotateZ(?deg);transform:rotate?deg0);'
    };
    var payPressCover=document.createElement("div");
    payPressCover.setAttribute("id","payPressCover");
    payPressCover.innerHTML=htmls;
    document.getElementsByTagName("body")[0].appendChild(payPressCover);
    var styleDom,sheet;
    styleDom=document.createElement("style");
    if(styleDom.textContent===undefined){
        styleDom.textContent="";
    }
    else {
        styleDom.appendChild(document.createTextNode(" "));
    }
    document.getElementsByTagName("head")[0].appendChild(styleDom);
    //兼容ie
    if(styleDom.sheet!==undefined){
        sheet=styleDom.sheet;
    }
    else if(styleDom.styleSheet!==undefined){
        sheet=styleDom.styleSheet;
    }
    //添加样式规则
    var insertRule=function(rule,sheet){
        for(var i in rule){
            sheet.insertRule(i+" {"+rule[i]+"}",0);
        }
    };
    var addRule=function(rule,sheet){
        for(var i in rule){
            sheet.addRule(i,rule[i]);
        }
    };
    //添加普通样式规则并循环添加重复样式
    var setRule=function(rule,sheet){
        if("insertRule" in sheet){
            insertRule(rule,sheet);

        }
        else if("addRule" in sheet){
            addRule(rule,sheet);
        }
    };
    var loopRuleAry={};
    for(var i= 0;i<cssLoopRule.number;i++){
        loopRuleAry[(""+cssLoopRule.selector+(i+1))]=cssLoopRule.rule.replace(/\?/g,function(s){
            return cssLoopRule.inset(i);
        }).replace(/\!/g,function(s){
                return 0.2+0.1*i
         })
    }
    setRule(loopRuleAry,sheet);
    loopRuleAry=null;
    setRule(cssRule,sheet);

    //----------------------------------------------------------------------设置事件
    var code="";
    var coverMain=document.getElementById("payPressCover");
    var keyMain=coverMain.getElementsByClassName("pay_press_box")[0].getElementsByTagName("div");
    var waitMain=coverMain.getElementsByClassName("pay_press_wait")[0];
    var waitMainRotate=waitMain.getElementsByClassName("pay_press_wait_block")[0];
    var keyBoard=coverMain.getElementsByClassName("pay_press_keyboard")[0];
    var pressPay=function(n){
        if(n===undefined){
            code="";
        }
        else if(n===-1){
            code=code.length?code.slice(0,-1):code;
        }
        else {
            code.length<6&&(code+=(String(n).charAt(0)));
        }
        for(var i =0;i<6;i++){
            if(i<code.length){
                keyMain[i].innerText="*";
            }
            else {
                keyMain[i].innerText="";
            }
        }
        if(code.length===6){
            waitMain.className="pay_press_wait";
            setTimeout(function(){
                waitMainRotate.className="pay_press_wait_block pay_animate_wait";
                successPay(code);
            },200);
        }
    };
    var closePay=function(){
        lockWinScroll.clear();
        waitMainRotate.className="pay_press_wait_block";
        waitMain.className="pay_press_wait pay_press_wait_hide";
        pressPay();
        if(coverMain.style.display="block"){
            coverMain.style.display="none";
        }
    };
    var showPay=function(s,c){
        if(coverMain.style.display==="none"||coverMain.style.display===""){
            lockWinScroll.lock();
            coverMain.style.display="block";
            if(s&&typeof s==="function"){
                successPay=s;
            }
            else {
                successPay=function(v){};
            }
            if(c&&typeof c==="function"){
                cancelPay=c;
            }
            else {
                cancelPay=function(v){};
            }
        }
    };
    var successPay=function(v){};
    var cancelPay=function(){};
    keyBoard.addEventListener(window.ontouchstart===undefined?"click":"touchstart",function(e){
        e.preventDefault();
        var target= e.target;
        var text;
        if(target.tagName==="SPAN"){
            text=target.innerText;
            if(text==="删除"){
                pressPay(-1);
            }
            else if(text==="取消"){
                closePay();
                cancelPay();
            }
            else if(!isNaN(parseInt(text))) {
                pressPay(text);
            }
        }
        return false
    },false);
    //------------------------------------------------抛出payPressWin对象
    w.payPressWin={};
    w.payPressWin.show=showPay;
    w.payPressWin.close=closePay;
    pressPay();//防止页面刷新时保留*
})(window);