/*
* 注册、登陆、找回密码页面共用js
* */
/*验证正则表达式*/
//    新西兰 9-11位
//    德国    10-11位
//    法国    9-10位
//    中国   11位
//    日本   11位
//    韩国   10-11位
//    澳大利亚   9-10位
//    美国   10位
// var regCountryRule={
//     "新西兰":/^\d{8,11}$/,
//     "德国":/^\d{10,11}$/,
//     "法国":/^\d{9,10}$/,
//     "中国":/^\d{11}$/,
//     "日本":/^\d{11}$/,
//     "韩国":/^\d{10,11}$/,
//     "澳大利亚":/^\d{9,10}$/,
//     "美国":/^\d{9,10}$/
// };
// var regCodeRule={
//     "0064":/^\d{8,11}$/,
//     "0049":/^\d{10,11}$/,
//     "0033":/^\d{9,10}$/,
//     "0086":/^\d{11}$/,
//     "0081":/^\d{11}$/,
//     "0082":/^\d{10,11}$/,
//     "0061":/^\d{9,10}$/,
//     "001":/^\d{9,10}$/
// };

/*
* 2.15取消了所有验证规则
* */
var regCountryRule={
    "新西兰":/^\d*$/,
    "德国":/^\d*$/,
    "法国":/^\d*$/,
    "中国":/^\d*$/,
    "日本":/^\d*$/,
    "韩国":/^\d*$/,
    "澳大利亚":/^\d*$/,
    "美国":/^\d*$/
};
var regCodeRule = {
    "0064":/^\d*$/,
    "0049":/^\d*$/,
    "0033":/^\d*$/,
    "0086":/^\d*$/,
    "0081":/^\d*$/,
    "0082":/^\d*$/,
    "0061":/^\d*$/,
    "001":/^\d*$/
};

//验证指定容器内的所有表单元素 （容器id）
function verifyForm(id){
    var passClass="e_choice";//选填表单
    var box=$("#"+id);
    var inputs=box.find("input[name],select[name],textarea[name]");
    var _t,p,v,mack=true,temp={};
    for(var i=0;i<inputs.length;i++){
        _t=inputs.eq(i);
        p=_t.attr("name");
        v=_t.val().replace(/(^\s|\s$)/g,"");
        temp[p]=v;
        if(!_t.hasClass(passClass)){
            if(v===""){
                app.toast(_t.attr("placeholder"));
                mack=false;
                break;
            }
            if(p==="mobile"){
                var areacodeSelect=box.find("select[name=areacode]");
                if(areacodeSelect.length){
                    var areacodeValue=areacodeSelect.val().replace(/(^\s|\s$)/g,"");
                    var regCode=regCodeRule;
                    if(regCode[String(areacodeValue)]&&!regCode[String(areacodeValue)].test(v)){
                        mack=false;
                        app.toast("手机号格式错误!");
                    }
                }
                if(!mack){
                    break;
                }
            }
            if((p==="user_name"||p==="member_name")&&!(/^[\u4e00-\u9fa5a-zA-Z0-9_]+$/).test(v)){
                app.toast("昵称仅能由数字.字母或下划线组成!");
                mack=false;
                break;
            }
        }
        else if(v!==""){
            if(p==="inviter_mobile"&&!(/^[0-9]{9,11}$/).test(v)){
                app.toast("输入的邀请人手机号码有误!");
                mack=false;
                break;
            }
            if(p==="password"||p==="password2"){
                if(v.length<6){
                    app.toast("请输入6位密码!");
                    mack=false;
                    break;
                }
            }
        }
    }
    return mack?temp:mack;
}
//发送验证码 (按钮id，获取方式)
function getCode(id,type,data){
    var _t=$("#"+id);
    var saveText=_t.text();
    var urls={
        "emailRegister":{url:"/index.php?act=login&op=send_email"},
        "mobileRegister":{url:"/index.php?act=login&op=send_verify_reg"},
        "emailForget":{url:"/index.php?act=login&op=send_email"},
        "mobileForget":{url:"/index.php?act=login&op=send_verify_pas"}
    };
    var count=60;
    if(_t.hasClass("dis")){
        return false;
    }
    if(!urls[type]){
        throw Error("没有找到发送"+type+"验证码方式")
    }
    //发送请求
    _t.addClass("dis");
    app.post({
        url:app.config.url+urls[type].url,
        data:typeof data==="object"?data:{},
        success:function(res){
            _t.text(count+"秒后重试");
            app.interval(function(i){
                _t.text(count-i+"秒后重试");
            },1000,count,function(){
                _t.text(saveText).removeClass("dis");
            });
        },
        defeat:function(e){
            app.toast(e.msg);
            _t.text(saveText).removeClass("dis");
        }
    });
}