﻿///<jscompress sourcefile="main_tool.js" />
/*
 * 工具
 * *a>template整合,测试、报错方法
 * *b>工具函数
 * *c>dom操作封装
 * *d>继承$.api对象
 * 
 * *e>ui控件,页面插件,二次封装api功能等
 * *f>独立页面功能封装
 * */
(function(app){
    /*
     * 打印测试数据
     * */
    window.test = app.test = function () {
        if(window.app&&window.app.config&&window.app.config.notTest){
            return false;
        }
        var r = "";
        for (var i = 0; i < arguments.length; i++) {
            if (typeof arguments[i] === "object") {
                r = JSON.stringify(arguments[i]);
            }
            else if (typeof arguments[i] === "function") {
                r = arguments[i].toString();
            }
            else {
                r = arguments[i];
            }
            alert(Object.prototype.toString.call(arguments[i]).slice(8, -1) + ":" + r);
        }
    };
    /*
     * 处理报错
     * */
    window.exportError = app.exportError =function (er){
        throw Error(er);
    };
    /*
    * 设置时间节点
    * */
    window.sdd=app.sdd=function(){
        app.sdt._start=new Date().getTime();
    };
    /*
     * 弹出时间节点
     * attr:_start 开始时间
     * ps:用于打印时间间隔
     * */
    window.sdt = app.sdt =function(){
        var startDate=app.sdt._start;
        if(startDate===undefined){
            app.sdt._start=new Date().getTime();
        }
        else {
            test(new Date().getTime()-startDate)
        }
    };
    /*
    * a>模板
    * */
    /*
     * 添加arttemplate.js模板,整合到api.template中
     * API:https://github.com/aui/artTemplate
     */
    !function(e){"use strict";var n=function(e,r){return n["string"==typeof r?"compile":"render"].apply(n,arguments)};n.version="2.0.3",n.openTag="<%",n.closeTag="%>",n.isEscape=!0,n.isCompress=!1,n.parser=null,n.render=function(e,r){var t=n.get(e)||i({id:e,name:"Render Error",message:"No Template"});return t(r)},n.compile=function(e,t){function a(r){try{return new s(r,e)+""}catch(o){return u?i(o)():n.compile(e,t,!0)(r)}}var c=arguments,u=c[2],l="anonymous";"string"!=typeof t&&(u=c[1],t=c[0],e=l);try{var s=o(e,t,u)}catch(p){return p.id=e||t,p.name="Syntax Error",i(p)}return a.prototype=s.prototype,a.toString=function(){return s.toString()},e!==l&&(r[e]=a),a};var r=n.cache={},t=n.helpers=function(){var e=function(n,r){return"string"!=typeof n&&(r=typeof n,"number"===r?n+="":n="function"===r?e(n.call(n)):""),n},r={"<":"&#60;",">":"&#62;",'"':"&#34;","'":"&#39;","&":"&#38;"},t=function(n){return e(n).replace(/&(?![\w#]+;)|[<>"']/g,function(e){return r[e]})},i=Array.isArray||function(e){return"[object Array]"==={}.toString.call(e)},o=function(e,n){if(i(e))for(var r=0,t=e.length;t>r;r++)n.call(e,e[r],r,e);else for(r in e)n.call(e,e[r],r)};return{$include:n.render,$string:e,$escape:t,$each:o}}();n.helper=function(e,n){t[e]=n},n.onerror=function(n){var r="Template Error\n\n";for(var t in n)r+="<"+t+">\n"+n[t]+"\n\n";e.console&&console.error(r)},n.get=function(t){var i;if(r.hasOwnProperty(t))i=r[t];else if("document"in e){var o=document.getElementById(t);if(o){var a=o.value||o.innerHTML;i=n.compile(t,a.replace(/^\s*|\s*$/g,""))}}return i};var i=function(e){return n.onerror(e),function(){return"{Template Error}"}},o=function(){var e=t.$each,r="break,case,catch,continue,debugger,default,delete,do,else,false,finally,for,function,if,in,instanceof,new,null,return,switch,this,throw,true,try,typeof,var,void,while,with,abstract,boolean,byte,char,class,const,double,enum,export,extends,final,float,goto,implements,import,int,interface,long,native,package,private,protected,public,short,static,super,synchronized,throws,transient,volatile,arguments,let,yield,undefined",i=/\/\*[\w\W]*?\*\/|\/\/[^\n]*\n|\/\/[^\n]*$|"(?:[^"\\]|\\[\w\W])*"|'(?:[^'\\]|\\[\w\W])*'|[\s\t\n]*\.[\s\t\n]*[$\w\.]+/g,o=/[^\w$]+/g,a=new RegExp(["\\b"+r.replace(/,/g,"\\b|\\b")+"\\b"].join("|"),"g"),c=/^\d[^,]*|,\d[^,]*/g,u=/^,+|,+$/g,l=function(e){return e.replace(i,"").replace(o,",").replace(a,"").replace(c,"").replace(u,"").split(/^$|,+/)};return function(r,i,o){function a(e){return m+=e.split(/\n/).length-1,n.isCompress&&(e=e.replace(/[\n\r\t\s]+/g," ").replace(/<!--.*?-->/g,"")),e&&(e=x[1]+p(e)+x[2]+"\n"),e}function c(e){var r=m;if($?e=$(e):o&&(e=e.replace(/\n/g,function(){return m++,"$line="+m+";"})),0===e.indexOf("=")){var i=!/^=[=#]/.test(e);if(e=e.replace(/^=[=#]?|[\s;]*$/g,""),i&&n.isEscape){var a=e.replace(/\s*\([^\)]+\)/,"");t.hasOwnProperty(a)||/^(include|print)$/.test(a)||(e="$escape("+e+")")}else e="$string("+e+")";e=x[1]+e+x[2]}return o&&(e="$line="+r+";"+e),u(e),e+"\n"}function u(n){n=l(n),e(n,function(e){y.hasOwnProperty(e)||(s(e),y[e]=!0)})}function s(e){var n;"print"===e?n=T:"include"===e?(v.$include=t.$include,n=O):(n="$data."+e,t.hasOwnProperty(e)&&(v[e]=t[e],n=0===e.indexOf("$")?"$helpers."+e:n+"===undefined?$helpers."+e+":"+n)),w+=e+"="+n+","}function p(e){return"'"+e.replace(/('|\\)/g,"\\$1").replace(/\r/g,"\\r").replace(/\n/g,"\\n")+"'"}var f=n.openTag,d=n.closeTag,$=n.parser,g=i,h="",m=1,y={$data:1,$id:1,$helpers:1,$out:1,$line:1},v={},w="var $helpers=this,"+(o?"$line=0,":""),b="".trim,x=b?["$out='';","$out+=",";","$out"]:["$out=[];","$out.push(",");","$out.join('')"],E=b?"$out+=$text;return $text;":"$out.push($text);",T="function($text){"+E+"}",O="function(id,data){data=data||$data;var $text=$helpers.$include(id,data,$id);"+E+"}";e(g.split(f),function(e){e=e.split(d);var n=e[0],r=e[1];1===e.length?h+=a(n):(h+=c(n),r&&(h+=a(r)))}),g=h,o&&(g="try{"+g+"}catch(e){"+"throw {"+"id:$id,"+"name:'Render Error',"+"message:e.message,"+"line:$line,"+"source:"+p(i)+".split(/\\n/)[$line-1].replace(/^[\\s\\t]+/,'')"+"};"+"}"),g=w+x[0]+g+"return new String("+x[3]+");";try{var S=new Function("$data","$id",g);return S.prototype=v,S}catch(P){throw P.temp="function anonymous($data,$id) {"+g+"}",P}}}();"function"==typeof define?define(function(){return n}):"undefined"!=typeof exports&&(module.exports=n),e.template=n}(this);
    app.template = window.template;
    /*
     * 设置api加载完成回调
     * attr: queue 待执行函数队列
     * ps:所有使用api对象的操作都要在ready内调用,可以调用多个ready，会按顺序执行
     *
     */
    app.ready = function (readyFn) {
        if (typeof readyFn !== "function") {
            return this;
        }
        if (window.api !== undefined) {
            readyFn();
        }
        else if (this.ready.queue === undefined) {
            this.ready.queue = [readyFn];
            window.apiready = function () {
                app._for(app.ready.queue, function (i) {
                    app.ready.queue[i]();
                });
                app.fireReady !== undefined && app.fireReady();
            }
        }
        else {
            this.ready.queue.push(readyFn);
        }
        return this;
    };
    /*
     * b>工具函数
     * */
    //验证对象类型
    app.dataType = function (o) {
        if (o === null) {
            return "Null";
        }
        if (o === undefined) {
            return "Undefined";
        }
        if (typeof o === "number") {
            return isNaN(o) ? "NaN" : "Number";
        }
        return Object.prototype.toString.call(o).slice(8, -1);
    };
    //对象是否为数组
    app.isArray = function (o) {
        return Object.prototype.toString.call(o).slice(8, -1) === "Array";
    };
    //对象是否为自定义对象
    app.isObj = function (o) {
        return Object.prototype.toString.call(o).slice(8, -1) === "Object";
    };
    //验证目标对象是否在数组内
    app.inArray = function (t, ary) {
        var mack=0;
        app._for(ary, function (i) {
            ary[i] === t && (mack =i+1);
        });
        return mack;
    };
    //对象遍历操作代理
    app._each = function (o, fn) {
        for (var i in o) {
            if (fn.call(o[i], i) === "break") {
                break;
            }
        }
        return this;
    };
    //数组循环操作代理
    app._for = function (ary, fn) {
        for (var i = 0; i < ary.length; i++) {
            if (fn.call(ary[i], i) === "break") {
                break;
            }
        }
        return this;
    };
    //转化为json
    app.toJson = function (str) {
        var o = {};
        try {
            o = JSON.parse(str);
        }
        catch (e) {
        }
        return o;
    };
    //转化为str
    app.toStr = function (json) {
        var o = {};
        try {
            o = JSON.stringify(json);
        }
        catch (e) {
        }
        return o;
    };
    //条件定时器(函数，间隔，结束条件（次数/判断函数）,结束回调)
    app.interval = function (f, i, h, e) {
        var fn = function () {
            count++;
            f(count);
            return false;
        }, it = null, count = 0;
        if (typeof (h) === "number") {
            fn = function () {
                count++;
                f(count);
                return count === h;
            }
        }
        else if (typeof (h) === "function") {
            fn = function () {
                count++;
                f(count);
                return !!h(count)
            }
        }
        it = setTimeout(function () {
            if (!fn()) {
                it = setTimeout(arguments.callee, i);
            }
            else {
                typeof e === "function" && e();
            }
        }, i);
        return function () {
            clearTimeout(it);
        };
    };
    /*
     * c>dom操作
     * */
    //插入样式表
    app.insertSheet = function (styles) {
        var stylesheetObj, styleElement;
        var rid = "insertStyle" + (Math.random() + "").slice(2);
        if (document.createStyleSheet) {
            stylesheetObj = document.createStyleSheet();
            styleElement = stylesheetObj.owningElement;
            styleElement.id = rid;
        }
        else {
            styleElement = document.createElement("style");
            styleElement.id = rid;
            document.getElementsByTagName("head")[0].appendChild(styleElement);
            stylesheetObj = styleElement.sheet;

        }
        if (typeof styles === "string") {
            console.log(stylesheetObj.cssText)
            stylesheetObj.cssText !== undefined ? (stylesheetObj.cssText = styles) : (styleElement.innerHTML = styles);
        }
        else if (typeof styles === "object") {
            if (stylesheetObj.insertRule) {
                for (var i in styles) {
                    stylesheetObj.insertRule(i + " {" + styles[i] + "}", stylesheetObj.cssRules.length);
                }
            }
            else {
                for (var i in styles) {
                    stylesheetObj.addRule(i, styles[i], stylesheetObj.rules.length);
                }
            }
        }
        return styleElement;
    };
    //禁止窗口滚动(true：锁定窗口 false：解锁窗口)
    app.lockWin = (function (w) {
        var eType = document.addEventListener !== undefined;
        var lockWin, lockKeyWin;
        //禁用窗口滚动事件
        lockWin = function (e) {
            e.preventDefault && e.preventDefault();
            e.returnValue = false;
            return false
        };
        //禁用上下左右 pagedown等翻页键
        lockKeyWin = function (e) {
            if (e.keyCode && e.keyCode > 32 && e.keyCode < 41) {
                e.preventDefault && e.preventDefault();
                return false
            }
            return true
        };
        return function (b) {
            //确定绑定还是解绑
            var method = !!b ? (eType ? "addEventListener" : "attachEvent") : (eType ? "removeEventListener" : "detachEvent");
            //兼容性
            if (eType) {
                //火狐鼠标滚轮事件
                window[method]("DOMMouseScroll", lockWin, false);
                //ie9+,chrome滚轮事件
                window[method]("mousewheel", lockWin, false);
                //手机touch事件
                window[method]("touchmove", lockWin, false);
                //ios touch事件
                window[method]("touchstart", lockWin, false);
                //键盘输入滚动事件
                document[method]("keydown", lockKeyWin, false);
            }
            else {
                document[method]("onmousewheel", lockWin);
                document[method]("onkeydown", lockKeyWin);
            }
            return this;
        };
    })(window);
    //获取目标对象在窗口中的位置（可能适用于滚动加载图片）
    app.offset = function (el) {
        var sl = Math.max(document.documentElement.scrollLeft, document.body.scrollLeft);
        var st = Math.max(document.documentElement.scrollTop, document.body.scrollTop);

        var rect = el.getBoundingClientRect();
        return {
            l: rect.left + sl,
            t: rect.top + st,
            w: el.offsetWidth,
            h: el.offsetHeight
        };
    };
    //为节点设置长按事件(节点选择器，事件函数  默认延迟为1s,允许位移区域为0)
    app.setTouchLongClick=function(el,fn,closeBounce){
        var allDom=$(""+el);
        if(allDom.length){
            allDom.each(function(){
                var dom=$(this);
                if(dom.hasClass("btn_has_init")){
                    return false;
                }
                var cacheInterval=null,cacheTime=0;//点击状态
                dom[0].addEventListener("touchstart",function(e){
                    // e.preventDefault();
                    // e.stopPropagation();
                    cacheTime=new Date().getTime();
                    cacheInterval=setTimeout(function(){
                        typeof fn==="function"&&fn(dom);
                        cacheInterval=null;
                    },800);
                    if(closeBounce){//强制关闭下拉刷新
                        api.setFrameAttr({
                            bounces: false
                        });
                    }
                },true);
                dom[0].addEventListener("touchmove",function(e){
                    // e.stopPropagation();
                    if(closeBounce){
                        api.setFrameAttr({
                            bounces: true
                        });
                    }
                    if(cacheInterval){
                        clearTimeout(cacheInterval);
                        cacheInterval=null;
                    }
                },true);
                dom[0].addEventListener("touchend",function(e){
                    if(closeBounce){//重新开启下拉刷新
                        api.setFrameAttr({
                            bounces: true
                        });
                    }
                    if(cacheInterval){
                        clearTimeout(cacheInterval);
                        cacheInterval=null;
                        return true;
                    }
                    else {
                        e.stopPropagation();
                        return false;
                    }
                },true);
            }).addClass("btn_has_init");
        }
        return this;
    };


    /*
     * 初始化slideWrapper的滑动效果
     *
     * ps:html结构请使用.slide-wrapper>.slide-content+.slide-delete结构
     * */
    app.initSlideWrapper=function(selector,closeBounce){
        var allWp=$(selector+":not(.wrapper_has_init)");
        allWp.each(function(){
            var _wp=$(this);
            if(_wp.hasClass("wrapper_has_init")){
                return false;
            }
            var option={
                closeBounce:false,
                isFirstMove:true,
                canComplete:true,
                startX:null,
                startY:null,
                nowX:null,
                nowY:null,
                outWidth:15,//额外允许偏移位置
                angle:1,//初始偏移量 y/x不大于此值时判定为左右滚动，阻止浏览器默认上下滑动
                state:0,//所处状态 1：展开 0：收缩
            };
            _wp.on("touchstart",tStart(option,_wp));
            _wp.on("touchmove",tMove(option,_wp));
            _wp.on("touchend",tEnd(option,_wp));
        }).addClass("wrapper_has_init");

        function tStart (t,o){
            return function(e){
                t.startX=t.nowX=e.touches[0].clientX;
                t.startY=t.nowY=e.touches[0].clientY;
            }
        }
        function tMove (t,o){
            return function(e){
                var moveX,moveY;
                if(t.canComplete){
                    t.nowX=e.touches[0].clientX;
                    t.nowY=e.touches[0].clientY;
                    moveX=t.nowX-t.startX;
                    moveY=t.nowY-t.startY;
                }
                if(t.isFirstMove){
                    t.isFirstMove=false;
                    if(Math.abs(moveY/moveX)>t.angle){
                        t.canComplete=false;
                    }
                    else {
                        //关闭坑爹的下拉弹动
                        if(closeBounce&&!t.closeBounce){
                            t.closeBounce=true;
                            api.setFrameAttr({
                                bounces: false
                            });
                        }
                        return false;
                    }
                }
                if(t.canComplete){
                    e.preventDefault();
                    //根据偏移量设定实际偏移量
                    if(t.state){
                        if(moveX<0-t.outWidth){
                            moveX=0-t.outWidth;
                        }
                        else if(moveX>60+t.outWidth){
                            moveX=60+t.outWidth;
                        }
                    }
                    else {
                        if(moveX<-60-t.outWidth){
                            moveX=-60-t.outWidth
                        }
                        else if(moveX>t.outWidth){
                            moveX=t.outWidth;
                        }
                    }
                    moveX=t.state?moveX-60:moveX;
                    setTranslateX(o,moveX);
                }
            }
        }
        function tEnd (t,o){
            return function(e){
                if(t.canComplete){
                    var moveX=t.nowX-t.startX;
                    moveX=t.state?moveX-60:moveX;
                    var endState=null;
                    if(moveX<-30){
                        //展开
                        toTranslateX(o,-60);
                        endState=1;
                    }
                    else {
                        //关闭
                        toTranslateX(o,0);
                        endState=0;
                    }
                    //阻止后续touchend事件
                    e.preventDefault();
                    e.stopPropagation();
                    //重新开启坑爹的下拉弹动
                    if(closeBounce&&t.closeBounce){
                        t.closeBounce=false;
                        api.setFrameAttr({
                            bounces: true
                        });
                    }
                }
                else {
                    setTranslateX(o,t.state?-60:0);
                }
                //重置变量
                t.isFirstMove=t.canComplete=true;
                t.startX=t.startY=t.nowX=t.nowY=null;
                t.state=endState;
                return !t.canComplete;
            }
        }
        function setTranslateX(o,x){
            o.css({
                "transition":"none",
                "-webkit-transition":"none",
                "transform":"translate3d("+x+"px,0,0)",
                "-webkit-transform":"-webkit-translate3d("+x+"px,0,0)"
            });
        }
        function toTranslateX(o,x){
            o.css({
                "transition":"transform .05s ease-out",
                "-webkit-transition":"-webkit-transform .05s ease-out",
                "transform":"translate3d("+x+"px,0,0)",
                "-webkit-transform":"-webkit-translate3d("+x+"px,0,0)"
            });
        }
        return this;
    };

    /*
     * 将js目录下的js文件加载到页面中
     * link:相对于 script文件夹内部的地址
     * call:js onload时的回调
     * ps:取得相对路径是基于页面中main.js引入的路径，如果获取不到，则只有取wgtRootDir
     * */
    app.loadJs=function(link,call){
        var bd=$("body");
        var allJs=bd.find("script");
        var prefix=null;
        allJs.each(function(){
            var _t=$(this);
            var _m=_t.attr("src").replace(/(^\s)|(\s$)/g,"");
            if(_m.match(/\/script\/main.js$/)){
                prefix= _m.replace(/\/script\/main.js$/,"");
            }
        });
        if(!prefix){
            prefix= api.wgtRootDir;
        }
        var jsLink=prefix+"/script/"+link;
        var scriptNode=document.createElement("script");
        scriptNode.onload=function(){
            call();
        };
        scriptNode.src=jsLink;
        bd.append($(scriptNode));
    };

    /*
     * d>复制官方提供的$api对象的一些方法
     * */

    /*
     * 检测设备
     * */
    app.isAndrod = (/android/gi).test(navigator.appVersion);
    app.isIos = !app.isAndrod;
    app.isHuawei=(/HUAWEI/gi).test(navigator.userAgent);//华为手机真不错,每天一个新BUG,要问为啥这么多,你问我又问哪个
    //获取版本设备
    app.getVer= function(){
        var n=Number(api.systemVersion.replace(".")[0]);
        return isNaN(n)?-1:n;
    };
    /*
     * 检测窗口类型
     * */
    app.isWin = function(){return !api.frameName};
    app.isFrame = function(){return !!api.frameName};
    /*
     * 本地存储操作 #app中的storage对象操作规则位于log/storage.js内
     * */
    /*初始化stg对象*/
    app.uzStorage = function () {
        var ls = window.localStorage;
        if (this.isAndrod) {
            ls = os.localStorage();
        }
        return ls;
    };
    /*设置storage*/
    /*ps:官方这里留了个坑，仅能保存string和Object，这里手动添加了布尔值和数字的判断*/
    app.setStorage = function (key, value) {
        if (arguments.length === 2) {
            var v = value;
            if (typeof v == 'object') {
                v = JSON.stringify(v);
                v = 'obj-' + v;
            }
            else if(typeof v== 'number'&&!isNaN(v)){
                v = 'num-' + v;
            }
            else if(typeof v== 'boolean'){
                v = 'bol-' + v;
            }
            else {
                v = 'str-' + v;
            }
            var ls = this.uzStorage();
            if (ls) {
                ls.setItem(key, v);
            }
        }
        return this;
    };
    /*获取storage*/
    app.getStorage = function (key) {
        var ls = this.uzStorage();
        if (ls) {
            var v = ls.getItem(key);
            if (!v) { 
                return;
            }
            if (v.indexOf('obj-') === 0) {
                v = v.slice(4);
                return JSON.parse(v);
            }
            else if(v.indexOf('num-') === 0){
                v = v.slice(4);
                return Number(v);
            }
            else if(v.indexOf('bol-') === 0){
                v = v.slice(4);
                return v==="true";
            }
            else if (v.indexOf('str-') === 0) {
                return v.slice(4);
            }
        }
        return this;
    };
    /*移除storage*/
    app.removeStorage = function (key) {
        var ls = this.uzStorage();
        if (ls && key) {
            ls.removeItem(key);
        }
        return this;
    };
    /*清除所有storage*/
    app.clearStorage = function () {
        var ls = this.uzStorage();
        if (ls) {
            ls.clear();
        }
        return this;
    };

    /*
     * 状态栏适配
     * */
    /*沉浸状态栏适配 ios*/
    app.fixIos7Bar = function (el) {
        if (typeof el === "string") {
            el = document.getElementById(el);
        }
        var strDM = api.systemType;
        if (strDM == 'ios') {
            var strSV = api.systemVersion;
            var numSV = parseInt(strSV, 10);
            var fullScreen = api.fullScreen;
            var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
            if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
                el.style.paddingTop = '20px';
            }
        }
        return this;
    };
    /*沉浸状态栏适配 ios/android */
    app.fixStatusBar = function (el) {
        if (typeof el === "string") {
            el = document.getElementById(el);
        }
        var sysType = api.systemType;
        if (sysType == 'ios') {
            app.fixIos7Bar(el);
        } else if (sysType == 'android') {
            var ver = api.systemVersion;
            ver = parseFloat(ver);
            if (ver >= 4.4) {
                el.style.paddingTop = '25px';
            }
        }
        return this;
    };
    /*获取沉浸栏高度*/
    app.getStatusBarHeight = function () {
        var sysType = api.systemType;
        if (sysType == 'ios') {
            var strSV = api.systemVersion;
            var numSV = parseInt(strSV, 10);
            var fullScreen = api.fullScreen;
            var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
            if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
                return 20;
            }
        } else if (sysType == 'android') {
            var ver = api.systemVersion;
            ver = parseFloat(ver);
            if (ver >= 4.4) {
                return 25;
            }
        }
        return 0
    };

    /*
    * e>二次封装api功能,模块功能
    * */

    /*
     * 调用展开底部弹出按钮
     * param:param:title：弹出的标题
     *             list：列表对象{文字描述：点击后执行函数}
     *             cancelTitle：取消按钮的文字
     * */
    app.showActionSheet = function (param) {
        var callBox = [null];
        var opt = {
            cancelTitle: "取消",
            style: {}
        };
        if (param.title) {
            opt["title"] = String(param.title);
        }
        if (app.isObj(param.list)) {
            opt.buttons = [];
            for (var i in param.list) {
                opt.buttons.push(i);
                callBox.push(param.list[i]);
            }
        }
        api.actionSheet(opt, function (r, e) {
            if (r) {
                var index = r.buttonIndex;
                if (index === callBox.length) {
                    //取消操作
                }
                else {
                    callBox[index]();
                }
            }

        });
    };
    /*
     * 调用复制功能(首先，你需要添加clipBoard模块)
     * param:text:复制的文字
     *       call:复制回调 arguments>state:true/false
     *                               msg:复制成功/复制失败
     *       showState:是否提醒
     * */
    app.copyText = function (text, call, showState) {
        if (text) {
            if (!app.copyText.module) {
                app.copyText.module = api.require("clipBoard");
            }
            var cb = app.copyText.module;
            cb.set({value: String(text)}, function (r, e) {
                if (r.status) {
                    showState && app.toast("复制成功！");
                    typeof call === "function" && call(true, "复制成功");
                }
                else {
                    showState && app.toast("复制失败！");
                    typeof call === "function" && call(false, "复制失败");
                }
            });
        }
    };
    /* 
     * 调用下载单个文件功能
     * param:url:文件地址
     *       call:下载成功回调 arguments:state:true/false
     *                                  data:成功保存的地址/失败原因
     *       showHint:是否显示成功或提示
     * */
    app.download = function (url, call, showHint) {
        if (url) {
            api.download({
                url: url,
                report: false,
                allowResume: true
            }, function (r, e) {
                if (r && r.state == 1) {
                    var savePath = r["savePath"];
                    showHint && app.toast("下载图片成功,图片保存在" + savePath);
                    call && typeof call === "function" && call(true, savePath);
                } else {
                    showHint && app.toast("下载失败");
                    call && typeof call === "function" && call(false, e["msg"]);
                }
            });
        }
    };
    /*
     * 调用下载多文件到相册功能
     * param:ary:文件地址数组(字符串)
     *       call:下载并保存完成回调 >arguments:state:true/false
     *                                         success:成功数量
     *                                         defeat:失败数量
     *                                         data:"您的相册中"/失败提示
     * ps:只要没有全部失败都会判断为成功
     *  */
    app.downloadAry = function (ary, call) {
        var len = ary.length;
        if (len) {
            var sc = 0, df = 0, c = 0, ps = [];
            app._for(ary, function (i) {
                app.download(String(ary[i]), function (state, msg) {
                    c++;
                    if (state) {
                        sc++;
                        ps.push(msg);
                    }
                    else {
                        df++;
                    }
                    if (len === c) {
                        app.saveToPA(ps, call);
                    }
                });
            }, true);
        }
        else {
            call(false, 0, 0, "没有要下载的图片");
        }
    };
    /*
     * 调用保存到相册功能
     * param:ary:文件数组 
     *       call:保存完成回调 >arguments:state:true/false
     *                                         success:成功数量
     *                                         defeat:失败数量
     *                                         data:"您的相册中"/失败提示
     * */
    app.saveToPA = function (ary, call) {
        var times = 0, sc = 0, de = 0;
        var fn = function () {
            if (times < ary.length) {
                if (typeof ary[times] === "string") {
                    api.saveMediaToAlbum({
                        path: ary[times]
                    }, function (r, e) {
                        if (r.status) {
                            sc++;
                        }
                        else {
                            de++;
                        }
                        fn();
                    });
                }
                else {
                    de++;
                    fn();
                }
                times++;
            }
            else if (times === ary.length) {
                call && typeof call === "function" && call(sc !== 0, sc, de, sc !== 0 ? "您的相册中 " : "保存失败");
            }
        };
        fn();
    };
//批量压缩图片
//图片数组，压缩程度1-10 回调
//返回值 state：成功/失败 ary成功压缩后的数组
// app.compactPic=function(urlAry,size,call){
//     var cpMd=app.compactPic._compactPictureMd;
//     if(!cpMd){
//         cpMd=app.compactPic._compactPictureMd=api.require("compactPicture");
//     }
//     if(app.isArray(urlAry)){
//         cpMd.HittingPic({
//             picpatharray:urlAry,
//             size:size||4
//         },function(ret){
//             call(!!ret.states,ret.states);
//         });
//     }
// }
    /*
     * 缓存图片
     * param:img:图片或图片数组
     * */
    app.imgCache = function (img) {
        if (typeof img === "string") {
            api.imageCache({
                url: img
            });
        }
        else if (app.isArray(img)) {
            app._for(img, function (i) {
                api.imageCache({
                    url: String(img[i])
                });
            });
        }
        return this;
    };
    /*
     * 获取本地图片
     * param:opt 参数 attr>type:"调用方式（library,camera)"
     *                     size:[]压缩大小
     *                     edit:是否可以裁剪（大部分机型无效，无视此参数）
     *       call:选择后回调 arguments>data:查API去 忘了
     * */
    app.getPic = function (opt, call) {
        var option = $.extend({
            type: "library",
            size: [],
            edit: false
        }, opt);
        var callBack = function (r, e) {
            if (e) {
                // app.toast(app.toStr(e));
            }
            else {
                if (r.data !== "") {
                    call(r.data);
                }
            }
        };
        var param = {
            sourceType: option.type,
            mediaValue: "pic",
            destinationType: "url",
            allowEdit: !!option.edit,
            quality: 100,
            saveToPhotoAlbum: false
        };
        if (app.dataType(option.size[0]) === "Number") {
            param.targetWidth = option.size[0];
        }
        if (app.dataType(option.size[1]) === "Number") {
            param.targetHeight = option.size[1];
        }
        api.getPicture(param, callBack);
    };
    /*
    * 调用多种分享功能
    * md:wx,qq,sina
    * */
    app.shareSomething=function(opt,type){
        var option={
            title:"",
            text:"",
            url:"",
            img:"",
            qqImg:""//QQ这逗逼必须分享网络图片
        };
        if(app.isObj(opt)){
            $.extend(true,option,opt);
        }
        else {
            throw Error("分享参数错误");
        }
        var wxMd,qqMd,sinaMd;//md
        var shareList={
            list:{
                "微信好友":function(){
                    if(!wxMd){
                        wxMd=api.require("wx");
                    }
                    //检测是否装有微信
                    wxMd.isInstalled(function(r,e){
                        if(r.installed){
                            wxMd.shareWebpage({
                                scene:"session",
                                title:option.title,
                                description:option.text,
                                thumb: option.img,
                                contentUrl:option.url
                            },function(r,e){
                                if(r.status){
                                    app.toast("分享成功");
                                }
                                else{
                                    app.toast("分享失败")
                                }
                            });
                        }
                        else {
                            app.toast('当前设备未安装微信客户端');
                        }
                    });
                },
                "朋友圈":function(){
                    if(!wxMd){
                        wxMd=api.require("wx");
                    }
                    //检测是否装有微信
                    wxMd.isInstalled(function(r,e){
                        if(r.installed){
                            wxMd.shareWebpage({
                                scene:"timeline",
                                title:option.title,
                                description:option.text,
                                thumb: option.img,
                                contentUrl:option.url
                            },function(r,e){
                                if(r.status){
                                    app.toast("分享成功");
                                }
                                else{
                                    app.toast("分享失败")
                                }
                            });
                        }
                        else {
                            app.toast('当前设备未安装微信客户端');
                        }
                    });
                },
                "新浪微博":function(){
                    if(!sinaMd){
                        sinaMd=api.require("weibo");
                    }
                    sinaMd.shareWebPage({
                        title:option.title,
                        text:option.text,
                        thumb:option.img,
                        contentUrl:option.url
                    },function(r,e){
                        if(r.status){
                            app.toast("分享成功");
                        }
                        else{
                            app.toast("分享失败")
                        }
                    });
                },
                "QQ":function(){
                    if(!qqMd){
                        qqMd=api.require("qq");
                    }
                    qqMd.installed(function(ret,err){
                        if(ret.status){
                            qqMd.shareNews({
                                url:option.url,
                                title:option.title,
                                description:option.text,
                                imgUrl:option.qqImg,
                                type:"QFriend"
                            },function(){
                                //android不支持回调
                            });
                        }else{
                            app.toast('当前设备未安装QQ');
                        }
                    });
                },
                "复制链接":function(){
                    app.copyText(option.url,function(state){
                        if(state){
                            app.toast("复制成功，已复制链接到剪贴板");
                        }
                    },false);
                }
            }
        };
        if(!type||type==="all"){
            app.showActionSheet(shareList);
        }
        else if(shareList["list"][type]){
            app.showActionSheet({
                list:shareList["list"][type]
            });
        }
    };


    /*
     ui控件封装
     */
    /*
     * alert弹窗
     * param(1):option:原来api.alert方法传入的参数
     * param(2):msg:提示文字
     *          call:确认后回调
     * */
    app.alert = function () {
        var opt = {
            title: "提示",
            msg: "",
            buttons: ["确定"]
        };
        var call;
        if (typeof arguments[0] === "object") {
            opt = $.extend(true, opt, arguments[0]);
        }
        else if (arguments.length === 1) {
            opt.msg = String(arguments[0]);
        }
        else if (arguments.length === 2) {
            if (typeof arguments[1] === "function") {
                opt.msg = String(arguments[0]);
                call = arguments[1];
                api.alert(opt, call);
                return this;
            }
            else {
                opt.title = String(arguments[0]);
                opt.msg = String(arguments[0]);
            }
        }
        api.alert(opt);
        return this;
    };
    /* confirm弹窗
     * param(1):option:原来api.alert方法传入的参数
     * param(2):msg:提示文字
     *          call:确认后回调
     * */
    app.confirm = function () {
        var opt = {
            title: "提示",
            msg: "",
            buttons: ["取消", "确定"]
        };
        var call;
        call = arguments[1];
        if (typeof arguments[0] === "object") {
            opt = $.extend(true, opt, arguments[0]);
            api.confirm(opt,function (index) {
                if (index.buttonIndex === 2) {
                    call();
                }
            });
        }
        else if (typeof arguments[0]==="string") {
            opt.msg = String(arguments[0]);
            api.confirm(opt, function (index) {
                if (index.buttonIndex === 2) {
                    call();
                }
            });
        }
        return this;
    };
    /*
     * toast弹窗
     * param:content:提示文字
     *       time:时间
     *       isGb:是否所有页面可见
     * */
    app.toast = function (content, time, isGb) {
        api.toast({
            msg: String(content),
            location: "middle",
            duration: time ? time * 1000 : 3000,
            global: !!isGb
        });
        return this;
    };
    /*
     * 打开模态框
     * param:显示的文字或配置对象
     * */
    app._hasDialog = false;
    app.openDialog = function () {
        var opt = {
            style: 'default',
            animationType: 'fade',
            title: '加载中',
            text: '请稍候',
            modal: false
        };
        //传入字符串
        if (typeof arguments[0] === "string") {
            opt.title = arguments[0];
        }
        //传入对象
        else if (app.isObj(arguments[0])) {
            opt = $.extend(true, opt, arguments[0])
        }
        app._hasDialog = true;
        api.showProgress(opt);
        return this
    };
    /*
     * 关闭模态框
     * */
    app.closeDialog = function () {
        app._hasDialog = false;
        api.hideProgress();
        return this
    };
    /*
     * 打开加载中(目前默认调用系统模态框，后面可改进此方法来更换ajax遮罩)
     * module:UILoading
     * param:显示文字(目前并不支持)
     * */
    app.loadingMd = null;
    app.loadingIds = [];
    app.loading = function (text) {
        if (!app.loadingMd) {
            app.loadingMd = api.require('UILoading')
        }
        var opt = {
            center: {
                x: api.winWidth / 2,
                y: api.winHeight / 2
            },
            size: 30,
            fixed: true
        };
        this.cover("transparent", "loadingCover");
        this.loadingMd.flower(opt, function (id) {
            app.loadingIds.push(id);
        });
        return this;
    };
    /*
     * 关闭加载中
     * */
    app.closeLoading = function () {
        if (!app.loadingMd) {
            app.loadingMd = api.require("UILoading")
        }
        for (var i = 0; i < app.loadingIds.length; i++) {
            app.loadingMd.closeFlower(app.loadingIds[i]);
        }
        app.loadingIds = [];
        app.closeCover("loadingCover");
        return this;
    };
    /*
     * cover div遮罩层
     * param:type:遮罩类型
     *       id:自定义id(可选)
     * */
    app.cover = function (type, id) {
        var bd = $("body");
        var cache = "appCoverLoading";
        if (typeof id === "string") {
            if ($("#" + cache).length) {
                return this;
            }
            cache = id;
        }
        else {
            if ($("#appCoverLoading").length) {
                return this;
            }
        }
        var opt = {
            'transparent': '<div id="' + cache + '" class="cover_loading cover_transparent"></div>',
            'gray': '<div id="' + cache + '" class="cover_loading cover_gray"></div>',
            'white': '<div id="' + cache + '" class="cover_loading cover_white"></div>'
        };
        type && opt[type] ? bd.append(opt[type]) : bd.append(opt["transparent"]);
        return this;
    };
    /*
     * close 关闭遮罩
     * param:id:指定id(不传表示关闭默认打开的cover)
     * */
    app.closeCover = function (id) {
        if (!id) {
            $("#appCoverLoading").remove();
        }
        else {
            $("#" + id + ".cover_loading").remove();
        }
        return this;
    };

    /*
     * msg toast 用户消息提示
     * ps:div..
     * */
    app.toastUserMsg = function (text, fn) {
        if (typeof text !== "string") {
            throw Error("参数错误");
        }
        var html = '<div id="userMsgToast" class="user_msg_toast" onclick="app._clickUserMsgToastModal(event,this)" tapmode>' + text + '<b>查看>></b></div>';
        var userMsgToastModal = $("#userMsgToast");
        if (userMsgToastModal.length) {
            clearTimeout(app._toastUserMsgTimes);
            app._toastUserMsgTimes = null;
            userMsgToastModal.remove();
        }
        $("body").append(html);
        app._toastUserMsgTimes = setTimeout(function () {
            $("#userMsgToast").remove();
        }, 4000);
        app._clickUserMsgToastModal = typeof fn === "function" ? fn : function () {};
        return this;
    };
    /*
     * 通过浏览器打开url
     * param:url:需要打开的url字符串
     * */
    app.openBrowser = function (url) {
        if (this.isIos) {
            api.openApp({
                iosUrl: url
            });
        }
        else if (this.isAndrod) {
            api.openApp({
                androidPkg: 'android.intent.action.VIEW',
                mimeType: 'text/html',
                uri: url
            }, function (ret, err) {
                if (err.msg) {
                    //据说某些华为去掉这两个参数就可以调起外部应用了
                    api.openApp({
                        uri: url
                    }, function (ret, err) {
                        if (err.msg) {
                            app.toast(err.msg);
                        }
                    });
                }
            });
            return false;
        }
    };
    /*
     * 打开内置浏览器url
     * page:browser
     * param:url:需要打开的url字符串
     * */
    app.openOwnBrowser = function (url) {
        if (typeof url === "string") {
            app.goWin("browser", {pageParam: {url: url}});
        }
        else {
            throw Error("url参数错误")
        }
        return this;
    };
    /*
     * 打开浏览器插件url
     * module:webBrowser
     * param:url:需要打开的url字符串
     * */
    app.openFixBrowser = function (url) {
        if (typeof url === "string") {
            var wbMd = api.require("webBrowser");
            wbMd.open({
                url: url,
                titleBar: {
                    bg: "#fff",
                    textColor: "#333"
                }
            });
        }
        else {
            throw Error("url参数错误")
        }
        return this;
    };



    /*
     * f>独立页面功能封装
     * */
    app.agency = {};//代理存储跨页面调用函数

    /*
     * 弹出frame白色遮罩(只能弹出一次)
     * page:white
     * */
    app.openFrameCover = function () {
        app.goFrame("white", {
            bgColor: "#fff",
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            animation: {
                type: "none"
            },
            reload: true
        });
        api.bringFrameToFront({
            from: "white"
        });
    };
    /*
     * 关闭frame白色遮罩
     * page:white
     * */
    app.closeFrameCover = function () {
        app.fire({
            event: "close",
            win: api.winName,
            frame: "white",
            param: {}
        });
    };
    /*
     * 使用新页面实现select(common/select.html来获取)
     * agency:_selectSomething
     * page:select
     * param:option 配置参数 property>title:标题栏显示文字
     *                               more:能否多选
     *                               list:列表数据 exp：["选项A","选项B","选项C"]
     *       call 选择后回调函数 arguments>ary:选项下标
     * */
    app.goSelect = function (option, call) {
        var opt = {};
        if (this.isObj(option) && this.isArray(option.list)) {
            opt = option
        }
        else {
            app.exportError("参数错误");
        }
        var param = {
            title: opt.title || "",//选择标题
            more: !!opt.more,//是否多选
            list: opt.list,//选择列表
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._selectSomething"
        };
        this.agency._selectSomething = function (json) {
            call && call(json);
            delete app.agency._selectSomething;
        };
        app.goWin("select", {
            pageParam: param
        });
    };
    /*
     * 调用多级联动选择器(最多二到三级)
     * module:UIActionSelector
     * param:title:标题 data:数据(按模块规则传入的data) call:处理回调(返回selectedInfo字段中的值)
     * */
    app.openSelect = function (title, data, call) {
        /*初始化选择器*/
        var uasMd = api.require("UIActionSelector");
        var param = {
            datas: data,
            layout: {
                row: 5,                            //（可选项）数字类型；每屏显示的数据行数，超出的数据可以滑动查看，只能是奇数；默认：5
                col: 3,                            //（可选项）数字类型；数据源的数据级数，最多3级；默认：3
                height: 30,                        //（可选项）数字类型；每行选项的高度；默认：30
                size: 14,                          //（可选项）数字类型；普通选项的字体大小；默认：12
                sizeActive: 14,                    //（可选项）数字类型；当前选项的字体大小；默认：同 size
                rowSpacing: 5,                     //（可选项）数字类型；行与行之间的距离；默认：5
                colSpacing: 10,                    //（可选项）数字类型；列与列之间的距离；默认：10
                maskBg: 'rgba(0,0,0,0.1)',         //（可选项）字符串类型；遮罩层背景，点击该区域隐藏选择器，支持 rgb，rgba，#，img；默认：rgba(0,0,0,0.2)
                bg: '#fff',                        //（可选项）字符串类型；选择器有效区域背景，支持 rgb，rgba，#，img；默认：#fff
                color: '#999',                     //（可选项）字符串类型；选项的文字颜色，支持 rgb，rgba，#；默认：#848484
                colorSelected: '#666'              //（可选项）字符串类型；已选项的文字颜色，支持 rgb，rgba，#；默认：同 colorActive
            },
            cancel: {
                text: '取消',                      //（可选项）字符串类型；取消按钮的显示文字；默认：未设置时只显示背景
                size: 12,                          //（可选项）数字类型；取消按钮的显示文字大小；默认：12
                w: 90,                             //（可选项）数字类型；取消按钮的宽；默认：90
                h: 35,                             //（可选项）数字类型；取消按钮的高；默认：35
                bg: '#fff',                        //（可选项）字符串类型；取消按钮的背景，支持 rgb，rgba，#，img；默认：'#fff'
                bgActive: '#ccc',                  //（可选项）字符串类型；取消按钮的背景高亮，支持 rgb，rgba，#，img；默认：同 bg
                color: '#888',                     //（可选项）字符串类型；取消按钮的文字颜色，支持 rgb，rgba，#；默认：'#848484'
                colorActive: '#fff'                //（可选项）字符串类型；取消按钮的文字颜色高亮，支持 rgb，rgba，#；默认：同 color
            },
            ok: {
                text: '确定',                      //（可选项）字符串类型；确定按钮的显示文字；默认：未设置时只显示背景
                size: 12,                          //（可选项）数字类型；确定按钮的显示文字大小；默认：12
                w: 90,                             //（可选项）数字类型；确定按钮的宽；默认：90
                h: 35,                             //（可选项）数字类型；确定按钮的高；默认：35
                bg: '#fff',                        //（可选项）字符串类型；确定按钮的背景，支持 rgb，rgba，#，img；默认：'#fff'
                bgActive: '#ccc',                  //（可选项）字符串类型；确定按钮的背景高亮，支持 rgb，rgba，#，img；默认：同 bg
                color: '#888',                     //（可选项）字符串类型；确定按钮的文字颜色，支持 rgb，rgba，#；默认：'#848484'
                colorActive: '#fff'                //（可选项）字符串类型；确定按钮的文字颜色高亮，支持 rgb，rgba，#；默认：同 color
            },
            title:{                                      //（可选项）JSON 对象类型；选择器顶部标题栏设置
                text: title,                    //（可选项）字符串类型；选择器的标题内容；默认：请选择
                size: 12,                          //（可选项）数字类型；标题内容的文字大小；默认：12
                h: 44,                             //（可选项）数字类型；标题栏的高；默认：44
                bg: '#eee',                        //（可选项）字符串类型；标题栏的背景，支持 rgb，rgba，#，img；默认：'#eee'
                color: '#888'                      //（可选项）字符串类型；标题内容的文字颜色，支持 rgb，rgba，#；默认：'#848484'
            }
        };
        !!api.frameName && (param.fixedOn = api.frameName);
        uasMd.open(param, function (r) {
            if (r["eventType"] && r["eventType"] === "ok") {
                call(r["selectedInfo"]);
            }
            else if (r["eventType"] && r["eventType"] === "cancel") {
                uasMd.close();
            }
        });
    };
//选择地址(在common/area.html中)
// app.areaChoose = function (call) {
//     var param = {
//         title: "选择地区",
//         backFrame: api.frameName,
//         backWin: api.winName,
//         call: "app._chooseArea"
//     };
//     this._chooseArea = function (json) {
//         call&&call(json);
//         delete app._chooseArea;
//     };
//     app.goWin("area",{
//         pageParam: param,
//         animation:{
//             type:"push",
//             subType:"from_right",
//             curve:"ease_out"
//         }
//     });
// };
    /*
     * 选择地址
     * module:UIActionSelector
     * page:area.js
     * param:call 选择回调 attr>province:省
     *                          province_id 省id
     *                          city 城市
     *                          city_id 城市id
     *                          area 地区(可能没有)
     *                          area_id 地区id(可能没有)
     * */
    app.areaChoose = function (call) {
        var callBack = function (r) {
            var data = r;
            var pp = ["province", "city", "area"];
            var backData = {}, temp = null;
            for (var i = 0; i < 3; i++) {
                temp = data[i] || {id: data[i - 1].id, name: ""};
                if (!!r[i]) {
                    backData[pp[i]] = temp.name;
                    backData[pp[i] + "_id"] = temp.id;
                }
                else {
                    backData[pp[i]] = "";
                    backData[pp[i] + "_id"] = backData[pp[i - 1] + "_id"]
                }
            }
            call(backData);
        };
        if (!app.areaChoose._areaData) {
            app.loadJs("area.js",function(){
                var data=window.nc_a;
                //拼装地址数据为模块所需json格式
                var cb = function (ncaId) {
                    var nca = [];
                    var ncaAry = data[parseInt(ncaId)];
                    if (app.isArray(ncaAry) && ncaAry.length) {
                        var temp = null, nextTemp = null;
                        for (var i = 0; i < ncaAry.length; i++) {
                            temp = {};
                            nextTemp = null;
                            temp["id"] = ncaAry[i][0];
                            temp["name"] = ncaAry[i][1];
                            nextTemp = cb(ncaAry[i][0]);
                            if (nextTemp.length) {
                                temp.sub = ([]).concat(nextTemp);
                            }
                            nca.push(temp);
                        }
                        return nca
                    }
                    else {
                        return [];
                    }
                };
                app.areaChoose._areaData = cb(0);
                app.copyText(app.toStr({data:app.areaChoose._areaData}));
                app.openSelect("选择地址", app.areaChoose._areaData, callBack);
            });

            //原来代码
            // var execParam = {name: api.winName};
            // !!api.frameName && (execParam.frameName = api.frameName);
            // //读取area.js的地址信息并重装对象
            // api.readFile({sync: false, path: api.wgtRootDir + "/script/area"}, function (r) {
            //     if (r.status) {
            //         execParam.script = r.data + ";window.ncaCallback(window.nc_a)";
            //         window.ncaCallback = function (data) {
            //             //拼装地址数据为模块所需json格式
            //             var cb = function (ncaId) {
            //                 var nca = [];
            //                 var ncaAry = data[parseInt(ncaId)];
            //                 if (app.isArray(ncaAry) && ncaAry.length) {
            //                     var temp = null, nextTemp = null;
            //                     for (var i = 0; i < ncaAry.length; i++) {
            //                         temp = {};
            //                         nextTemp = null;
            //                         temp["id"] = ncaAry[i][0];
            //                         temp["name"] = ncaAry[i][1];
            //                         nextTemp = cb(ncaAry[i][0]);
            //                         if (nextTemp.length) {
            //                             temp.sub = ([]).concat(nextTemp);
            //                         }
            //                         nca.push(temp);
            //                     }
            //                     return nca
            //                 }
            //                 else {
            //                     return [];
            //                 }
            //             };
            //             app.areaChoose._areaData = cb(0);
            //             app.openSelect("选择地址", app.areaChoose._areaData, callBack);
            //         };
            //         api.execScript(execParam);
            //     }
            // });
        }
        else {
            app.openSelect("选择地址", app.areaChoose._areaData, callBack);
        }
    };
    /*
     * 调用搜索功能(search/search.html)
     * page:search
     * param:page:搜索类型
     *       param:给search页的参数(key和placeholder) attr>key:默认关键字
     *                                                    placeholder:你懂得
     *       pageParam:给搜索列表页的参数(根据不同页面自定义)
     * */
    app.goSearch = function (page, param, pageParam) {
        if (page === undefined) {
            app.exportError("缺少page参数");
        }
        var p = {
            key: "",
            placeholder: "请输入搜索内容"
        };
        var pageP = {
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app._searchSomething"
        };
        var callBack = pageParam.call;
        this._searchSomething = function (o) {
            typeof callBack === "function" && callBack.apply(this, arguments);
            delete app._searchSomething;
        };
        if (app.isObj(param)) {
            $.extend(true, p, param);
        }
        if (app.isObj(param)) {
            $.extend(true, pageParam, pageP);
        }
        this.goWin("search", {
            pageParam: {
                page: String(page),
                key: p.key,
                placeholder: p.placeholder,
                focus: p.focus,
                pageParam: pageParam
            },
            animation: {
                type: "push",
                subType: "from_right",
                curve: "ease_out"
            }
        });
        return this;
    };
    /*
     * 选择月份
     * agency:_selectMonth
     * page:month
     * param:param:参数 attr>type:"right"目前仅支持右侧打开
     *                       start:1999.8 起始月份
     *                       end 1999.9 结束月份
     *                       title:头部文字
     *       call:选择回调 arguments>date: data:年-月格式字符串 或null exp:2005-9
     * */
    app.openMonthSelect = function (param, call) {
        //配置参数
        var p = {
            title: "月份选择",
            start: "1970.1",
            end: new Date().getFullYear() + "." + (new Date().getMonth() + 1)
        };
        if (app.isObj(param)) {
            $.extend(true, p, param);
        }
        var params = {
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._selectMonth"
        };
        $.extend(true, p, params);
        this.agency._selectMonth = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._selectMonth;
        };
        this.goFrame("month", {
            pageParam: p,
            bounces: false,
            bgColor: "rgba(0,0,0,0)",
            reload: true,
            rect: {
                x: 0,
                y: p.top || 0,
                w: api.winWidth,
                h: api.winHeight - (p.top || 0)
            },
            animation: {
                type: "fade",
                curve: "ease_out",
                duration: 100
            }
        });
        return this;
    };
    /*
     * 在当前页中切换站点
     * agency:_chooseCountry
     * page:countryAlertList
     * param:param:打开frame参数 call
     *       call:回调 arguments> index:一个索引值
     * ps:具体传参和功能没有封装在内，为主页封装的方法
     * */
    app.openChooseCountry = function (param, call) {
        var params = {
            pageParam: {},
            bounces: false,
            bgColor: "rgba(0,0,0,0)",
            reload: true,
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            animation: {
                type: "none",
            }
        };
        if (app.isObj(param)) {
            $.extend(true, params, param);
        }
        $.extend(true, params.pageParam, {
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._chooseCountry"
        });
        this.agency._chooseCountry = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._chooseCountry;
        };
        this.goFrame("countryAlertList", params);
        return this;
    };
    /*
     * 在当前页中切换分类
     * agency:_chooseCategory
     * page:categoryAlertList
     * param:param:打开frame参数 call
     *       call:回调 arguments> index:一个索引值
     * ps:具体传参和功能没有封装在内,为求购主页封装的方法
     * */
    app.openChooseCategory = function (param, call) {
        var params = {
            pageParam: {},
            bounces: false,
            bgColor: "rgba(0,0,0,0)",
            reload: true,
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            animation: {
                type: "none"
            }
        };
        if (app.isObj(param)) {
            $.extend(true, params, param);
        }
        $.extend(true, params.pageParam, {
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._chooseCategory"
        });
        this.agency._chooseCategory = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._chooseCategory;
        };
        this.goFrame("categoryAlertList", params);
        return this;
    };
    /*
     * 打开图片浏览器
     * page:picture
     * module:photoBrowser
     * param:param:配置参数 attr>ary:图片字符串数组
     *                          index：默认显示第几张
     *                          call：回调（暂无）}
     * */
    app.openPicView = function (param) {
        var dfP = {
            ary: [],
            index: 0,
            call: null
        };
        $.extend(true, dfP, param);
        if (!app.isArray(dfP.ary)) {
            return false
        }
        app.goWin("picture", {
            animation: {
                type: "fade",
                duration: 180,
                curve: "ease_out"
            },
            bgColor: "#000",
            pageParam: dfP
        });
        return this;
    };
    /*
     * 打开留言弹窗
     * attr:_leaveMsgText
     * param:opt:参数 attr >value:初始填充的内容
     *                      placeholder:你懂得
     *                      max:最大文字数量
     *                      ext:额外的附加参数，会在回调中传回
     *                      callback:你懂得 arguments>data:text:填写的文字
     *                                                     ext:传回的值
     * */
    app.openLeaveMsg=function(param,call){
        var params={
            pageParam: {},
            bounces: false,
            bgColor: "rgba(0,0,0,0)",
            reload: true,
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            animation: {
                type: "none"
            }
        };
        var pageParam={
            value:param.value||"",
            placeholder:param.placeholder||"",
            max:param.max||100,
            ext:app.isObj(param.ext)?param.ext:{},
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._leaveMsgText"
        };
        if (app.isObj(param)) {
            $.extend(true, params, param);
        }
        $.extend(true, params.pageParam,pageParam);
        this.agency._leaveMsgText = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._leaveMsgText;
        };
        this.goFrame("leaveMsg", params);
        return this;
    };
    /*
     * 打开报价弹窗
     * attr:_leaveNumberText
     * param:opt:参数 attr>num:初始填充的内容
     *                     placeholder:你懂得
     *                     min:最低数字（默认无）
     *                     max:最高数字（默认无）
     *                     callBack:你懂得 arguments>data:num:填写的数字
     *
     * */
    app.openLeaveNumber=function(param,call){
        var params={
            pageParam: {},
            bounces: false,
            bgColor: "rgba(0,0,0,0)",
            reload: true,
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            animation: {
                type: "none"
            }
        };
        var pageParam={
            num:param.value||"",
            placeholder:param.placeholder||"",
            min:param.min!==undefined?Number(param.min):null,
            max:param.max!==undefined?Number(param.max):null,
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._leaveNumberText"
        };
        if (app.isObj(param)) {
            $.extend(true, params, param);
        }
        $.extend(true, params.pageParam,pageParam);
        this.agency._leaveNumberText = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._leaveNumberText;
        };
        this.goFrame("leaveNumber", params);
        return this;
    };



//调用身份证扫描功能(仅支持ios)
// app.openIdCardScan=function(call){
//     if(app.isIos){
//         var doFn=function(){
//             if(app.openIdCardScan._cdMd==undefined){
//                 app.openIdCardScan._cdMd=api.require('idcard');
//             }
//             app.openIdCardScan._cdMd.cardInfo(function(ret) {
//                 call(ret);
//             });
//         };
//         if(!app.getStorage("isReadScanInfo")){
//             app.setStorage("isReadScanInfo",true);
//             app.alert("使用扫描功能提示：扫描时注意光照的影响，尽量避免反光和黑影;不要使扫描角度倾斜过大，以免造成图像严重变型；",doFn);
//         }
//     }
// };
    /*
     * 进入裁剪页
     * agency:_clipImg
     * page:clip
     * module:FNImageClip
     * param:param:参数 attr>path（要裁剪的图片）
     *       call（执行的回调函数）
     * */
    app.goClip = function (param, call) {
        if (!app.isObj(param)) {
            app.exportError("缺少param参数");
        }
        // else if(app._clipImg){
        //     return false;
        // }
        var p = {
            call: "app.agency._clipImg",
            backFrame: api.frameName,
            backWin: api.winName
        };
        this.agency._clipImg = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._clipImg;
        };
        $.extend(true, p, param);
        this.goWin("clip", {
            pageParam: p,
            animation: {
                type: "push",
                subType: "from_right",
                curve: "ease_out"
            }
        });
        return this;
    };

    /*
     * 识别某个url，并做内部跳转或者外部打开
     * page:browser
     * module:webBrowser
     * param:url url字符串
     * */
    app.adaptUrl = function (url) {
        var search = url.split("?");
        if (search.length === 2) {
            var tmp = null;
            for (var i in app.adaptLink._linkRule) {
                tmp = app.adaptLink._linkRule[i](search[1]);
                if (tmp) {
                    app.adaptLink._pageRule[i](tmp);
                    return this;
                }
            }
        }
        //无参数链接或无法识别的链接直接跳转
        app.openBrowser(url);
        return this
    };

    /*
     * a标签链接跳转识别
     * attr:_pageRule:跳转规则 _linkRule:解析规则
     * param:selector:容器选择器（会激活内部所有a标签）
     */
    app.adaptLink = function (selector) {
        var wrapper = $("" + selector);
        if (!wrapper.length) {
            return false;
        }
        var aNode = wrapper.find("a");
        aNode.each(function () {
            var _t = $(this);
            var hrefLink=_t.attr("href");
            _t.data("href",hrefLink);
            _t.attr({
                "tapmode": "tapmode",
                "href":"javascript:;"
            }).removeAttr("target");
            this.onclick = function (e) {
                e.preventDefault();
                e.stopPropagation();
                var href=$(this).data("href");
                var search = href.split("?");
                if (search.length === 2) {
                    var tmp = null;
                    for (var i in app.adaptLink._linkRule) {
                        tmp = app.adaptLink._linkRule[i](search[1]);
                        if (tmp) {
                            app.adaptLink._pageRule[i](tmp);
                            return false;
                        }
                    }
                }
                //无参数链接或无法识别的链接直接跳转
                app.openBrowser(href);
                return false;
            };
        });
        api.parseTapmode();
        return this;
    };
    //解析规则
    app.adaptLink._linkRule = {
        "articleList": function (searchStr) {
            if ((/article/).test(searchStr)) {
                var acId = searchStr.match(/ac_id\=\d+/);
                if (acId && acId.length) {
                    return {articlelist_id: acId[0].replace(/\D/g, "")};
                }
            }
            return false
        },
        "article": function (searchStr) {
            if ((/(article.*show)|(show.*article)/).test(searchStr)) {
                var articleId = searchStr.match(/article_id\=\d+/);
                if (articleId && articleId.length) {
                    return {article_id: articleId[0].replace(/\D/g, "")};
                }
            }
            return false
        },
        "goods": function (searchStr) {
            if ((/goods/).test(searchStr)) {
                var goodsId = searchStr.match(/goods_id\=\d+/);
                if (goodsId && goodsId.length) {
                    return {goods_id: goodsId[0].replace(/\D/g, "")};
                }
            }
            return false
        },
        "searchGoods": function (searchStr) {
            if ((/search/).test(searchStr)) {
                var cateId = searchStr.match(/cate_id\=\d+/);
                if (cateId && cateId.length) {
                    return {gc_id: cateId[0].replace(/\D/g, "")};
                }
            }
        }
    };
    //跳转规则
    app.adaptLink._pageRule = {
        "articleList": function (p) {
            app.goPage("title", {
                title: "文章列表",
                page: "articleList",
                pageParam: p
            });
        },
        "article": function (p) {
            app.goPage("article", p);
        },
        "goods": function (p) {
            app.goPage("shoppingInfo", p);
        },
        "searchGoods": function (p) {
            app.goPage("title", {
                title: "商品列表",
                page: "shoppingList",
                pageParam: p
            });
        }
    };
    /*
     * 新消息跳转方式识别
     * page:可能跳转多个页面
     * param:id:信息id,code:类型code,param:扩展参数
     * */
    app.adaptMsg = function (id, code, param) {
        var close = null, winId = null,  pp = {}, am = {
            type:"push",
            subType:"from_right",
            duration:300
            // type: "none"
        };
        //1:跳转到普通消息详情
        if (code == 1) {
            pp.msgId = id;
            winId = "msgInfo";
        }
        //2.跳转到求购详情
        else if (code == 2 || code == 4) {
            close = true;
            // mainIndex=2;//别想多了，到时候切换的时候闪屏给你提个bug过来看你怎么改
            //指定报价留言
            if(param["is_quotation"]==1){
                winId = "title";
                pp = {
                    title: "查看报价",
                    page: "quoteList",
                    pageParam: {pId: param["goods_id"]}
                };
            }
            //针对求购信息留言
            else {
                winId = "publishInfo";
                pp = {pId: param["goods_id"]};
            }
        }
        //3.跳转到报价列表页
        else if (code == 3) {
            close = true;
            winId = "title";
            pp = {
                title: "查看报价",
                page: "quoteList",
                pageParam: {pId: param["goods_id"]}
            };
        }
        // //4.跳转到我发布的列表
        // else if(code==4){
        //     close=true;
        //     // mainIndex=4;
        //     winId="myPublish";
        //     pp={open:param["goods_state"]==1?0:2}
        // }
        //5.跳转到订单详情
        else if (code == 5) {
            close = true;
            //mainIndex=3;
            pp = {order_id: param["order_id"]};
            if (param["is_seller"]) {
                winId = "sellerOrderInfo";
            }
            else {
                winId = "orderInfo"
            }
        }
        //6.跳转到退款详情
        else if (code == 6) {
            close = true;
            //mainIndex=3
            pp = {refund_id: param['refund_id']};
            if (param["is_seller"]) {
                winId = "sellerRefund";
            }
            else {
                winId = "orderAfterInfo"
            }
        }
        else {
            pp.msgId = id;
            winId = "msgInfo";
        }
        if (close) {//非消息详情
            //访问一下本消息详情，以更改消息访问状态
            app.post({
                url: app.config.url + "/index.php?act=member_message&op=detail",
                data: {"message_id": id},
                cover: false,
                success: function (r) {
                    //更新留言条数
                    // app.updateFetch("msgNum");
                    //通知主页刷新未读消息条数
                    app.fire({
                        event: "changeTag",
                        win: "main",
                        param: {}
                    });
                    app.goWin(winId,{
                        pageParam: pp,
                        animation: am
                    });
                }
            }, true);
        }
        else {
            //打开消息详情
            app.goWin(winId, {
                pageParam: pp,
                animation: am
            });
        }
    };
    /*
     * 打开浮窗提示消息
     * attr:_isOpen:是否已打开浮窗
     * agency:_clickFloatMsgFn,_hideFloatMsgFrame
     * page:floatMsg
     * param:title消息标题 msg消息内容 data消息内容 call点击回调
     * ps:必须在win上面使用，多次消息提醒会形成队列，最快1s一条
     * ps:如果在有浮窗的时候打开新的frame，会遮盖浮窗
     * ps:先打开frame，然后再次调用时调用fire，frame关闭时调用本页面的_hideFloatMsgFrame，点击消息时调用本页面的_clickFloatMsgFn
     * ps:坑爹指数：☆☆☆☆
     * */
    app.openFloatMsg = function (title, msg, callback) {
        var pg = {
            title: title,
            content: msg,
            call: "app.agency._clickFloatMsgFn",
            hide: "app.agency._hideFloatMsgFrame"
        };
        app.agency._clickFloatMsgFn = typeof callback == "function" ? callback : function () {
        };
        if (!app.openFloatMsg._isOpen) {
            app.openFloatMsg._isOpen = true;
            if (!app.agency._hideFloatMsgFrame) {
                app.agency._hideFloatMsgFrame = function () {
                    app.openFloatMsg._isOpen = false;
                };
            }
            //未打开浮窗，打开新frame
            app.goFrame("floatMsg", {
                pageParam: pg,
                bgColor: "rgba(0,0,0,0)",
                reload: true,
                bounces: false,
                rect: {
                    x: 0,
                    y: 0,
                    w: api.winWidth,
                    h: 65
                }
            });
        }
        else {
            //已打开浮窗，直接给浮窗内部通知刷新
            app.fire({
                event: "refresh",
                win: api.winName,
                frame: "floatMsg",
                param: pg
            });
        }
        api.bringFrameToFront({
            from: "floatMsg"
        });
    };

    /*
     * 打开提示遮罩
     * param: name:遮罩类型
     *        top:透明部分距离顶部高度
     *        h:透明部分高度
     *        call:点击透明部分回调
     *        extend:其他参数
     * ps:主要是用在用户首次进入给予一个提示引导遮罩
     * ps:目前有遮罩：shipmentsHint 发货人编辑 countryHint 首页分站切换
     * ps:HTML结构已在HTML中构建好
     * */
    app.openHint = function (name, top, h, call, extend) {
        var p = {
            call: "app._hintCall",
            top: 0,
            h: 0,
            backFrame: api.frameName,
            backWin: api.winName
        };
        this._hintCall = function () {
            typeof call === "function" && call.apply(this, arguments);
            delete app._hintCall;
        };
        $.extend(true, p, {top: top, h: h});

        stg = app.getStorage("hintCache");
        //更改默认发货人提示(extend:是否强制显示（用于测试）)
        if (name === "shipmentsHint") {
            if (!stg.shipments || extend) {
                stg.shipments = true;
                app.setStorage("hintCache", stg);
                $.extend(true, p, {type: "shipments"});
                this.goFrame("coverHint", {
                    rect: {
                        t: 0,
                        l: 0,
                        w: api.winWidth,
                        h: api.winHeight
                    },
                    reload: true,
                    pageParam: p,
                    bgColor: "rgba(0,0,0,0)",
                    animation: {
                        type: "none"
                    }
                });
            }
        }
        //首页分站选择提示(extend:是否强制显示（用于测试）)
        else if (name === "countryHint") {
            if (!stg.country || extend) {
                stg.country = true;
                app.setStorage("hintCache", stg);
                $.extend(true, p, {type: "country"});
                this.goFrame("coverHint", {
                    rect: {
                        t: 0,
                        l: 0,
                        w: api.winWidth,
                        h: api.winHeight
                    },
                    reload: true,
                    pageParam: p,
                    bgColor: "rgba(0,0,0,0)",
                    animation: {
                        type: "none"
                    }
                });
            }
        }
        //个人中心卖货标签设置提示(extend:是否强制显示（用于测试）)
        else if(name==="tagHint"){
            if (!stg.tag || extend) {
                stg.tag = true;
                app.setStorage("hintCache", stg);
                $.extend(true, p, {type: "tag"});
                this.goFrame("coverHint", {
                    rect: {
                        t: 0,
                        l: 0,
                        w: api.winWidth,
                        h: api.winHeight
                    },
                    reload: true,
                    pageParam: p,
                    bgColor: "rgba(0,0,0,0)",
                    animation: {
                        type: "none"
                    }
                });
            }
        }
        return this;
    };

    /*
    * 打开引导图片弹窗
    * param:src:图片地址
    * page:tool/img_alert
    * ps:这里的src地址是基于image文件夹路径
    * */
    app.openImgAlert=function(src){
        app.goFrame("imgAlert",{
            pageParam:{img:src},
            rect:{x:0,y:0,w: api.winWidth,h: api.winHeight},
            animation:{
                type:"fade",
                duration:300
            }
        });
        return this;
    };

    /*
    * 打开额外的固定弹窗
    * param:win:窗口id param:打开窗口的参数
    * ps:所有的内容在这个窗口内自己定义，这里只是简单给一个打开frame的方法
    * */
    app.openCustomAlert=function(win,p){
        app.goFrame(win,$.extend(true,{
            rect:{x:0,y:0,w: api.winWidth,h: api.winHeight},
            animation:{
                type:"fade",
                duration:300
            }
        },app.isObj(p)?p:{}));
        api.bringFrameToFront({
            from:win
        });
        return this;
    };

    /*
    * 检测用户是否打开了通知
    *
    * ps:仅ios
    * */
    app.checkDevNot=function(){
        // app.removeStorage("lastCheckNotTime");
        // app.removeStorage("checkNotJumpVersion");
        // return false;
        if(!app.isIos){
            return false;
        }
        var appSettings = api.require('appSettings');
        if(appSettings){
            var lastCheckNotTime=app.getStorage("lastCheckNotTime");
            var checkNotJumpVersion=app.getStorage("checkNotJumpVersion");
            var now=new Date().getTime();
            var ver,time,mack=true;
            var tp=String(lastCheckNotTime).split("&");
            if(tp.length!=2){
                ver=-1;
                time=0;
            }
            else {
                ver =tp[0];
                time=parseInt(tp[1]);
            }
            if(ver!=api.appVersion){
                //非当前版本，必然检测一次
                mack=false;
            }
            else if(now-time>86400000&&!checkNotJumpVersion){
                //当前版本，但是超过一天且未跳过此版本
                mack=false;
            }
            if(!mack){
                app.setStorage("lastCheckNotTime",api.appVersion+"&"+now);
                app.setStorage("checkNotJumpVersion",false);
                appSettings&&appSettings["checkNotification"](function(ret){
                    if (!ret.status) {
                        setTimeout(function(){
                            app.openCustomAlert("checkNot");
                        },500)
                    }
                });
            }
        }
    };



})(window.app||(window.app={}));
///<jscompress sourcefile="main_frame.js" />
/*
 * 页面框架
 * *a>页面跳转，堆栈处理
 * *b>跨页面交互功能封装
 *
 * */

(function(app){
    /*
     * a>窗口、frame堆栈操作
     * ps:主要通过api.config的pathUrl来获取具体路径
     */

    /*
     * 打开新窗口（不建议使用，请使用goWin）
     * param:option打开窗口所需参数(详情查看api)
     * */
    app.openWin = function (option) {
        var opt = $.extend(true, {
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            allowEdit: true,//暂时全局打开
            slidBackEnabled: option.name.match(/(main)|(root)|(login)|(access)/g) ? false : true,//在主页面之外的页面默认都有滑动返回功能
            animation: {
                type: "none"
            }
        }, option);
        // ios 8.0及以上 使用wk内核
        // if(app.isIos&&app.getVer()>=8){
        //     opt.useWKWebView=true;
        // }
        api.openWin(opt);
        return this;
    };
    /*
     * 打开新frame（不建议使用，请使用goFrame）
     * param：option:打开frame所需参数(详情查看api)
     * */
    app.openFrame = function (option) {
        var opt = $.extend(true, {
            bounces: false,
            vScrollBarEnabled: false,
            hScrollBarEnabled: false,
            slidBackEnabled: false,
            allowEdit: true,//暂时全局打开
            // progress:{
            //     title:"加载中...",
            //     text:"加载..."
            // },
            animation: {
                type: "none"
            }
        }, option);
        /*兼容性处理，rect参数中有字符串转化为数字,否则ios下会抽风*/
        if (app.isObj(opt.rect)) {
            var ary = ["x", "y", "w", "h"], tp, end = {};
            for (var i = 0; i < 4; i++) {
                tp = Number(opt.rect[ary[i]]);
                if (!isNaN(tp)) {
                    end[ary[i]] = tp;
                }
                else {
                    end[ary[i]] = opt.rect[ary[i]];
                }
            }
            opt.rect = end;
        }
        // ios 8.0及以上 使用wk内核
        // if(app.isIos&&app.getVer()>=8){
        //     opt.useWKWebView=true;
        // }
        api.openFrame(opt);
        return this;
    };
   /*
   * 关闭窗口
   * param:option:窗口name/关闭窗口所需参数
   * */
    app.closeWin = function (option) {
        if (option === undefined) {
            option = api.winName;
        }
        if (!app.isObj(option)) {
            option = {name: String(option)};
        }
        var opt = $.extend(true, {
            name: api.winName,
            animation: {
                type: "push",
                subType:"from_left",
                duration:240
            }
        }, option);
        //百度统计模块
        if(api.pageParam&&api.pageParam._category){
            app.tjPageEnd(api.pageParam._category);
        }
        api.closeWin(opt);
        return this;
    };
    /*
    * 关闭多个窗口
    * param:winId:要关闭到的窗口id/或者整个api.closeToWin的参数
    *
    * */
    app.closeToWin=function(p){
        var backParam={
            animation: {
                type: 'none'
            }
        };
        if(typeof p==="string"){
            backParam.name=p;
        }
        else if(app.isObj(p)){
            $.extend(true,backParam,p)
        }
        else {
            return false;
        }
        //百度统计模块
        if(api.pageParam&&api.pageParam._category){
            app.tjPageEnd(api.pageParam._category);
        }
        api.closeToWin(backParam);
    };
    /*
     * 关闭frame
     * param:option: 窗口name/关闭frame所需参数
     * */
    app.closeFrame = function (option) {
        if (option === undefined) {
            option = {name: api.frameName};
        }
        else if (!app.isObj(option)) {
            option = {name: String(option)};
        }
        var opt = $.extend(true, {
            name: api.frameName,
            animation: {
                type: "none"
            }
        }, option);
        api.closeFrame(opt);
        return this;
    };
    /*
     * 隐藏frame
     * param:name:frame name
     * */
    app.hideFrame = function (name) {
        api.setFrameAttr({
            name: name,
            hidden: true
        });
        return this;
    };
    /*
     * 显示frame
     * param：name:frame name animation:动画参数(详见api)
     * */
    app.showFrame = function (name, animation) {
        api.setFrameAttr({
            name: name,
            hidden: false,
            animation: $.extend(true, {
                type: "none"
            }, app.isObj(animation) ? animation : {})
        });
        return this;
    };
    /*
     * 根据id打开新窗口,并传入openWin参数
     * param:id:窗口id(可选)
     *       type:页面名称
     *       param:窗口打开参数
     * ps:param参数除了在原有的api参数上还可以附加以下字段
     *    readyFire:传入一个对象，作为页面刚打开时执行首次fire方法的参数
     *    page:当页面为common页面时，传入page可以代理打开一个子页面
     * ps:打开新窗口时，使用此方法会产生以下影响：
     *    1.传入调用此方法页面的window和frame信息
     *    2.如果传入了id，那么这个页面会以这个值为id
     *    3.否则会为新开的win创建一个name+自增的id，并且如果新开的win是一个代理窗口如(title+frame)，会命名为winName+And+contentName的形式
     * ps:新开页面后，会产生以下影响
     *    1.记录本窗口为最顶层窗口
     *    2.打开新窗口后，会调用一次_initFire参数内的事件
     * */
    app.goWin = function (a,b,c) {
        var _id,_category,_param;
        if(arguments.length>=3){
            _id=a;
            _category=b;
            _param=c;
        }
        else if(arguments.length==2) {
            if(app.isObj(b)){
                _category=a;
                _param=b;
            }
            else if(b!==undefined){
                _id=a;
                _category=b;
            }
        }
        else {
            _category=a;
        }
        //附加上个页面的窗口信息
        var opt = {
            pageParam: {
                _lastPage: {
                    win: api.winName,
                    frame: api.frameName,
                    alone:!api.frameName,//是否是单独的win页面（如果为false，表示上个页面也是frame）
                    category: api.pageParam._category
                },
                _category:_category,
                _initFire: []
            }
        };
        if (app.isObj(_param)) {
            $.extend(true, opt, _param);
        }
        if (app.isArray(opt.readyFire)) {
            opt.pageParam._initFire = opt.readyFire;
        }
        if (app.config.pathUrl[_category]) {
            opt["name"] = _category;
            opt["url"] = app.config.pathUrl[_category];
        }
        else {
            exportError("没有找到指定页面");
        }
        //如果是共用头部，则name为共用头部类型+"And"+子页面id
        if (app.inArray(_category, app.config.commonAry)) {
            if (opt["pageParam"] && opt["pageParam"]["page"]) {
                opt["name"] = _category + "&" + opt["pageParam"]["page"];
                opt["reload"] = true;
            }
            else {
                exportError("没有找到要打开的子页面");
            }
        }
        delete opt.readyFire;
        delete opt.page;
        //如果已传入id，那么使用自定义id
        if(_id){
            opt["name"]=_id;
        }
        //否则加上随机数，以兼容重复打开功能
        else {
            var rp = app.getStorage("repeatPage");
            opt["name"]+="-"+rp++;
            app.setStorage("repeatPage",rp);
        }
        this.openWin(opt);
        return this
    };
    /*
     * 根据id打开新frame,并传入openFrame参数
     * param:id:frame id(可选)
     *       type:页面名称
     *       param:打开frame的参数
     * ps:param参数除了在原有的api参数上还可以附加以下字段
     *    readyFire:传入一个对象，作为页面刚打开时执行首次fire方法的参数
     *    page:当页面为common页面时，传入page可以代理打开一个子页面
     * ps:如果传入了id，那么会以id为名称，否则会以type为名称；
     * ps:一个win上打开多个相同frame，请自定义id
     * */
    app.goFrame = function (a,b,c) {
        var _id,_category,_param;
        if(c!==undefined){
            _id=a;
            _category=b;
            _param=c;
        }
        else {
            _category=a;
            _param=b;
        }
        //附加上个页面的窗口信息
        var opt = {
            pageParam: {
                _lastPage: {
                    win: api.winName,
                    frame: api.frameName,
                    alone:!api.frameName,//是否归属于单独的win页面（如果为false，表示上个页面也是frame）
                    category: api.pageParam._category
                },
                _fireWinMain:app._fireWinMain,
                _category:_category,
                _initFire: []
            }
        };
        if (app.isObj(_param)) {
            $.extend(true, opt, _param);
        }
        if (app.isArray(opt.readyFire)) {
            opt.pageParam._initFire = opt.readyFire;
        }
        //缓存本页面的rect信息
        if (opt.rect) {
            opt.pageParam._rect = opt.rect;
        }
        if (app.config.pathUrl[_category]) {
            opt["name"] = _category;
            opt["url"] = app.config.pathUrl[_category];
        }
        else {
            exportError("没有找到指定页面");
        }
        //如果是共用头部，则name为共用头部类型+"And"+子页面id
        if (app.inArray(_category, app.config.commonAry)) {
            if (opt["pageParam"] && opt["pageParam"]["page"]) {
                opt["name"] = _category + "&" + opt["pageParam"]["page"];
                opt["reload"] = true;
            }
            else {
                exportError("没有找到要打开的子页面,错误页面id为:"+_category);
            }
        }
        delete opt.readyFire;
        delete opt.page;
        //如果已传入id，那么使用自定义id
        if(_id){
            opt["name"]=_id;
        }
        this.openFrame(opt);
        return this
    };

    /*
     * b>go-page,go-back dom自动跳转页面方法
     */
    /*
     * 页面跳转功能
     * param:pageId:目标win name
     *       param:pageParam参数（与goWin不同的是这里只传pageParam）
     * ps:和goWin一样的处理逻辑,只是附加了页面跳转动画参数
     * */
    app.goPage = function () {
        var pa=arguments,sub=arguments.length===3?2:1,opt={
            animation: {
                type: "push",
                subType: "from_right",
                duration: 240
            }
        };
        if(app.isObj(pa[sub])){
            pa[sub]=$.extend(true,opt,{pageParam:pa[sub]});
            if(!app.isObj(pa[sub].pageParam)){
                delete pa[sub].pageParam;
            }
        }
        app.goWin.apply(app,pa);
        return this;
    };

    /*
     * 页面返回功能
     * param:event 可选的: 如果为字符串：如果本页面是由goWin或者goPage打开,那么可以在返回的同时触发一次上页面的自定义事件
     *                    如果为true：强行返回，不验证返回函数
     * */
    app._goBackFn = function () {
        return true;
    };
    app.goBack = function (event, param) {
        var canGoBack = event === true ? true : this._goBackFn();
        if (!!canGoBack) {
            //如果返回了一个数组，那么第一个被定义为返回事件名，第二个被定义为参数
            if (app.isArray(canGoBack) && canGoBack.length === 2 && app.isObj(canGoBack[1])) {
                event = String(canGoBack[0]);
                param = canGoBack[1];
            }
            //如果返回一个字符串，定义为返回事件名
            if (typeof event === "string" && api.pageParam._lastPage) {
                //如果存在_lastPage,则可以触发一次自定义事件和自定义返回回调
                var p = {
                    event: String(event),
                    win: api.pageParam._lastPage.win,
                    param: this.isObj(param) ? param : {}
                };
                if (api.pageParam._lastPage.frame) {
                    p.frame= api.pageParam._lastPage.frame;

                }
                this.fire(p);
            }
            if(api.pageParam._lastPage){
                var p2={
                    name: api.pageParam._lastPage.win,
                    script: "window.app.setBackHere._backHereCallback()"
                };
                if (api.pageParam._lastPage.frame) {
                    p2.frameName= api.pageParam._lastPage.frame;
                }
                api.execScript(p2);
            }
            if (!(app.inArray(api.winName,app.config.basePage))) {
                //除了这三个页面无法返回，其他的都默认Wie关闭窗口
                app.closeWin();
            }
        }
        return this;
    };
    /*
     * 重新配置此页面的返回功能
     * param 调用此方法后，传入的函数将在返回前一步执行，如果函数返回false，页面将不会返回
     * */
    app.resetGoBack = function (fn) {
        if (typeof fn === "function") {
            app._goBackFn = fn
        } else {
            exportError("参数错误")
        }
        return this;
    };

    /*
     * 重载页面上所有go-page、go-back、go-url事件，在html改变之后，要让新节点点击有效，必须再次执行此方法
     * param:selector容器选择器，将会在此容器中进行事件重置
     * */
    app._goPageClickFn = function () {
        window.event.stopPropagation();
        var pageData = $(this).data("param");
        if (typeof pageData === "string") {
            //替换特殊符号为空格避免解析失败
            pageData = pageData.replace(/\s/g, " ");
            try {
                pageData = app.toJson(pageData);
            } catch (e) {}
        }
        try {
            //如果存在id字段，则被用来定义为id
            if(pageData.id){
                app.goPage(pageData.id,pageData.url, pageData.param);
            }
            else {
                app.goPage(pageData.url, pageData.param);
            }
        } catch (e) {}
    };
    app._goBackClickFn = function () {
        window.event.stopPropagation();
        var pageData = $(this).data("param");
        try {
            if (app.isObj(pageData)) {
                app.goBack(pageData.event, pageData.param);
            }
            else {
                app.goBack();
            }
        } catch (e) {
        }
    };
    app._goUrlClickFn = function () {
        window.event.stopPropagation();
        var pageData = $(this).data("url");
        if (pageData !== undefined) {
            app.openOwnBrowser(String(pageData));
        }
        else {
            app.toast("没有找到要跳转的url")
        }
    };
    app.setGo = function (selector) {
        var wp = null;
        if (typeof selector === "string") {
            wp = $("" + selector);
        }
        else {
            wp = $("body");
        }
        var goPageNode = wp.find(".go-page");
        var goBackNode = wp.find(".go-back");
        var goUrlNode = wp.find(".go-url");
        goPageNode.attr("tapmode", "tapmode").each(function () {
            this.onclick = app._goPageClickFn;
        });
        goBackNode.attr("tapmode", "tapmode").each(function () {
            this.onclick = app._goBackClickFn;
        });
        goUrlNode.attr("tapmode", "tapmode").each(function () {
            this.onclick = app._goUrlClickFn;
        });
        api.parseTapmode();
        return this;
    };
    /*
     *  暂停短暂延迟后关闭窗口，期间应用无法操作
     *  param:time:延迟时间 ms
     *        call:关闭前的操作
     * */
    app.closeAndBack=function(time,call){
        app.cover("transparent");
        setTimeout(function(){
            typeof call==="function"&&call();
            app.goBack();
        },app.dataType(time)==="Number"?time:800);
    };
    /*
     * 设置返回到本页面时执行的函数
     * attr: _backHereCallback 执行的回调
     * param:call:回调
     * ps:必须goBack才会调用
     * */
    app.setBackHere =function(call){
        typeof call==="function"&&(app.setBackHere._backHereCallback=call);
        return app;
    };
    app.setBackHere._backHereCallback=function(){};

    /*
     * 手动触发返回目标页面
     * */
    app.triggerBack=function (win,frame){
        if(win){
            var execParam={
                name:win,
                script:"window.app.setBackHere._backHereCallback()"
            };
            if(!!frame){
                execParam.frameName=frame;
            }
            api.execScript(execParam);
        }
    };

    /*
     * b>跨页面执行函数封装
     * */
    /*
     * 监听页面被切换到前台事件
     * attr:_exposeQueue 事件执行队列
     * ps:仅能在win上监听
     * */
    app.listenExpose = function (fn) {
        if(typeof fn === "function"&&app.isWin()){
            if(app.listenExpose._exposeQueue==null){
                app.listenExpose._exposeQueue=[];
                api.addEventListener({
                    name: 'viewappear'
                }, function (ret, err) {
                    app._for(app.listenExpose._exposeQueue,function(i){
                        app.listenExpose._exposeQueue[i]();
                    });
                });
            }
            app.listenExpose._exposeQueue.push(fn);
        }
    };
    /*
     * 全局散播事件
     * */
    app.fireAll = function (event, param) {
        api.sendEvent({
            name: event,
            extra: param || {}
        });
        return app;
    };
    /*
     * 接收全局事件
     * param:event 事件名
     *       fn：回调 arguments:param:散播时传入的参数
     *       extra：针对平台可能出现的某些系统事件可能需要配置一些参数，自定义事件请无视
     * */
    app.listenAll = function (event, fn, extra) {
        var o = {
            name: event
        };
        app.isObj(extra) && (o.extra = extra);
        api.addEventListener(o, function (ret, err) {
            fn(ret, err)
        });
    };

    /*
     * 设置本页面事件独立,重设fireWin主页
     * attr:_fireWinMain:独立标记
     * ps:默认的主窗口为win
     * ps:重设后打开的frame会以本页面为主窗口,所以要在调用此方法后再打开的frame才会认为是在同一环境下
     * */
    app._fireWinMain=null;
    app.setFireWinMain= function(){
        app._fireWinMain={win:api.winName,frame:api.frameName||null};
        return false;
    };
    /*
     * 同窗口内部触发事件
     * param:event:事件名称
     *       child:指定内部子页面执行(不传表示在主页面执行)
     *       param:参数
     * ps:和fire方法可混用，由listen方法共同监听
     * */
    app.fireWin =function (option){
        var opt = $.extend(true,{}, app._fireWinMain?app._fireWinMain:{win:api.winName},{
            event:option.event||null,
            param:option.param||{}
        });
        if(option.child){
            opt.frame=option.child;
        }
        if (opt.event === null || (opt.win === null && opt.frame === null) || !app.isObj(opt.param)) {
            exportError("事件触发参数错误");
        }
        else {
            var p = {};
            opt.win && (p.name = opt.win);
            opt.frame && (p.frameName = opt.frame);
            p.script = "var cacheP=['" + opt.event + "'," + app.toStr(opt.param) + "];if(window.app!==undefined){app.ready(function(){app.trigger(cacheP[0],cacheP[1]);});}" +
                "else{window.appTriggerCache===undefined?(window.appTriggerCache=[cacheP]):(window.appTriggerCache.push(cacheP));}";
            api.execScript(p);
        }
        return this;
    };

    /*
     * 指定页面触发事件
     * param：event（事件名）
     *        win/frame:目标页面的win/frame name（同页面可以不传win name）
     *        param:要传递的参数
     * ps:最好用于同一win内的frame、win之间通信，或有固定id的页面通信
     * */
    app.fire = function (option) {
        var opt = $.extend(true, {
            event: null,
            win: null,
            frame: null,
            param: {}
        }, option);
        if (opt.event === null || (opt.win === null && opt.frame === null) || !app.isObj(opt.param)) {
            exportError("事件触发参数错误");
        }
        else {
            var p = {};
            opt.win && (p.name = opt.win);
            opt.frame && (p.frameName = opt.frame);
            p.script = "var cacheP=['" + opt.event + "'," + app.toStr(opt.param) + "];if(window.app!==undefined){app.ready(function(){app.trigger(cacheP[0],cacheP[1]);});}" +
                "else{window.appTriggerCache===undefined?(window.appTriggerCache=[cacheP]):(window.appTriggerCache.push(cacheP));}";
            api.execScript(p);
        }
        return this;
    };
    /*
     * 跨页面监听事件
     * attr:events
     * param:event（为本页面（frame/win）绑定跨页面事件名）
     *       fn(触发后执行函数)
     * */
    app.listen = function (event, fn) {
        if (typeof event !== "string" || typeof fn !== "function") {
            exportError("事件监听参数错误!");
        }
        if (app.listen.events[event] === undefined) {
            app.listen.events[event] = [];
            app.listen.events[event][0] = fn;
        }
        else {
            app.listen.events[event].push(fn);
        }
        return this;
    };
    app.listen.events = {};
    /*
     * 直接触发本页面绑定的事件(可重复绑定多次，按顺序执行，但是未测试)
     * param:event:要触发的事件
     *       param:手动传入参数
     * */
    app.trigger = function (event, param) {
        if (this.listen.events[event] !== undefined) {
            for (var i = 0; this.listen.events[event] !== undefined ? (i < this.listen.events[event].length) : (false); i++) {
                this.listen.events[event][i](app.isObj(param) ? param : {});
            }
        }
    };
    /*
     * 跨页面事件移除(使用赋值delete)
     * param:event:要移除的事件名
     * */
    app.closeListen = function (event) {
        if (event === undefined) {
            exportError("事件移除参数错误!");
        }
        else if (app.listen.events.hasOwnProperty(event)) {
            if (delete app.listen.events[event] === false) {
                app.listen.events[event] = undefined;
            }
        }
        return this
    };
})(window.app||(window.app={}));
///<jscompress sourcefile="main_function.js" />
/*
 * 封装具体的页面功能
 * *a>页面数据交互操作
 * *b>注销/客服等业务逻辑操作
 * *c>跨页面数据同步操作
 * */
(function(app){
    /*
     * a>页面数据交互操作
     * */

    /*
     * >ajax提交数据
     * attr:count
     * param:url:你懂得
     *       method:请求方式
     *       data:请求数据
     *       cover:“请求中”，是否显示遮罩，可以设置文字
     *       timeout：最长等待时间 默认10s
     *       callBack：请求有结果后必然执行回调
     *       success: 请求结果成功回调
     *       defeat：请求结果失败回调
     *       after: 请求回调执行完成后额外的回调
     *       token:true/false 是否同时提交用户token
     * ext:内部的参数会强制覆盖param.data
     * return:tag标记,用于取消ajax
     * ps:此方法对本平台接口的数据返回格式进行了验证，并非公用方法
     * */
    app._ajaxCacheTag = [];
    app.ajax = function (option, token, ext) {
        if (option.url === undefined) {
            throw Error("缺少url参数");
        }
        //自增本页面ajax标记
        if (!app.ajax.count) {
            app.ajax.count = 1;
        }
        else {
            app.ajax.count++;
        }
        var opt = {
            method: "get",
            tag: "ajax" + app.ajax.count,
            timeout: 10,
            checkLogin:true,
            data: {}
        };
        //附加token
        if (token) {
            var tkUser = app.getStorage("user");
            if (tkUser.token) {
                opt.data.token = tkUser.token;
            }
            else {
                opt.data.token = "";
                // app.toLogin();
            }
            //所有接口自动附加国家信息
            var countryStg = app.getStorage("countryMsg");
            if (countryStg) {
                opt.data["site_id"] = countryStg.siteId;
            }
            else {
                opt.data["site_id"] = 0;
            }
        }

        var callback, hasMack;
        $.extend(true, opt, option);
        //处理是否打开遮罩
        if (opt.cover) {
            hasMack = true;
            app.loading(typeof opt.cover === "string" ? opt.cover : null);
            delete opt.cover;
        }
        //强制覆盖ext参数
        if(app.isObj(ext)){
            $.extend(true,opt.data,ext);
        }
        var cacheOpt=$.extend(true,{},opt.data);
        //处理type数据封装
        if (opt.method === "post") {
            opt.data = {
                values: opt.data
            }
        }
        else if (opt.method === "file") {
            opt.method = "post";
            opt.data = {
                values: opt.data,
                files: opt.files
            };
            delete opt.files;
        }
        else if (opt.method === "text") {
            opt.method = "post";
            opt.data = {
                body: String(opt.data)
            }
        }
        else {
            opt.method = "get";
            var joinText = "";
            for (var i in opt.data) {
                joinText += "&" + i + "=" + opt.data[i];
            }
            if (opt.url.indexOf(/\?[\S\s]+/) === -1) {
                opt.url += joinText;
            }
            else {
                opt.url += "?" + joinText.slice(1);
            }
            delete opt.data;
        }

        //处理回调
        callback = function (res, e) {
            if (hasMack) {
                var isInCache = app.inArray(opt.tag, app._ajaxCacheTag);
                if (isInCache) {
                    app._ajaxCacheTag.splice(isInCache - 1, 1);
                }
                app.closeLoading();//移除这个tag
            }
            typeof opt.callBack === "function" && opt.callBack(!!res ? res : {}, e);
            if (e) {
                // app.toast("请求失败，状态码：" + e.statusCode + ",错误码：" + e.code + ",错误信息:" + e.msg + ",错误提示：" + e.body);
                var errorData = {statusCode: -2, msg: e.body};
                if (e.code === 1) {
                    errorData.statusCode = 0;
                    errorData.msg = "网络超时，请重试";
                }
                else if (e.code === 0) {
                    errorData.statusCode = 0;
                    errorData.msg = "当前没有网络";
                }
                else {
                    app.toast("网络繁忙，请稍后重试");//其他未知错误自动提示
                }
                typeof opt.defeat === "function" && opt.defeat(errorData,res,cacheOpt);
            }
            else {
                //错误状态
                if (res === "") {
                    app.toast("网络繁忙，请稍后重试");
                }
                else if (res.datas && res.datas["error"]) {
                    //需要登录
                    if (res["need_login"] == "1") {
                            if(opt.checkLogin){
                                app.toast(res.datas["error"]);
                                app.cover("transparent");
                                setTimeout(function () {
                                    app.toLogin();
                                }, 1200);
                                return false;
                            }
                            else {
                                opt.defeat({statusCode: -1, msg: "请登录"},res,cacheOpt);
                                return false;
                            }
                    }
                    if (typeof opt.defeat === "function") {
                        opt.defeat({statusCode: -1, msg: res.datas["error"]},res,cacheOpt);
                    }
                    else {
                        app.toast(res.datas["error"]);
                    }
                }
                else {
                    typeof opt.success === "function" && opt.success(res.datas,res,cacheOpt);
                }
            }
            if (typeof opt.after === "function") {
                opt.after();
            }
        };
        if (typeof opt.before === "function") {
            opt.before();
        }
        api.ajax(opt, callback);
        this._ajaxCacheTag.push(opt.tag);
        return opt.tag;
    };
    /*
     * 取消ajax
     * param：id:app.ajax返回的tag,如果不传 会清楚本页正在执行的所有ajax
     * */
    app.cancelAjax = function (id) {
        if (id) {
            api.cancelAjax({
                tag: id
            });
        }
        else {
            app._for(this._ajaxCacheTag, function (i) {
                api.cancelAjax({
                    tag: app._ajaxCacheTag[i]
                });
            });
            app._ajaxCacheTag = [];
        }
        return this;
    };
    /*
     * file上传
     * param:同ajax
     * ps:method默认为file，其他同ajax #要提交的文件用files对象传入
     * */
    app.file = function (opt, tk ,ext) {
        return app.ajax($.extend(true, {method: "file"}, opt), tk,ext);
    };
    /*
     * post提交ajax
     * param:同ajax
     * ps:method默认为post，其他同ajax
     * */
    app.post = function (opt, tk ,ext) {
        return app.ajax($.extend(true, {method: "post"}, opt), tk,ext);
    };
    /*
     * get上传
     * param:同ajax
     * ps:method默认为get，其他同ajax
     * */
    app.get = function (opt, tk ,ext) {
        return app.ajax($.extend(true, {method: "get"}, opt), tk,ext);
    };

    /*
     * >上拉加载更多和下拉刷新功能
     * ps:此方法对本平台接口的数据返回格式进行了验证，并非公用方法
     * ps:封装了接口规则，所以要求接口要按固定格式返回数据
     */
    /*
     * 设置下拉刷新
     * param(1):obj:下拉样式类型
     *          callback:下拉后执行的函数
     * param(2):callback:下拉后执行的函数
     * */
    app.setRf = function (a, b) {
        var dfOpt = {
            visible: true,//是否可见
//            loadingImg:true,//上拉下拉的图片地址
            bgColor: "#f0f0f0",//背景颜色
            textColor: "#999",//文本颜色
            textDown: "再下拉一点点...",//下拉文字描述
            textUp: "松开以刷新页面",//松开文字描述
            textLoading: "刷新中...",//加载状态描述
            // textTime: "",//最后更新时间
            showTime: false//是否显示更新时间
        };
        var types = {};
        var callBack = null;
        if (typeof a === "string") {
            types[a] !== undefined && $.extend(true, dfOpt, types[a]||{});
            if (typeof b === "function") {
                callBack = b;
            }
        }
        else if (typeof a === "function") {
            callBack = a;
        }
        api.setRefreshHeaderInfo(dfOpt, function (r, e) {
            callBack();
        });
    };
    /*
     * 设置下拉刷新为完成
     * */
    app.stopRf = function () {
        api.refreshHeaderLoadDone();
    };
    /*
     * 设置上拉加载更多(默认不会请求一次,下次请求page会自动加1)
     * attr:_types 请求种类集合 _dfOpt 默认参数
     * param:type:上拉种类（默认为ajax请求,目前仅有ajax请求）
     *       opt:上拉参数
     *       param:ajax参数（如果type为ajax 会给ajax.post传入的参数）
     * ext:强制覆盖的参数
     * */
    app.setLoadMore = function (type, opt, param ,ext) {
        if (!app.isObj(this.setLoadMore._types)) {
            this.setLoadMore._types = {
                "ajax": {}
            };
            this.setLoadMore._dfOpt = {};
        }
        var types = this.setLoadMore._types;
        var dfType = type ? "ajax" : String(type);
        var dfOpt = this.setLoadMore._dfOpt = {//*指可以通过setLoadMoreOpt方法修改的属性
            upAndDown: false,//是否同时设置上拉刷新使用本接口刷新数据
            win: $(window),//视口
            wrapper: "body",//placeholder的容器
            box: "body",//内容容器
            bottom: 0,//距离页面底部距离多少时刷新*
            page: "curpage",//页码关键字
            start: 1,//起始page为1
            pageNum: "page",//列表条数关键字
            num: false,//加载列表条数，false为不传
            loadingText: "加载中，请稍候...",//加载中文字 *
            defeatText: "加载失败，点击重试...",//加载失败文字 *
            // successText:"加载成功",//加载成功文字 *
            successText: "",//加载成功文字 *
            endText: "没有更多数据了",//没有更多数据文字 *
            //首次请求失败显示html
            defeatWrapper: '<div class="nothing" style="padding-top: ' + ((api.frameName !== "" ? api.frameHeight : api.winHeight) / 2 - 135) + 'px;">' +
            '<i class="nothing_icon iconfont icon-networkError"></i><div class="nothing_small">网络异常</div><div class="blank1"></div>' +
            '<div class="nothing_btn"><div class="c_btn" onclick="app.clearLoadMore({cover:true},true);" tapmode>重新加载</div></div></div>',
            // 首次加载无数据显示html*
            nothingWrapper: '<div class="nothing" style="padding-top: ' + ((api.frameName !== "" ? api.frameHeight : api.winHeight) / 2 - 135) + 'px;">' +
            '<i class="nothing_icon iconfont icon-orderBlank"></i><div class="nothing_text">暂无数据</div></div>',
            refreshCallBack: null//下拉刷新时的回调(会提前于ajax前执行)
        };
        if (typeof opt === "string") {
            opt = {box: opt};
        }
        else if (!app.isObj(opt)) {
            throw Error("缺少参数opt！");
        }
        $.extend(true, dfOpt, opt);
        if (dfType === "ajax" && !app.isObj(param)) {
            throw Error("缺少参数ajaxParam！");
        }
        var ajaxParam = param;
        if (!types[dfType]) {
            return false;
        }
        else {
            if (dfType === "ajax") {
                var typesCache = types[dfType];
                typesCache["box"] = $(dfOpt.box).css({
                    "marginBottom": dfOpt.bottom + 30 + "px",
                    "position": "relative"
                });//内容容器
                typesCache["wrapper"] = $(dfOpt.wrapper).css("position", "relative").append('<div id="loadMorePlaceholder"></div>');//placeholder的容器
                typesCache["placeholder"] = $("#loadMorePlaceholder").css({"bottom": "-30px"});//上拉提示
                typesCache["count"] = dfOpt.start;//从第几页开始加载
                typesCache["loadEnd"] = false;//是否加载完所有内容
                //重装回调数据
                typesCache["posting"] = false;//正在请求中标记
                // var successProxy=null,dfProxy=null,callBacProxy=null;
                if (typeof ajaxParam.callBack === "function") {
                    typesCache.callBackProxy = ajaxParam.callBack;
                }
                ajaxParam.callBack = function (data, e) {
                    //请求完成
                    typesCache["placeholder"].text("");
                    typesCache["posting"] = false;
                    //关闭下拉刷新
                    if (dfOpt.upAndDown === -1) {
                        dfOpt.upAndDown = true;
                    }
                    else if (dfOpt.upAndDown) {
                        app.stopRf();
                    }
                    //判断是否还有下一页，如果没有 关闭上拉加载
                    if (!data["hasmore"]) {
                        typesCache["loadEnd"] = true;
                        typesCache["placeholder"].text(dfOpt["endText"]).show();
                    }
                    typesCache.callBackProxy && typesCache.callBackProxy(data, e);
                };
                if (typeof ajaxParam.success === "function") {
                    typesCache.successProxy = ajaxParam.success;
                }
                ajaxParam.success = function (data,res,p) {
                    //请求成功
                    if (!typesCache["loadEnd"]) {
                        typesCache["placeholder"].text(dfOpt["successText"]);
                    }
                    typesCache.successProxy && typesCache.successProxy(data,res,p);
                    //判断第一页是否有数据,如果没有 显示nothingwrapper
                    var htmlContent = typesCache["box"].html().replace(/\s/g, "");
                    if (htmlContent === "") {
                        if (typesCache["count"] === 1 && dfOpt["nothingWrapper"]) {//首次加载没有数据显示html
                            typesCache["box"].html(dfOpt["nothingWrapper"]);
                            api.parseTapmode();
                            typesCache["placeholder"].hide();
                        }
                    }
                    typesCache["count"] += 1;
                };
                if (typeof ajaxParam.defeat === "function") {
                    typesCache.dfProxy = ajaxParam.defeat;
                }
                ajaxParam.defeat = function (data,res,p) {
                    //请求失败 如果是第一页 显示defeatwrapper
                    if (typesCache["count"] === 1 && dfOpt["defeatWrapper"]) {
                        typesCache["box"].html(dfOpt["defeatWrapper"]);
                        api.parseTapmode();
                        typesCache["placeholder"].hide();
                    }//如果不是，显示点击重新加载
                    else if (!typesCache["loadEnd"]) {
                        typesCache["placeholder"].text(dfOpt["defeatText"]).on("click", function () {
                            typesCache["post"]();
                        });
                    }
                    typesCache.dfProxy && typesCache.dfProxy(data,res,p);
                };
                //修正data属性为对象
                if (!app.isObj(ajaxParam.data)) {
                    ajaxParam.data = {};
                }
                //附加消息条数
                if (typeof dfOpt["num"] === "number") {
                    ajaxParam.data[dfOpt.pageNum] = dfOpt["num"];
                }
                typesCache["param"] = ajaxParam;
                typesCache["cacheExt"] = ext;
                ajaxParam = null;
                typesCache["post"] = function (show) {
                    if (typesCache["posting"]) {
                        return false;
                    }
                    if (typesCache["loadEnd"]) {
                        return false;
                    }
                    typesCache["posting"] = true;
                    if (typesCache["count"] === 1) {
                        //清空内容
                        typesCache["box"].html("");
                    }
                    if (show) {
                        typesCache["placeholder"].hide()
                    }
                    else {
                        typesCache["placeholder"].show();
                    }
                    var newOpt = {data: {}};
                    newOpt["data"][dfOpt.page] = typesCache["count"];
                    typesCache["placeholder"].text(dfOpt["loadingText"]).off("click");
                    app.post($.extend(true, {}, typesCache["param"], newOpt), true,typesCache["cacheExt"]);
                };
                //设置滚动事件
                api.addEventListener({
                    name: 'scrolltobottom',
                    extra: {
                        threshold: dfOpt.bottom            //设置距离底部多少距离时触发，默认值为0，数字类型
                    }
                }, function (ret, err) {
                    typesCache["post"]();
                });
                //如果有upAndDown字段，则配置下拉刷新也使用此上拉加载的ajax
                if (dfOpt.upAndDown) {
                    dfOpt.upAndDown = -1;//做个标记，第一次加载没有刷新中状态
                    app.setRf(function () {
                        if (typeof dfOpt.refreshCallBack === "function") {
                            dfOpt.refreshCallBack();
                        }
                        app.clearLoadMore(null, true);
                    });
                }
                //默认请求一次(且本次不需要触发成功关闭刷新中)
                typesCache["post"](true);
            }
        }
        return this;
    };
    /*
     * 修改上拉加载的参数（一些不重要的，立即生效）
     * param:param:上拉加载的参数
     * */
    app.setLoadMoreOpt = function (param) {
        if (this.setLoadMore._dfOpt === undefined) {
            return false;
        }
        var df = this.setLoadMore._dfOpt;
        var aj = this.setLoadMore._types && this.setLoadMore._types["ajax"];
        var newOpt = {};
        if (typeof param["bottom"] === "number") {
            newOpt["bottom"] = param["bottom"];
            $(df.box).css({"marginBottom": newOpt["bottom"] + 30 + "px", "position": "relative"});//内容容器
            aj["placeholder"] = $("#loadMorePlaceholder").css({"bottom": "-30px"});//上拉提示
        }
        typeof param["loadingText"] === "string" && (newOpt["loadingText"] = param["loadingText"]);
        typeof param["defeatText"] === "string" && (newOpt["defeatText"] = param["defeatText"]);
        typeof param["endText"] === "string" && (newOpt["endText"] = param["endText"]);
        if (param["nothingWrapper"] !== undefined) {
            if (typeof param["nothingWrapper"] === "string") {
                newOpt["nothingWrapper"] = param["nothingWrapper"]
            }
            else if (!!param["nothingWrapper"] === false) {
                newOpt["nothingWrapper"] = false;
            }
        }
        if (param["defeatWrapper"] !== undefined) {
            if (typeof param["defeatWrapper"] === "string") {
                newOpt["defeatWrapper"] = param["defeatWrapper"]
            }
            else if (!!param["defeatWrapper"] === false) {
                newOpt["defeatWrapper"] = false;
            }
        }
        $.extend(true, df, newOpt);
        return this;
    };
    /*
     * 静默覆盖上拉加载ajax的参数（加载时才生效的参数）
     * param:data:参数
     *       cover:是否新有的字段完全整体覆盖之前的参数
     *       ext:强制覆盖参数
     * */
    app.resetLoadMore=function (data,cover,ext){
        var ajaxObj = this.setLoadMore && this.setLoadMore._types["ajax"];
        if(ajaxObj && ajaxObj.box){
            if(app.isObj(data)){
                if (app.isObj(data)) {
                    if (cover) {
                        for (var i in data) {
                            if (i === "success") {
                                ajaxObj.successProxy = data[i];
                            }
                            else if (i === "defeat") {
                                ajaxObj.dfProxy = data[i];
                            }
                            else if (i === "callBack") {
                                ajaxObj.callBackProxy = data[i];
                            }
                            else {
                                ajaxObj.param[i] = data[i];
                            }
                        }
                    }
                    else {
                        $.extend(true, ajaxObj.param, data);
                    }
                }
            }
            if(app.isObj(ext)){
                ajaxObj.cacheExt=ext;
            }
        }
        return this
    };
    /*
     * 重置上拉加载，可修改参数，并将页面page重置为0
     * param:data:新的参数
     *       again:是否刷新一次
     *       cover:是否新有的字段完全覆盖之前的参数/覆盖或继承新的参数
     *       ext:强制覆盖参数
     * ps:如果传入true，会默认执行一次，否则相当于清空页面
     * */
    app.clearLoadMore = function (data, again, cover,ext) {
        var ajaxObj = this.setLoadMore && this.setLoadMore._types["ajax"];
        if (ajaxObj && ajaxObj.box) {
            app.resetLoadMore(data,cover,ext);
            ajaxObj.count = 1;
            ajaxObj.loadEnd = false;
            if (again) {
                ajaxObj.post(true);
            }
        }
        return this;
    };
    /*
     * 清除上拉加载
     * */
    app.removeLoadMore = function () {
        var ajaxObj = this.setLoadMore._types["ajax"];
        if (ajaxObj.box) {
            ajaxObj["wrapper"].off("scroll");
            this.setLoadMore._types["ajax"] = null;
        }
        return this;
    };

    /*
    * b>注销/客服等业务逻辑操作
    * */

    /*
    * 检测token是否失效
    * param:token：要检测的token值
    *       call:回调 arguments:0:1/0/-1 未失效/失效/网络问题无法检测
    * ps:仅检测 不做返回登陆操作
    * */
    app.tokenIsDated=function(call){
        var userStg=app.getStorage("user");
        if(typeof userStg.token==="string"){
            app.ajax({
                url: app.config.url + "/index.php?act=index&op=check_token",
                method: "post",
                timeout: 1,
                checkLogin:false,
                data: {token: userStg.token},
                success:function(r,res,param){
                    if(res["need_login"] == "1"){
                        typeof call=="function"&&call(0);
                    }
                    else {
                        typeof call=="function"&&call(1);
                    }
                },
                defeat:function(e){
                    typeof call=="function"&&call(-1);
                }
            });
        }
        else {
            typeof call=="function"&&call(false);
        }
    };


    /*
     * 更新用户数据并检测用户当前token是否已过期（如果已过期会注销）
     * param: rf:检测后是否刷新用户数据(可选)
     *        fn: 回调函数 arguments>state:1:可用 0:失效
     *                               data:更新之后的用户数据
     * */
    app.checkToken = function (rf, fn) {
        var call = function () {
        }, needRf;
        if (typeof rf !== "function") {
            needRf = !!rf;
            if (typeof fn === "function") {
                call = fn;
            }
        }
        else {
            call = rf;
        }
        var userStg = app.getStorage("user");
        if (!userStg.token) {
            call.apply(null, needRf ? [0, {}] : [0]);
        }
        else {
            var opt = {};
            app.ajax({
                url: app.config.url + "/index.php?act=index&op=check_token",
                method: "post",
                timeout: 5,
                data: {token: userStg.token},
                success: function (data) {
                    if (needRf) {
                        opt = {
                            uid: data["member_id"],
                            token: data["token"],
                            username: data["member_name"],//用户昵称
                            mobile: data["mobile"],//手机号
                            avatar: data["member_avatar"],//头像地址
                            areaCode: data["areacode"],//国家时区
                            email: data["member_email"],//邮箱
                            // sex:data["member_sex"]==="0"?"男":"女",//性别
                            areaInfo: data["member_areainfo"],//居住地
                            account: data["account"],//是否已实名认证
                            reg_step: data["reg_step"],//资料完善度
                            member_qq: data["member_qq"],//QQ信息
                            member_wx: data["member_wx"],//微信信息
                            member_type:data["member_type"],//角色：0：B 3:C
                            domain:data["share_domain"]||false,//个人店铺信息
                            inviteNum:data["invite_num"],//个人剩余邀请码
                        };
                        app.setStorage("user", $.extend(true, app.getStorage("user"), opt));
                    }
                    call(1, opt);
                },
                defeat: function () {
                    call.apply(null, needRf ? [0, {}] : [0]);
                }
            });
        }
    };
    /*
    * 检测用户身份
    * 返回值： a:核心代理 b:一般代理 c:普通用户 y:游客
    * */
    app.userIdentity=function(){
        var userStg=app.getStorage("user");
        var key=null;
        if(!userStg.uid){
            key="y";
        }
        else {
            if(userStg["member_type"]==4){
                key="a";
            }
            else if(userStg["member_type"]==0||userStg["member_type"]==1){
                key="b";
            }
            else/*if(userStg["member_type"]==3)*/{
                key="c";
            }
        }
        return key;
    };

    /*
    * 对用户当前身份进行资料完善检测
    * page:register3
    * param: noC:true/false 是否不区分c端进行检测
    *        noJump: true/false 是否不跳转到完善资料
    * 返回值：true 用户当前身份无需完善资料或已完善资料
    *        false 用户需要跳转到完善资料页面进行完善资料
    * */
    app.verifyUserInformation=function(noC,noJump){
        if(noC||this.userIdentity()!="c"){
            var userStorage=app.getStorage("user");
            if(userStorage["reg_step"]!=3){
                if(!noJump){
                    app.goWin("register3",{
                        pageParam:{
                            goMain:false
                        },
                        animation:{
                            type:"push",
                            subType:"from_right"
                        }
                    });
                }
                return false;
            }
        }
        return true
    };

    /*
     * 检测更新
     * module:mam
     * param：call 检测完毕回调 arguments>state:-1,0,1版本过旧/未执行更新/正在更新中
     *                                   msg:正在执行的操作>disabled:更新中,禁止继续使用
     *                                                     closeWidget:应该关闭应用
     *                                                     skip:应该跳过更新
     *                                                     update:后台更新中,可以继续使用
     *                                                     cancel:取消了更新
     *                                                     no:没有需要更新的
     *                                                     error:检测更新报错]
     *        custom 自定义检测方式
     * ps:custom 为了在入口检测强制更新，主页检测可选更新 请分别传入force/auto 参数
     * */
    app.checkUpdate = function (callBack,custom) {
        var mamMd = api.require("mam");
        var call = typeof callBack === "function" ? callBack : function () {
            
        };
        mamMd&&mamMd.checkUpdate(function (r, e) {
            if (r.status) {
                var result = r.result;
                if (result.update) {
                    var updateFn = function () {
                        api.toast({
                            msg: "正在后台下载应用，请稍候...",
                            location: "bottom",
                            global: true
                        });
                        if (!app.isIos) {
                            api.download({
                                url: result.source,
                                report: true
                            }, function (ret, err) {
                                if (ret && 1 == ret.state) {/* 下载完成 */
                                    var savePath = ret.savePath;
                                    api.installApp({
                                        appUri: savePath
                                    });
                                }
                            });
                        }
                        else {
                            api.installApp({
                                appUri: result.source
                            });
                        }
                    };
                    if (result.closed) {//强制更新
                        if(custom==="auto"){
                            return false;//不检测强制更新
                        }
                        api.confirm({
                            title: "新版本发布啦(强制更新):" + result.version,
                            msg: result.updateTip,
                            buttons: ["立即更新", "退出洋姑妈"]
                        }, function (r, e) {
                            var index = r.buttonIndex;
                            if (index == 1) {
                                updateFn();
                                call(1, "disabled");//更新中(禁止使用)
                            }
                            else {
                                api.closeWidget({silent: true});
                                call(-1, "closeWidget");//关闭应用
                            }
                        });
                    }
                    else {//非强制更新
                        if(custom==="force"){
                            return false;//不检测可选更新
                        }
                        //获取上次检测时间,小于一天不提示
                        var lcuStg = parseFloat(app.getStorage("lastCheckUpdate"));
                        var nowTime = new Date().getTime();
                        if (nowTime - lcuStg < 864000000) {
                            call(0, "skip");//跳过更新
                            return false;
                        }
                        api.confirm({
                            title: "新版本发布啦:" + result.version,
                            msg: result.updateTip,
                            buttons: ["立即更新", "稍后再说"]
                        }, function (r, e) {
                            var index = r.buttonIndex;
                            if (index == 1) {
                                updateFn();
                                call(1, "update");//更新中
                            }
                            else if (index == 2) {
                                app.setStorage("lastCheckUpdate", nowTime);
                                call(0, "cancel");//取消了更新
                            }
                            else {
                                call(0, "cancel");
                            }
                        });
                    }
                }
                else {
                    call(0, "no");//没有更新
                }
            }
            else {
                // app.alert(e.msg);
                call(0, "error");//检测更新错误
                // setTimeout(function(){
                //     api.closeWidget({silent:true});
                // },2000)
            }
        });
    };
    /*
     * 注销账号并回到登录页面
     * module:MyImModule
     * */
    app.toLogin = function () {
        //注销ajax回调
        app.cancelAjax();
        //注销客服信息
        app.outIm();
        //通知root页注销所有页面
        setTimeout(function () {
            app.fire({
                event: "goApp",
                win: "root",
                param: {
                    type: "logout"
                }
            });
        }, 360);
        return app;
    };
    
    /*
    * 转化为游客模式访问
    * module:MyImModule
    * */
    app.toVisitor = function () {
        //注销ajax回调
        app.cancelAjax();
        //注销客服信息
        app.outIm();
        //通知root页注销所有页面
        setTimeout(function () {
            app.fire({
                event: "goApp",
                win: "root",
                param: {
                    type: "visitor"
                }
            });
        }, 360);
        return app;
    };

    /*
    * 静默修复完成，提示重启弹窗
    *
    * */
    app.smartAlert=function(v){
        api.alert({
            title: '当前有新的可用更新',
            msg: v,
            buttons:["重启应用"]
        }, function(ret, err) {
            api.rebootApp();
        });
    };

    /*
     * 批量下单缓存操作
     * param：id/[id,...]
     * ps:将id或id数组加入到本地存储quick对象中的orders中
     * */
    app.joinQuickOrder = function (id) {
        var quick = app.getStorage("quick")
        quick.orders.push(id);
        app.setStorage("quick", quick);
        return app;
    };
    /*
     * 重设quick对象中orders
     * param：[id,...]
     */
    app.setQuickOrder = function (ary) {
        if (app.isArray(ary)) {
            app.setStorage("quick", {orders: ary});
        }
        else {
            app.exportError("")
        }
        return app;
    };
    /*
     *获取目前缓存的quick对象
     * */
    app.getQuickOrder = function () {
        var quick = app.getStorage("quick");
        return quick.orders
    };

    /*
    * 调用客服接口
    * */

    /*
    * 初始化客服模块
    * attr:_imMd,_imMd_callBack
    *
    * type:"normal"/"goods"/"order"
    * param: normal:null
    *        goods:txt:简介
    *              image:缩略图
    *              url:商品地址
    *              price:单价
    *        order:txt:简介
    *              url:订单详情地址
    * */
    app.agency._imMd=null;
    app.agency._imMd_callBack=null;
    app.initIm=function(extJson){
        //在客服未初始化之前，禁止使用
        if(!extJson){
            if(!app.getStorage("serverIsInit")){
                this.agency._imMd=null;
                return this;
            }
        }
        this.agency._imMd=api.require("MyImModule");
        if(this.agency._imMd){
            this.agency._imMd_callBack={};
            //如果传入extJson，那么将会注册以下事件
            if(typeof extJson=="object"){
                var param={};
                if(app.isIos){
                    param={appParam:extJson};
                }
                else {
                    param={appParam:app.toStr(extJson)};
                }
                this.agency._imMd.registImNotice(param,function(r,e){
                    var call=app.agency._imMd_callBack;
                    if(r==1){//安卓有新消息
                        if(app.isAndrod){
                            call["newMsg"]&&call["newMsg"](app.agency._imMd);
                        }
                    }
                    else if(r==0){//安卓无新消息
                        if(app.isAndrod){
                            call["noMsg"]&&call["noMsg"](app.agency._imMd);
                        }
                    }
                    else if(r!=0&&r!=1){
                        //ios个推处理im号
                        if(app.isIos){
                            //区分im:前缀的识别为im号
                            var isIm=String(r).match(/^im\:/);
                            if(isIm&&isIm.length&&isIm.index==0){
                                call["server"]&&call["server"](app.agency._imMd,String(r).slice(3));
                                return false;
                            }
                        }
                        call["goUrl"]&&call["goUrl"](app.agency._imMd,r);
                    }
                });
                app.setStorage("serverIsInit",true);
                if(app.isIos){
                    this.agency._imMd.listenState({},function(state){
                        // test(arguments);
                        var call=app.agency._imMd_callBack;
                        if(state==1){
                            call["newMsg"]&&call["newMsg"](app.agency._imMd);
                        }
                        else if(state==0) {
                            call["noMsg"]&&call["noMsg"](app.agency._imMd);
                        }
                    });
                }
            }
            app.initIm=function(){};
        }
        return this;
    };
    app.charIm=function(id,type,p){
        if(!this.agency._imMd){
            this.initIm();
        }
        if(!this.agency._imMd){
            return false;
        }
        var _type,_param,param=app.isObj(p)?p:{};
        //重组参数
        switch (type){
            case "goods":_type="goods";_param={
                txt:param.txt||"",
                image:param.image||"",
                price:param.price||"",
                url:param.url||""
            };break;
            case "order":_type="order";_param={
                txt: param.txt||"",
                image: param.image||"测试",
                price: param.price||"测试",
                buyerName: param.buyerName||"测试",
                buyerPhoneNum: param.buyerPhoneNum||"测试",
                states: param.states||"测试",
                wuliu: param.wuliu||"测试"
            };if(param.url)_param.url=param.url;break;
            default:_type="normal";_param=null;
        }
        this.charImByDevice(id,_type,_param);
    };
    app.closeChar=function(){
        if(this.agency._imMd){
            this.agency._imMd.closeChat(null);
        }
    };
    app.charImByDevice=function(id,type,param){
        var imMd=this.agency._imMd,sendParam;
        var userStg=app.getStorage("user");
        var serviceUser={
            account:userStg.areaCode?userStg.areaCode+"-"+userStg.mobile:userStg.mobile,//账号
            nickname:userStg.username,//昵称
            avatar:userStg.avatar,//头像
        };
        //附加微信、qq信息
        if(userStg.member_wx){
            serviceUser.weixin=userStg.member_wx;
        }
        if(userStg.member_qq){
            serviceUser.qq=userStg.member_qq;
        }
        var serviceParam={
            type:type,
            user:serviceUser
        };
        if(app.isObj(param)){
            serviceParam.data=param;
        }
        if(app.isIos){
            sendParam={
                appParam:{
                    im_number:id,
                    infro:serviceParam
                }
            }
        }
        else {
            sendParam ={appParam:'[ "" ,' + id +',' + app.toStr(serviceParam) +']'};
        }
        imMd["chat"](sendParam);
    };
    app.outIm=function(){
        if(!this.agency._imMd){
            app.initIm();
        }
        var imMd=this.agency._imMd;
        imMd&& imMd.loginOutIM();
    };
    /*
    * 打开客服会话列表
    *
    * */
    app.imOpenList=function(){
        if(!this.agency._imMd){
            this.initIm();
        }
        if(!this.agency._imMd){
            return false;
        }
        var imMd=this.agency._imMd,sendParam;
        var userStg=app.getStorage("user");
        var serviceUser={
            account:userStg.areaCode?userStg.areaCode+"-"+userStg.mobile:userStg.mobile,//账号
            nickname:userStg.username,//昵称
            avatar:userStg.avatar,//头像
        };
        //附加微信、qq信息
        if(userStg.member_wx){
            serviceUser.weixin=userStg.member_wx;
        }
        if(userStg.member_qq){
            serviceUser.qq=userStg.member_qq;
        }
        var serviceParam={
            user:serviceUser
        };
        if(app.isIos){
            sendParam={
                appParam:{
                    infro:serviceParam
                }
            }
        }
        else {
            sendParam ={appParam:'[ "" ,"",' + app.toStr(serviceParam) +']'};
        }
        imMd["chatList"](sendParam);
    };

    /*
    * 回调监听
    * noMsg：没有新消息
    * newMsg：有新消息
    * goUrl:跳转到指定url
    * */
    app.imListen=function(event,call){
        if(!this.agency._imMd) {
            this.initIm();
        }
        if (!this.agency._imMd) {
            return false;
        }
        if(app.isObj(this.agency._imMd_callBack)&&typeof call==="function"){
            switch (event){
                case "noMsg":this.agency._imMd_callBack["noMsg"]=call;break;
                case "newMsg":this.agency._imMd_callBack["newMsg"]=call;break;
                case "goUrl":this.agency._imMd_callBack["goUrl"]=call;break;
                case "server":this.agency._imMd_callBack["server"]=call;break;
            }
        }
    };


    /*
     * 百度统计模块
     * module:baiduMTJ
     * */
    // app.agency._tjMd=null;
    app.initTj=function(){
        var tjMd=api.require("baiduMTJ");
        tjMd&&tjMd.init({}, function(ret, err) {
            if(ret["status"]){
                //...
            }
        });
    };
    app.tjPage=function(pageName){
        var tjMd = api.require('baiduMTJ');
        tjMd&&tjMd["onPageStart"]({
            pagename:pageName,
        }, function(ret, err) {

        });
    };
    app.tjPageEnd=function(pageName){
        var tjMd = api.require('baiduMTJ');
        tjMd&&tjMd["onPageEnd"]({
            pagename:pageName,
        }, function(ret, err) {
        });
    };
    app.tjEvent=function(id,tag){
        var tjMd = api.require('baiduMTJ');
        tjMd["onEvent"]({
            eventid:id,
            label: tag
        }, function(ret, err) {

        });
    };
    /*
     * c>跨页面数据同步操作
     * ps:在本地存储fetchData字段作为数据刷新的判断依据
     *    fetchData={
     *        type:{
     *            local:{
     *                winName:newDate().getTime
     *            },
     *            state:{
     *                time:registerDate().getTime,
     *                ext:{
     *                    //最后一次操作的值
     *                }
     *            }
     *        }
     *    }
     *
     * */

    /*
     * 读取数据
     * param:type:数据种类
     * */
    app.getFetchData = function (type){
        var fetchData=app.getStorage("fetchData");
        return arguments.length?fetchData[type]:fetchData;
    };

    /*
     * 移除数据
     * param:type:数据种类
     * */
    app.removeFetchData = function (type){
        var fetchData=app.getStorage("fetchData");
        if(typeof type === "string"&&fetchData[type]){
            delete fetchData[type];
            app.setStorage(fetchData);
        }
        return app
    };

    /*
     * 清空数据
     * */
    app.clearFetchData =function (){
        app.setStorage("fetchData",{});
        return app
    };

    /*
     * 为本页面注册一条本地数据监听(同一win内都无法重复注册，再次注册会被覆盖)
     * param: type:数据种类
     *        call:更新变动回调操作 arguments>type:变动类型(目前只有refresh)
     *                                       ext:上次变动的数据
     * */
    app._localFetchCall={};
    app.registerFetch = function (type,call) {
        if(type&&typeof type === "string"){
            var fetchData=app.getStorage("fetchData");
            if(!fetchData[type]){
                fetchData[type]={
                    local:{},
                    state:{
                        time:0,
                        ext:null
                    }
                };
            }
            fetchData[type].local[api.winName]=fetchData[type].state.time;
            if(typeof call==="function"){
                app._localFetchCall[type]=call;
            }
            app.setStorage("fetchData",fetchData);
        }
        else {
            exportError("数据异常");
        }
        return app;
    };

    /*
     * 触发一次本地数据更新
     * param: type:数据种类
     *        data:存入变动数据
     * ps:本页面绑定的监听不会调用，如果不想下次进入此页面重复刷新一次，在本页面再次调用lostFetch方法
     * */
    app.updateFetch = function (type,data){
        var fetchData=app.getStorage("fetchData");
        if(fetchData[type]){
            fetchData[type].state={
                time:new Date().getTime(),
                ext:data
            };
            app.setStorage("fetchData",fetchData);
        }
        return app;
    };

    /*
     * 手动检测一次本地是否是最新数据
     * param: type:数据种类(可选)
     * */
    app.examineFetchHandle=function (type){
        var fetchData=app.getStorage("fetchData");
        var localTime,fetchTime,mack;
        if(typeof type==="string"&&fetchData[type]){
            fetchTime=fetchData[type].state.time;
            localTime=fetchData[type].local[api.winName];
            if(localTime!==fetchTime){
                //与本地时间不一致，触发fireAll
                app.fireAll("fetchDataChange-"+api.winName,{type:type,data:fetchData[type].state.ext});
                fetchData[type].local[api.winName]=fetchTime;
                mack=true;
            }
        }
        else {
            app._each(fetchData,function(i){
                if(fetchData[i].local[api.winName]!==undefined&&fetchData[i].state.time!==fetchData[i].local[api.winName]){
                    //与本地时间不一致，触发fireAll
                    app.fireAll("fetchDataChange-"+api.winName,{type:i,data:fetchData[i].state.ext});
                    fetchData[i].local[api.winName]=fetchData[i].state.time;
                    mack=true;
                }
            });
        }
        mack&&app.setStorage("fetchData",fetchData);
        return app;
    };
    /*
     * 跳过指定页面的本次更新检测
     * param:type:数据种类
     *       id:指定页面id(不传代表当前窗口)
     * */
    app.loseFetch = function (type,id){
        var tId=id?id: api.winName;
        var fetchData=app.getStorage("fetchData");
        if(typeof type==="string"&&fetchData[type]&&fetchData[type].local[tId]){
            fetchData[type].local[tId]=fetchData[type].state.time;
        }
        return app;
    }

})(window.app||(window.app={}));
///<jscompress sourcefile="main_config.js" />
/*
 * 初始化app对象
 * *配置应用参数、页面路径
 * *初始化页面基本功能
 * */
(function (app) {
    var nowTime = new Date().getTime();
    var parseNowTime = parseInt(nowTime / 1000);
    app.config = {
        //正式地址
        notTest:true,
        fileHost:"https://msul.moyuntv.com",
        host:"https://ygmb2b.com",
        url: "https://api.ygmb2b.com",

        //测试地址
        // fileHost:"https://temsul.moyuntv.com",
        // host: "https://test.ygmb2b.com",
        // url: "https://teapi.ygmb2b.com",

        // 1.88 IP本地地址
        // fileHost: "http://192.168.1.88/shop2/uploadCard",
        // host: "http://192.168.1.88/shop2",
        // url: "http://192.168.1.88/mobileygm",

        //1.90 IP本地地址
        // fileHost: "http://192.168.1.90/shop2/uploadCard",
        // host: "http://192.168.1.90/shop2",
        // url: "http://192.168.1.90/mobileygm",

        //1.66 IP本地地址
        // fileHost: "http://192.168.1.66/shop2/uploadCard",
        // host: "http://192.168.1.66/shop2",
        // url: "http://192.168.1.66/mobileygm",

        //底层页面（底层页面无法返回上一页）
        basePage:["root","main","login","access"],
        //页面路径配置
        pathConfig: {
            "root": ["root", "main","mainHome","mainOrder","mainPublish","mainQuick","mainAgency","mainUser"],//主框架
            "ad": ["ad", "jump"],//广告页
            "common": ["title"],//公用页面
            "guide": ["guide"],//引导页
            "home":["home","homeContent"],//入口页
            "function": ["categoryAlertList", "countryAlertList", "coverHint"],//特殊功能页面
            "login": ["forget", "login", "passAttestation", "passInfo", "protocol", "register", "register1", "register2", "register3"],//登陆注册
            "order": ["order", "orderAfter", "orderAfterInfo", "orderCancel", "orderFillLogistics", "orderInfo", "orderList", "orderLogistics"],//订单页
            "other": ["article", "articleContent", "articleList", "leave", "pay", "paySuccess", "msg", "msgInfo", "ranking"],//其他页面
            "quick": ["quick", "quickList", "quickListContent", "quickMain"],//快捷下单
            "search": ["result", "resultOrder", "resultShopping", "search","searchTag","searchAddr", "searchBrand","searchGlobalShopping","searchOrder","searchPublish","searchShopping", "searchShopping2"],//搜索功能
            "shopping": ["brand", "car", "carList", "class", "classList", "classMenu", "shoppingAffirm", "shoppingInfo", "shoppingInfoAlert", "shoppingInfoContent", "shoppingInfoForCar", "shoppingList"],//商品页
            "tool": ["browser","checkNot", "clip", "floatMsg","imgAlert","leaveMsg","leaveNumber","month", "picture", "pictureMenu", "pictureTop", "select", "white"],//独立功能页面
            "user": ["user","addDomain", "about", "addr", "addrEdit","agency","addTag","attestation", "available", "availableList", "balance", "balanceContent", "bandcardEdit","beAgency","beCoreAgency",
                "changeMobile", "changePassword","inviteCodeList","inviteCodeHistory","releaseTagsEdit","myTagsEdit",
                "orderSum", "orderSum2", "orderSumContent", "orderSumContent2","payAgency","payAgencyAffirm","payAgencySuccess","payInviteSuccess","recommend", "recommendContent", "recommendFilter", "recommendFilterContent", "remain", "remainContent",
                "setting", "shipments", "shipmentsAddr", "shipmentsAddrEdit", "userInfo", "withdraw", "withdrawList", "withdrawStep"],//个人中心
            "temp": [],//临时功能、活动页
            "access":["access","findPassword"],//新入口
        },
        //页面路径配置(子功能)
        pathChildConfig: {
            publish: {
                "root": ["publish"],//主页
                "publish": ["myPublish", "myPublishList", "publishInfo", "publishInfoContent", "publishList", "release"],//发布
                "buy": ["boughtAffirm", "myBought", "myBoughtList"],//购买
                "sell": ["mySell", "mySellList", "quote", "quoteInfo", "quoteList", "sellerOrderInfo", "sellerOrderShipments", "sellerRefund", "sellerRefundAddress", "sellerRefundAffirm", "sellerRefuse"]//报价/售出
            }
        },
        //storage初始化配置
        storageConfig: {
            //每次重启app会被重置
            temp: {
                gtLoadingTime: 0,//应用上次启动时间(个推离线推送伪检测)
                disabledAppLogin: false,//版本是否过低，是否禁止用户登录(检测更新)
                repeatPage: 1,//页面重复堆栈产生的id增量信息(打开新win)
                stackCache: {//页面堆栈缓存(用于获取win层级)
                    topPage: "root",//顶层win的id
                    payBackPage:{
                        win:null,
                        frame:null
                    },//支付返回页面缓存id
                }, 
                fetchData: {},//数据同步缓存(app.registerFetch)
                pathUrl: null,//页面解析缓存(首次启动)
                countryMsg: null,//当前站点国家信息(切换站点)
                countryCache:null,//所有站点国家信息
                refundServer: [],//已经发出过客服介入推送的退款id数组(退款申请介入)
                classInfo: {},//商品分类信息(获取商品分类)
                serverIsInit:false,//客服已初始化成功，可以调用
            },
            //仅在第一次进入应用会被重置
            save: {
                resetUserInfo:"0.0.0",//个人信息已重置的版本
                lastCheckUpdate: 0,//上次检测版本更新时间(app.checkUpdate)
                smartUpdateFinishOK:false,//静默修复完成，临时存储的文字
                lastCheckNotTime:0,//应用上次检查通知是否开启时间(app.checkDevNot)
                checkNotJumpVersion:false,//是否跳过每天一次的通知
                user: {//用户个人信息(进入app时会刷新个人信息，登陆完成时更新个人信息)
                    uid: null,//用户id
                    token: null,//token(没有token字段将会被认为是未登录)
                    username: null,//用户昵称
                    mobile: null,//手机号
                    avatar: null,//头像地址
                    email: null,//邮箱
                    areaInfo: null,//居住地
                    account: null,//是否已进行实名认证
                    reg_step: null,//用户资料完善度 1：刚注册 2：通过邀请验证 3：已完善资料
                    member_qq: null,//QQ信息
                    member_wx: null,//微信信息
                    member_type:null,//角色
                    domain:null,//个人店铺信息
                    inviteNum:null,//个人剩余邀请码
                },
                cacheMobile:null,//缓存上次登录时输入的电话号码
                gtAppResume: 0,//应用上次从后台切换到前台时间(个推通知栏点击伪检测)
                hintCache: {//提示缓存(app.openHint方法)
                    shipments: false,//收货人编辑提示
                    country: false,//首页分站选择提示
                    tag: false//个人中心标签设置提示
                },
                publishMsgStatus: {//发布信息红点更新时间（click代表点击时间，msg代表最新消息时间）(我的-求购)
                    publish: {click: parseNowTime, msg: null},  //我发布的-发布中 最新消息更新时间
                    defeat: {click: parseNowTime, msg: null},  //我发布的-未通过 最新消息更新时间
                    past: {click: parseNowTime, msg: null},  //我发布的-已过期 最新消息更新时间
                    sell: {click: parseNowTime, msg: null}   //我出售的-已售出  最新消息更新时间
                },
                searchCache: {//搜索页历史搜索记录缓存(search)
                    order: [],//搜索订单关键字历史记录
                    shopping: [],//搜索商品关键字历史记录
                    publish:[],//搜索求购关键字历史记录
                },
                quick: {//批量付款订单信息(快捷下单临时缓存的id)
                    orders: []//待批量付款的订单列表
                },
                publishAlertIsOpen:false,//是否切换到求购tab过
                // isReadScanInfo:false,//是否已阅读过身份证扫描功能提示
                cacheRelease:null,//发布求购时缓存的收货地区和发货地要求（release）
                cacheQuote:null,//报价时缓存的收货地区和发货地要求（quote）
                serverNewMsg:false,//是否有客服新消息
                // historyReleaseTags:[],//求购的历史标签缓存
            }
        },
        //解析后路径
        pathUrl: {},
        //公共代理页面
        commonAry: ["title", "result", "search"],//共用头部页面集合,它们的winName为公用name+&+要打开的子页面name+"-"+随机数
        //状态栏默认颜色
        statusBarStyle: "dark",//状态栏：默认黑色
        msg: {
            xfText: "2017-04-17",
            xf: new Date("2017-04-17").getTime()
        },
        //分站国家本地信息（通过code与服务器数据对应）
        country: {
            "all": {
                id: "",
                code: "",
                siteId:0,
                name: "全球",
                img: "/image/country/country-logo-all.png"
            },
            // "0081":{
            //     id:"",
            //     code:"0081",
            //     name:"日本",
            //     img: "/image/country/country-all.jpg"
            // },
            // "0082":{
            //     id:"",
            //     code:"0082",
            //     name:"韩国",
            //     img: "/image/country/country-all.jpg"
            // },
            "0081,0082": {
                id: "",
                code: "0081,0082",
                name: "日韩",
                img: "/image/country/country-logo-0081_0082.png",
            },
            "0033,0049": {
                id: "",
                code: "0033,0049",
                name: "德国",
                img: "/image/country/country-logo-0033_0049.png"
            },
            "0061,0064": {
                id: "",
                code: "0061,0064",
                name: "澳新",
                img: "/image/country/country-logo-0061_0064.png"
            },
            "0061": {
                id: "",
                code: "0061",
                name: "澳大利亚",
                img: "/image/country/country-logo-0061.png"
            },
            "0064": {
                id: "",
                code: "0064",
                name: "新西兰",
                img: "/image/country/country-logo-0064.png"
            },
            "0049": {
                id: "",
                code: "0049",
                name: "德国",
                img: "/image/country/country-logo-0049.png"
            },
            "0033": {
                id: "",
                code: "0033",
                name: "法国",
                img: "/image/country/country-logo-0033.png"
            },
            "001": {
                id: "",
                code: "001",
                name: "美国",
                img: "/image/country/country-logo-001.png"
            }
        },
        floatMsgTimeout:4800,//float内部弹窗关闭延时
    };

    /*
     * 初始化页面功能
     * */
    app.ready(function () {
        //0.适配、兼容性处理
        //适配状态栏(#在有header.hd的情况下自动适配状态栏)
        var hd = document.getElementsByClassName("hd");
        if (!!hd.length) {
            app.fixStatusBar(hd[0]);
            if (hd[0].className.indexOf("hd-fix") !== -1) {
                var cs = getComputedStyle(hd[0]);
                var h = parseInt(cs.height) + parseInt(cs.paddingTop) + parseInt(cs.marginTop) + parseInt(cs.borderTopWidth) + parseInt(cs.borderBottomWidth);
                document.getElementsByTagName("body")[0].style.paddingTop = h + "px";
            }
        }
        //1城市图片路径配置
        app._each(app.config.country, function () {
            this.img = api.wgtRootDir + this.img;
        });
        //2.页面路径配置(将路径属性pathConfig转化为索引对象pathUrl)
        var pathUrl = app.getStorage("pathUrl");
        if (pathUrl) {
            app.config.pathUrl = pathUrl;
        }
        //3.返回键设置 #除了主页面和main，login其他页面都是执行goBack操作来关闭页面
        if (app.inArray(api.winName,app.config.basePage)) {
            //原来为双击退出
            // var keyBackMack = 0;
            // api.addEventListener({name: "keyback"}, function () {
            //     if (new Date().getTime() - keyBackMack < 2000) {
            //         api.closeWidget({silent: true});
            //         return false;
            //     }
            //     keyBackMack = new Date().getTime();
            //     api.toast({
            //         msg: '再次点击退出程序',
            //         duration: "2500"
            //     });
            // });
            //现在改为单击退出到后台
            api.addEventListener({name: "keyback"}, function () {
                api.toLauncher();
            });
        }
        else {
            api.addEventListener({name: "keyback"}, function () {
                app.goBack();
            });
        }
        //4.页面元素事件预先绑定
        app.setGo();
        //5.功能
        //执行提前触发的页面fire（在页面app.ready中绑定事件之前触发，那么会收集在ready之后一起触发，避免创建页面后无法掌握fire调用时机）
        if (app.isArray(window.appTriggerCache)) {
            var ary = window.appTriggerCache;
            app.fireReady = function () {
                app._for(ary, function (i) {
                    if (app.listen.events[ary[i][0]] !== undefined) {
                        app.trigger(ary[i][0], ary[i][1]);
                    }
                });
                window.appTriggerCache = undefined;
            }
        }
        //上面的提前fire在ios下有问题，打开窗口100ms内没有window对象，所以使用pageParam的_initFire参数来执行这些提前的fire(以后调整)
        if (api.pageParam._initFire && api.pageParam._initFire.length) {
            app.fireReady = function () {
                app._for(api.pageParam._initFire, function (i) {
                    !api.pageParam._initFire[i].win&&(api.pageParam._initFire[i].win=api.winName);//没有传入win代表在本窗口环境下
                    app.fire(api.pageParam._initFire[i])
                });
            };
        }
        //6.框架传参、堆栈功能初始化
        //监听数据跨页面刷新
        app.listenAll("fetchDataChange-"+api.winName,function(ret){
            var param=ret.value||{};
            app._localFetchCall[param.type]&&app._localFetchCall[param.type](param.data);
        });
        if(app.isWin()){
            //窗口切换时,检测跨页面数据是否同步
            app.listenExpose(function(){
                //检测本页面是否应该刷新
                setTimeout(function(){
                    app.examineFetchHandle();
                },360);//连续返回时避免此操作
                //缓存本页面id为顶层页面
                if(!api.frameName){
                    var stackCacheStg=app.getStorage("stackCache");
                    stackCacheStg.topPage=api.winName;
                    app.setStorage("stackCache",stackCacheStg);
                }
            });
            //为本页面listen openFloatMsg 事件，用于顶层win弹窗
            app.listen("openFloatMsg",function(p){
                app.openFloatMsg(p.title,p.content,function(){
                    if(p.msg){
                        //消息
                        app.adaptMsg(p.msg.id,p.msg.code,p.msg.ext);
                    }
                    else if(p.im){
                        //客服
                        app.charIm(p.im,"normal");
                    }
                });
            });
            //退出到后台关闭客服窗口
            api.addEventListener({
                name:'pause'
            }, function(ret, err){
                app.closeChar();
            });
        }
        else {
            //设置窗口内部事件主页面
            if(api.pageParam._fireWinMain){
                app._fireWinMain=api.pageParam._fireWinMain;
            }
        }
        //本页面 是否是由win直接打开的页面
        app.isAlone= !!(api.pageParam._lastPage&&api.pageParam._lastPage.alone);
        //7.百度统计页面 打开关闭
        //ps:在closeToWin时跳过的页面无法统计关闭时间
        //ps:被重复打开的页面会在关闭第一次时统计关闭
        if(api.pageParam&&api.pageParam._category){
            app.tjPage(api.pageParam._category);
        }
    });
})(window.app || (window.app = {}));
