/*
 * 工具
 * *a>template整合,测试、报错方法
 * *b>工具函数
 * *c>dom操作封装
 * *d>继承$.api对象
 * 
 * *e>ui控件,页面插件,二次封装api功能等
 * *f>独立页面功能封装
 * */
(function(app){
    /*
     * 打印测试数据
     * */
    window.test = app.test = function () {
        if(window.app&&window.app.config&&window.app.config.notTest){
            return false;
        }
        var r = "";
        for (var i = 0; i < arguments.length; i++) {
            if (typeof arguments[i] === "object") {
                r = JSON.stringify(arguments[i]);
            }
            else if (typeof arguments[i] === "function") {
                r = arguments[i].toString();
            }
            else {
                r = arguments[i];
            }
            alert(Object.prototype.toString.call(arguments[i]).slice(8, -1) + ":" + r);
        }
    };
    /*
     * 处理报错
     * */
    window.exportError = app.exportError =function (er){
        throw Error(er);
    };
    /*
    * 设置时间节点
    * */
    window.sdd=app.sdd=function(){
        app.sdt._start=new Date().getTime();
    };
    /*
     * 弹出时间节点
     * attr:_start 开始时间
     * ps:用于打印时间间隔
     * */
    window.sdt = app.sdt =function(){
        var startDate=app.sdt._start;
        if(startDate===undefined){
            app.sdt._start=new Date().getTime();
        }
        else {
            test(new Date().getTime()-startDate)
        }
    };
    /*
    * a>模板
    * */
    /*
     * 添加arttemplate.js模板,整合到api.template中
     * API:https://github.com/aui/artTemplate
     */
    !function(e){"use strict";var n=function(e,r){return n["string"==typeof r?"compile":"render"].apply(n,arguments)};n.version="2.0.3",n.openTag="<%",n.closeTag="%>",n.isEscape=!0,n.isCompress=!1,n.parser=null,n.render=function(e,r){var t=n.get(e)||i({id:e,name:"Render Error",message:"No Template"});return t(r)},n.compile=function(e,t){function a(r){try{return new s(r,e)+""}catch(o){return u?i(o)():n.compile(e,t,!0)(r)}}var c=arguments,u=c[2],l="anonymous";"string"!=typeof t&&(u=c[1],t=c[0],e=l);try{var s=o(e,t,u)}catch(p){return p.id=e||t,p.name="Syntax Error",i(p)}return a.prototype=s.prototype,a.toString=function(){return s.toString()},e!==l&&(r[e]=a),a};var r=n.cache={},t=n.helpers=function(){var e=function(n,r){return"string"!=typeof n&&(r=typeof n,"number"===r?n+="":n="function"===r?e(n.call(n)):""),n},r={"<":"&#60;",">":"&#62;",'"':"&#34;","'":"&#39;","&":"&#38;"},t=function(n){return e(n).replace(/&(?![\w#]+;)|[<>"']/g,function(e){return r[e]})},i=Array.isArray||function(e){return"[object Array]"==={}.toString.call(e)},o=function(e,n){if(i(e))for(var r=0,t=e.length;t>r;r++)n.call(e,e[r],r,e);else for(r in e)n.call(e,e[r],r)};return{$include:n.render,$string:e,$escape:t,$each:o}}();n.helper=function(e,n){t[e]=n},n.onerror=function(n){var r="Template Error\n\n";for(var t in n)r+="<"+t+">\n"+n[t]+"\n\n";e.console&&console.error(r)},n.get=function(t){var i;if(r.hasOwnProperty(t))i=r[t];else if("document"in e){var o=document.getElementById(t);if(o){var a=o.value||o.innerHTML;i=n.compile(t,a.replace(/^\s*|\s*$/g,""))}}return i};var i=function(e){return n.onerror(e),function(){return"{Template Error}"}},o=function(){var e=t.$each,r="break,case,catch,continue,debugger,default,delete,do,else,false,finally,for,function,if,in,instanceof,new,null,return,switch,this,throw,true,try,typeof,var,void,while,with,abstract,boolean,byte,char,class,const,double,enum,export,extends,final,float,goto,implements,import,int,interface,long,native,package,private,protected,public,short,static,super,synchronized,throws,transient,volatile,arguments,let,yield,undefined",i=/\/\*[\w\W]*?\*\/|\/\/[^\n]*\n|\/\/[^\n]*$|"(?:[^"\\]|\\[\w\W])*"|'(?:[^'\\]|\\[\w\W])*'|[\s\t\n]*\.[\s\t\n]*[$\w\.]+/g,o=/[^\w$]+/g,a=new RegExp(["\\b"+r.replace(/,/g,"\\b|\\b")+"\\b"].join("|"),"g"),c=/^\d[^,]*|,\d[^,]*/g,u=/^,+|,+$/g,l=function(e){return e.replace(i,"").replace(o,",").replace(a,"").replace(c,"").replace(u,"").split(/^$|,+/)};return function(r,i,o){function a(e){return m+=e.split(/\n/).length-1,n.isCompress&&(e=e.replace(/[\n\r\t\s]+/g," ").replace(/<!--.*?-->/g,"")),e&&(e=x[1]+p(e)+x[2]+"\n"),e}function c(e){var r=m;if($?e=$(e):o&&(e=e.replace(/\n/g,function(){return m++,"$line="+m+";"})),0===e.indexOf("=")){var i=!/^=[=#]/.test(e);if(e=e.replace(/^=[=#]?|[\s;]*$/g,""),i&&n.isEscape){var a=e.replace(/\s*\([^\)]+\)/,"");t.hasOwnProperty(a)||/^(include|print)$/.test(a)||(e="$escape("+e+")")}else e="$string("+e+")";e=x[1]+e+x[2]}return o&&(e="$line="+r+";"+e),u(e),e+"\n"}function u(n){n=l(n),e(n,function(e){y.hasOwnProperty(e)||(s(e),y[e]=!0)})}function s(e){var n;"print"===e?n=T:"include"===e?(v.$include=t.$include,n=O):(n="$data."+e,t.hasOwnProperty(e)&&(v[e]=t[e],n=0===e.indexOf("$")?"$helpers."+e:n+"===undefined?$helpers."+e+":"+n)),w+=e+"="+n+","}function p(e){return"'"+e.replace(/('|\\)/g,"\\$1").replace(/\r/g,"\\r").replace(/\n/g,"\\n")+"'"}var f=n.openTag,d=n.closeTag,$=n.parser,g=i,h="",m=1,y={$data:1,$id:1,$helpers:1,$out:1,$line:1},v={},w="var $helpers=this,"+(o?"$line=0,":""),b="".trim,x=b?["$out='';","$out+=",";","$out"]:["$out=[];","$out.push(",");","$out.join('')"],E=b?"$out+=$text;return $text;":"$out.push($text);",T="function($text){"+E+"}",O="function(id,data){data=data||$data;var $text=$helpers.$include(id,data,$id);"+E+"}";e(g.split(f),function(e){e=e.split(d);var n=e[0],r=e[1];1===e.length?h+=a(n):(h+=c(n),r&&(h+=a(r)))}),g=h,o&&(g="try{"+g+"}catch(e){"+"throw {"+"id:$id,"+"name:'Render Error',"+"message:e.message,"+"line:$line,"+"source:"+p(i)+".split(/\\n/)[$line-1].replace(/^[\\s\\t]+/,'')"+"};"+"}"),g=w+x[0]+g+"return new String("+x[3]+");";try{var S=new Function("$data","$id",g);return S.prototype=v,S}catch(P){throw P.temp="function anonymous($data,$id) {"+g+"}",P}}}();"function"==typeof define?define(function(){return n}):"undefined"!=typeof exports&&(module.exports=n),e.template=n}(this);
    app.template = window.template;
    /*
     * 设置api加载完成回调
     * attr: queue 待执行函数队列
     * ps:所有使用api对象的操作都要在ready内调用,可以调用多个ready，会按顺序执行
     *
     */
    app.ready = function (readyFn) {
        if (typeof readyFn !== "function") {
            return this;
        }
        if (window.api !== undefined) {
            readyFn();
        }
        else if (this.ready.queue === undefined) {
            this.ready.queue = [readyFn];
            window.apiready = function () {
                app._for(app.ready.queue, function (i) {
                    app.ready.queue[i]();
                });
                app.fireReady !== undefined && app.fireReady();
            }
        }
        else {
            this.ready.queue.push(readyFn);
        }
        return this;
    };
    /*
     * b>工具函数
     * */
    //验证对象类型
    app.dataType = function (o) {
        if (o === null) {
            return "Null";
        }
        if (o === undefined) {
            return "Undefined";
        }
        if (typeof o === "number") {
            return isNaN(o) ? "NaN" : "Number";
        }
        return Object.prototype.toString.call(o).slice(8, -1);
    };
    //对象是否为数组
    app.isArray = function (o) {
        return Object.prototype.toString.call(o).slice(8, -1) === "Array";
    };
    //对象是否为自定义对象
    app.isObj = function (o) {
        return Object.prototype.toString.call(o).slice(8, -1) === "Object";
    };
    //验证目标对象是否在数组内
    app.inArray = function (t, ary) {
        var mack=0;
        app._for(ary, function (i) {
            ary[i] === t && (mack =i+1);
        });
        return mack;
    };
    //对象遍历操作代理
    app._each = function (o, fn) {
        for (var i in o) {
            if (fn.call(o[i], i) === "break") {
                break;
            }
        }
        return this;
    };
    //数组循环操作代理
    app._for = function (ary, fn) {
        for (var i = 0; i < ary.length; i++) {
            if (fn.call(ary[i], i) === "break") {
                break;
            }
        }
        return this;
    };
    //转化为json
    app.toJson = function (str) {
        var o = {};
        try {
            o = JSON.parse(str);
        }
        catch (e) {
        }
        return o;
    };
    //转化为str
    app.toStr = function (json) {
        var o = {};
        try {
            o = JSON.stringify(json);
        }
        catch (e) {
        }
        return o;
    };
    //条件定时器(函数，间隔，结束条件（次数/判断函数）,结束回调)
    app.interval = function (f, i, h, e) {
        var fn = function () {
            count++;
            f(count);
            return false;
        }, it = null, count = 0;
        if (typeof (h) === "number") {
            fn = function () {
                count++;
                f(count);
                return count === h;
            }
        }
        else if (typeof (h) === "function") {
            fn = function () {
                count++;
                f(count);
                return !!h(count)
            }
        }
        it = setTimeout(function () {
            if (!fn()) {
                it = setTimeout(arguments.callee, i);
            }
            else {
                typeof e === "function" && e();
            }
        }, i);
        return function () {
            clearTimeout(it);
        };
    };
    /*
     * c>dom操作
     * */
    //插入样式表
    app.insertSheet = function (styles) {
        var stylesheetObj, styleElement;
        var rid = "insertStyle" + (Math.random() + "").slice(2);
        if (document.createStyleSheet) {
            stylesheetObj = document.createStyleSheet();
            styleElement = stylesheetObj.owningElement;
            styleElement.id = rid;
        }
        else {
            styleElement = document.createElement("style");
            styleElement.id = rid;
            document.getElementsByTagName("head")[0].appendChild(styleElement);
            stylesheetObj = styleElement.sheet;

        }
        if (typeof styles === "string") {
            console.log(stylesheetObj.cssText)
            stylesheetObj.cssText !== undefined ? (stylesheetObj.cssText = styles) : (styleElement.innerHTML = styles);
        }
        else if (typeof styles === "object") {
            if (stylesheetObj.insertRule) {
                for (var i in styles) {
                    stylesheetObj.insertRule(i + " {" + styles[i] + "}", stylesheetObj.cssRules.length);
                }
            }
            else {
                for (var i in styles) {
                    stylesheetObj.addRule(i, styles[i], stylesheetObj.rules.length);
                }
            }
        }
        return styleElement;
    };
    //禁止窗口滚动(true：锁定窗口 false：解锁窗口)
    app.lockWin = (function (w) {
        var eType = document.addEventListener !== undefined;
        var lockWin, lockKeyWin;
        //禁用窗口滚动事件
        lockWin = function (e) {
            e.preventDefault && e.preventDefault();
            e.returnValue = false;
            return false
        };
        //禁用上下左右 pagedown等翻页键
        lockKeyWin = function (e) {
            if (e.keyCode && e.keyCode > 32 && e.keyCode < 41) {
                e.preventDefault && e.preventDefault();
                return false
            }
            return true
        };
        return function (b) {
            //确定绑定还是解绑
            var method = !!b ? (eType ? "addEventListener" : "attachEvent") : (eType ? "removeEventListener" : "detachEvent");
            //兼容性
            if (eType) {
                //火狐鼠标滚轮事件
                window[method]("DOMMouseScroll", lockWin, false);
                //ie9+,chrome滚轮事件
                window[method]("mousewheel", lockWin, false);
                //手机touch事件
                window[method]("touchmove", lockWin, false);
                //ios touch事件
                window[method]("touchstart", lockWin, false);
                //键盘输入滚动事件
                document[method]("keydown", lockKeyWin, false);
            }
            else {
                document[method]("onmousewheel", lockWin);
                document[method]("onkeydown", lockKeyWin);
            }
            return this;
        };
    })(window);
    //获取目标对象在窗口中的位置（可能适用于滚动加载图片）
    app.offset = function (el) {
        var sl = Math.max(document.documentElement.scrollLeft, document.body.scrollLeft);
        var st = Math.max(document.documentElement.scrollTop, document.body.scrollTop);

        var rect = el.getBoundingClientRect();
        return {
            l: rect.left + sl,
            t: rect.top + st,
            w: el.offsetWidth,
            h: el.offsetHeight
        };
    };
    //为节点设置长按事件(节点选择器，事件函数  默认延迟为1s,允许位移区域为0)
    app.setTouchLongClick=function(el,fn,closeBounce){
        var allDom=$(""+el);
        if(allDom.length){
            allDom.each(function(){
                var dom=$(this);
                if(dom.hasClass("btn_has_init")){
                    return false;
                }
                var cacheInterval=null,cacheTime=0;//点击状态
                dom[0].addEventListener("touchstart",function(e){
                    // e.preventDefault();
                    // e.stopPropagation();
                    cacheTime=new Date().getTime();
                    cacheInterval=setTimeout(function(){
                        typeof fn==="function"&&fn(dom);
                        cacheInterval=null;
                    },800);
                    if(closeBounce){//强制关闭下拉刷新
                        api.setFrameAttr({
                            bounces: false
                        });
                    }
                },true);
                dom[0].addEventListener("touchmove",function(e){
                    // e.stopPropagation();
                    if(closeBounce){
                        api.setFrameAttr({
                            bounces: true
                        });
                    }
                    if(cacheInterval){
                        clearTimeout(cacheInterval);
                        cacheInterval=null;
                    }
                },true);
                dom[0].addEventListener("touchend",function(e){
                    if(closeBounce){//重新开启下拉刷新
                        api.setFrameAttr({
                            bounces: true
                        });
                    }
                    if(cacheInterval){
                        clearTimeout(cacheInterval);
                        cacheInterval=null;
                        return true;
                    }
                    else {
                        e.stopPropagation();
                        return false;
                    }
                },true);
            }).addClass("btn_has_init");
        }
        return this;
    };


    /*
     * 初始化slideWrapper的滑动效果
     *
     * ps:html结构请使用.slide-wrapper>.slide-content+.slide-delete结构
     * */
    app.initSlideWrapper=function(selector,closeBounce){
        var allWp=$(selector+":not(.wrapper_has_init)");
        allWp.each(function(){
            var _wp=$(this);
            if(_wp.hasClass("wrapper_has_init")){
                return false;
            }
            var option={
                closeBounce:false,
                isFirstMove:true,
                canComplete:true,
                startX:null,
                startY:null,
                nowX:null,
                nowY:null,
                outWidth:15,//额外允许偏移位置
                angle:1,//初始偏移量 y/x不大于此值时判定为左右滚动，阻止浏览器默认上下滑动
                state:0,//所处状态 1：展开 0：收缩
            };
            _wp.on("touchstart",tStart(option,_wp));
            _wp.on("touchmove",tMove(option,_wp));
            _wp.on("touchend",tEnd(option,_wp));
        }).addClass("wrapper_has_init");

        function tStart (t,o){
            return function(e){
                t.startX=t.nowX=e.touches[0].clientX;
                t.startY=t.nowY=e.touches[0].clientY;
            }
        }
        function tMove (t,o){
            return function(e){
                var moveX,moveY;
                if(t.canComplete){
                    t.nowX=e.touches[0].clientX;
                    t.nowY=e.touches[0].clientY;
                    moveX=t.nowX-t.startX;
                    moveY=t.nowY-t.startY;
                }
                if(t.isFirstMove){
                    t.isFirstMove=false;
                    if(Math.abs(moveY/moveX)>t.angle){
                        t.canComplete=false;
                    }
                    else {
                        //关闭坑爹的下拉弹动
                        if(closeBounce&&!t.closeBounce){
                            t.closeBounce=true;
                            api.setFrameAttr({
                                bounces: false
                            });
                        }
                        return false;
                    }
                }
                if(t.canComplete){
                    e.preventDefault();
                    //根据偏移量设定实际偏移量
                    if(t.state){
                        if(moveX<0-t.outWidth){
                            moveX=0-t.outWidth;
                        }
                        else if(moveX>60+t.outWidth){
                            moveX=60+t.outWidth;
                        }
                    }
                    else {
                        if(moveX<-60-t.outWidth){
                            moveX=-60-t.outWidth
                        }
                        else if(moveX>t.outWidth){
                            moveX=t.outWidth;
                        }
                    }
                    moveX=t.state?moveX-60:moveX;
                    setTranslateX(o,moveX);
                }
            }
        }
        function tEnd (t,o){
            return function(e){
                if(t.canComplete){
                    var moveX=t.nowX-t.startX;
                    moveX=t.state?moveX-60:moveX;
                    var endState=null;
                    if(moveX<-30){
                        //展开
                        toTranslateX(o,-60);
                        endState=1;
                    }
                    else {
                        //关闭
                        toTranslateX(o,0);
                        endState=0;
                    }
                    //阻止后续touchend事件
                    e.preventDefault();
                    e.stopPropagation();
                    //重新开启坑爹的下拉弹动
                    if(closeBounce&&t.closeBounce){
                        t.closeBounce=false;
                        api.setFrameAttr({
                            bounces: true
                        });
                    }
                }
                else {
                    setTranslateX(o,t.state?-60:0);
                }
                //重置变量
                t.isFirstMove=t.canComplete=true;
                t.startX=t.startY=t.nowX=t.nowY=null;
                t.state=endState;
                return !t.canComplete;
            }
        }
        function setTranslateX(o,x){
            o.css({
                "transition":"none",
                "-webkit-transition":"none",
                "transform":"translate3d("+x+"px,0,0)",
                "-webkit-transform":"-webkit-translate3d("+x+"px,0,0)"
            });
        }
        function toTranslateX(o,x){
            o.css({
                "transition":"transform .05s ease-out",
                "-webkit-transition":"-webkit-transform .05s ease-out",
                "transform":"translate3d("+x+"px,0,0)",
                "-webkit-transform":"-webkit-translate3d("+x+"px,0,0)"
            });
        }
        return this;
    };

    /*
     * 将js目录下的js文件加载到页面中
     * link:相对于 script文件夹内部的地址
     * call:js onload时的回调
     * ps:取得相对路径是基于页面中main.js引入的路径，如果获取不到，则只有取wgtRootDir
     * */
    app.loadJs=function(link,call){
        var bd=$("body");
        var allJs=bd.find("script");
        var prefix=null;
        allJs.each(function(){
            var _t=$(this);
            var _m=_t.attr("src").replace(/(^\s)|(\s$)/g,"");
            if(_m.match(/\/script\/main.js$/)){
                prefix= _m.replace(/\/script\/main.js$/,"");
            }
        });
        if(!prefix){
            prefix= api.wgtRootDir;
        }
        var jsLink=prefix+"/script/"+link;
        var scriptNode=document.createElement("script");
        scriptNode.onload=function(){
            call();
        };
        scriptNode.src=jsLink;
        bd.append($(scriptNode));
    };

    /*
     * d>复制官方提供的$api对象的一些方法
     * */

    /*
     * 检测设备
     * */
    app.isAndrod = (/android/gi).test(navigator.appVersion);
    app.isIos = !app.isAndrod;
    app.isHuawei=(/HUAWEI/gi).test(navigator.userAgent);//华为手机真不错,每天一个新BUG,要问为啥这么多,你问我又问哪个
    //获取版本设备
    app.getVer= function(){
        var n=Number(api.systemVersion.replace(".")[0]);
        return isNaN(n)?-1:n;
    };
    /*
     * 检测窗口类型
     * */
    app.isWin = function(){return !api.frameName};
    app.isFrame = function(){return !!api.frameName};
    /*
     * 本地存储操作 #app中的storage对象操作规则位于log/storage.js内
     * */
    /*初始化stg对象*/
    app.uzStorage = function () {
        var ls = window.localStorage;
        if (this.isAndrod) {
            ls = os.localStorage();
        }
        return ls;
    };
    /*设置storage*/
    /*ps:官方这里留了个坑，仅能保存string和Object，这里手动添加了布尔值和数字的判断*/
    app.setStorage = function (key, value) {
        if (arguments.length === 2) {
            var v = value;
            if (typeof v == 'object') {
                v = JSON.stringify(v);
                v = 'obj-' + v;
            }
            else if(typeof v== 'number'&&!isNaN(v)){
                v = 'num-' + v;
            }
            else if(typeof v== 'boolean'){
                v = 'bol-' + v;
            }
            else {
                v = 'str-' + v;
            }
            var ls = this.uzStorage();
            if (ls) {
                ls.setItem(key, v);
            }
        }
        return this;
    };
    /*获取storage*/
    app.getStorage = function (key) {
        var ls = this.uzStorage();
        if (ls) {
            var v = ls.getItem(key);
            if (!v) { 
                return;
            }
            if (v.indexOf('obj-') === 0) {
                v = v.slice(4);
                return JSON.parse(v);
            }
            else if(v.indexOf('num-') === 0){
                v = v.slice(4);
                return Number(v);
            }
            else if(v.indexOf('bol-') === 0){
                v = v.slice(4);
                return v==="true";
            }
            else if (v.indexOf('str-') === 0) {
                return v.slice(4);
            }
        }
        return this;
    };
    /*移除storage*/
    app.removeStorage = function (key) {
        var ls = this.uzStorage();
        if (ls && key) {
            ls.removeItem(key);
        }
        return this;
    };
    /*清除所有storage*/
    app.clearStorage = function () {
        var ls = this.uzStorage();
        if (ls) {
            ls.clear();
        }
        return this;
    };

    /*
     * 状态栏适配
     * */
    /*沉浸状态栏适配 ios*/
    app.fixIos7Bar = function (el) {
        if (typeof el === "string") {
            el = document.getElementById(el);
        }
        var strDM = api.systemType;
        if (strDM == 'ios') {
            var strSV = api.systemVersion;
            var numSV = parseInt(strSV, 10);
            var fullScreen = api.fullScreen;
            var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
            if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
                el.style.paddingTop = '20px';
            }
        }
        return this;
    };
    /*沉浸状态栏适配 ios/android */
    app.fixStatusBar = function (el) {
        if (typeof el === "string") {
            el = document.getElementById(el);
        }
        var sysType = api.systemType;
        if (sysType == 'ios') {
            app.fixIos7Bar(el);
        } else if (sysType == 'android') {
            var ver = api.systemVersion;
            ver = parseFloat(ver);
            if (ver >= 4.4) {
                el.style.paddingTop = '25px';
            }
        }
        return this;
    };
    /*获取沉浸栏高度*/
    app.getStatusBarHeight = function () {
        var sysType = api.systemType;
        if (sysType == 'ios') {
            var strSV = api.systemVersion;
            var numSV = parseInt(strSV, 10);
            var fullScreen = api.fullScreen;
            var iOS7StatusBarAppearance = api.iOS7StatusBarAppearance;
            if (numSV >= 7 && !fullScreen && iOS7StatusBarAppearance) {
                return 20;
            }
        } else if (sysType == 'android') {
            var ver = api.systemVersion;
            ver = parseFloat(ver);
            if (ver >= 4.4) {
                return 25;
            }
        }
        return 0
    };

    /*
    * e>二次封装api功能,模块功能
    * */

    /*
     * 调用展开底部弹出按钮
     * param:param:title：弹出的标题
     *             list：列表对象{文字描述：点击后执行函数}
     *             cancelTitle：取消按钮的文字
     * */
    app.showActionSheet = function (param) {
        var callBox = [null];
        var opt = {
            cancelTitle: "取消",
            style: {}
        };
        if (param.title) {
            opt["title"] = String(param.title);
        }
        if (app.isObj(param.list)) {
            opt.buttons = [];
            for (var i in param.list) {
                opt.buttons.push(i);
                callBox.push(param.list[i]);
            }
        }
        api.actionSheet(opt, function (r, e) {
            if (r) {
                var index = r.buttonIndex;
                if (index === callBox.length) {
                    //取消操作
                }
                else {
                    callBox[index]();
                }
            }

        });
    };
    /*
     * 调用复制功能(首先，你需要添加clipBoard模块)
     * param:text:复制的文字
     *       call:复制回调 arguments>state:true/false
     *                               msg:复制成功/复制失败
     *       showState:是否提醒
     * */
    app.copyText = function (text, call, showState) {
        if (text) {
            if (!app.copyText.module) {
                app.copyText.module = api.require("clipBoard");
            }
            var cb = app.copyText.module;
            cb.set({value: String(text)}, function (r, e) {
                if (r.status) {
                    showState && app.toast("复制成功！");
                    typeof call === "function" && call(true, "复制成功");
                }
                else {
                    showState && app.toast("复制失败！");
                    typeof call === "function" && call(false, "复制失败");
                }
            });
        }
    };
    /* 
     * 调用下载单个文件功能
     * param:url:文件地址
     *       call:下载成功回调 arguments:state:true/false
     *                                  data:成功保存的地址/失败原因
     *       showHint:是否显示成功或提示
     * */
    app.download = function (url, call, showHint) {
        if (url) {
            api.download({
                url: url,
                report: false,
                allowResume: true
            }, function (r, e) {
                if (r && r.state == 1) {
                    var savePath = r["savePath"];
                    showHint && app.toast("下载图片成功,图片保存在" + savePath);
                    call && typeof call === "function" && call(true, savePath);
                } else {
                    showHint && app.toast("下载失败");
                    call && typeof call === "function" && call(false, e["msg"]);
                }
            });
        }
    };
    /*
     * 调用下载多文件到相册功能
     * param:ary:文件地址数组(字符串)
     *       call:下载并保存完成回调 >arguments:state:true/false
     *                                         success:成功数量
     *                                         defeat:失败数量
     *                                         data:"您的相册中"/失败提示
     * ps:只要没有全部失败都会判断为成功
     *  */
    app.downloadAry = function (ary, call) {
        var len = ary.length;
        if (len) {
            var sc = 0, df = 0, c = 0, ps = [];
            app._for(ary, function (i) {
                app.download(String(ary[i]), function (state, msg) {
                    c++;
                    if (state) {
                        sc++;
                        ps.push(msg);
                    }
                    else {
                        df++;
                    }
                    if (len === c) {
                        app.saveToPA(ps, call);
                    }
                });
            }, true);
        }
        else {
            call(false, 0, 0, "没有要下载的图片");
        }
    };
    /*
     * 调用保存到相册功能
     * param:ary:文件数组 
     *       call:保存完成回调 >arguments:state:true/false
     *                                         success:成功数量
     *                                         defeat:失败数量
     *                                         data:"您的相册中"/失败提示
     * */
    app.saveToPA = function (ary, call) {
        var times = 0, sc = 0, de = 0;
        var fn = function () {
            if (times < ary.length) {
                if (typeof ary[times] === "string") {
                    api.saveMediaToAlbum({
                        path: ary[times]
                    }, function (r, e) {
                        if (r.status) {
                            sc++;
                        }
                        else {
                            de++;
                        }
                        fn();
                    });
                }
                else {
                    de++;
                    fn();
                }
                times++;
            }
            else if (times === ary.length) {
                call && typeof call === "function" && call(sc !== 0, sc, de, sc !== 0 ? "您的相册中 " : "保存失败");
            }
        };
        fn();
    };
//批量压缩图片
//图片数组，压缩程度1-10 回调
//返回值 state：成功/失败 ary成功压缩后的数组
// app.compactPic=function(urlAry,size,call){
//     var cpMd=app.compactPic._compactPictureMd;
//     if(!cpMd){
//         cpMd=app.compactPic._compactPictureMd=api.require("compactPicture");
//     }
//     if(app.isArray(urlAry)){
//         cpMd.HittingPic({
//             picpatharray:urlAry,
//             size:size||4
//         },function(ret){
//             call(!!ret.states,ret.states);
//         });
//     }
// }
    /*
     * 缓存图片
     * param:img:图片或图片数组
     * */
    app.imgCache = function (img) {
        if (typeof img === "string") {
            api.imageCache({
                url: img
            });
        }
        else if (app.isArray(img)) {
            app._for(img, function (i) {
                api.imageCache({
                    url: String(img[i])
                });
            });
        }
        return this;
    };
    /*
     * 获取本地图片
     * param:opt 参数 attr>type:"调用方式（library,camera)"
     *                     size:[]压缩大小
     *                     edit:是否可以裁剪（大部分机型无效，无视此参数）
     *       call:选择后回调 arguments>data:查API去 忘了
     * */
    app.getPic = function (opt, call) {
        var option = $.extend({
            type: "library",
            size: [],
            edit: false
        }, opt);
        var callBack = function (r, e) {
            if (e) {
                // app.toast(app.toStr(e));
            }
            else {
                if (r.data !== "") {
                    call(r.data);
                }
            }
        };
        var param = {
            sourceType: option.type,
            mediaValue: "pic",
            destinationType: "url",
            allowEdit: !!option.edit,
            quality: 100,
            saveToPhotoAlbum: false
        };
        if (app.dataType(option.size[0]) === "Number") {
            param.targetWidth = option.size[0];
        }
        if (app.dataType(option.size[1]) === "Number") {
            param.targetHeight = option.size[1];
        }
        api.getPicture(param, callBack);
    };
    /*
    * 调用多种分享功能
    * md:wx,qq,sina
    * */
    app.shareSomething=function(opt,type){
        var option={
            title:"",
            text:"",
            url:"",
            img:"",
            qqImg:""//QQ这逗逼必须分享网络图片
        };
        if(app.isObj(opt)){
            $.extend(true,option,opt);
        }
        else {
            throw Error("分享参数错误");
        }
        var wxMd,qqMd,sinaMd;//md
        var shareList={
            list:{
                "微信好友":function(){
                    if(!wxMd){
                        wxMd=api.require("wx");
                    }
                    //检测是否装有微信
                    wxMd.isInstalled(function(r,e){
                        if(r.installed){
                            wxMd.shareWebpage({
                                scene:"session",
                                title:option.title,
                                description:option.text,
                                thumb: option.img,
                                contentUrl:option.url
                            },function(r,e){
                                if(r.status){
                                    app.toast("分享成功");
                                }
                                else{
                                    app.toast("分享失败")
                                }
                            });
                        }
                        else {
                            app.toast('当前设备未安装微信客户端');
                        }
                    });
                },
                "朋友圈":function(){
                    if(!wxMd){
                        wxMd=api.require("wx");
                    }
                    //检测是否装有微信
                    wxMd.isInstalled(function(r,e){
                        if(r.installed){
                            wxMd.shareWebpage({
                                scene:"timeline",
                                title:option.title,
                                description:option.text,
                                thumb: option.img,
                                contentUrl:option.url
                            },function(r,e){
                                if(r.status){
                                    app.toast("分享成功");
                                }
                                else{
                                    app.toast("分享失败")
                                }
                            });
                        }
                        else {
                            app.toast('当前设备未安装微信客户端');
                        }
                    });
                },
                "新浪微博":function(){
                    if(!sinaMd){
                        sinaMd=api.require("weibo");
                    }
                    sinaMd.shareWebPage({
                        title:option.title,
                        text:option.text,
                        thumb:option.img,
                        contentUrl:option.url
                    },function(r,e){
                        if(r.status){
                            app.toast("分享成功");
                        }
                        else{
                            app.toast("分享失败")
                        }
                    });
                },
                "QQ":function(){
                    if(!qqMd){
                        qqMd=api.require("qq");
                    }
                    qqMd.installed(function(ret,err){
                        if(ret.status){
                            qqMd.shareNews({
                                url:option.url,
                                title:option.title,
                                description:option.text,
                                imgUrl:option.qqImg,
                                type:"QFriend"
                            },function(){
                                //android不支持回调
                            });
                        }else{
                            app.toast('当前设备未安装QQ');
                        }
                    });
                },
                "复制链接":function(){
                    app.copyText(option.url,function(state){
                        if(state){
                            app.toast("复制成功，已复制链接到剪贴板");
                        }
                    },false);
                }
            }
        };
        if(!type||type==="all"){
            app.showActionSheet(shareList);
        }
        else if(shareList["list"][type]){
            app.showActionSheet({
                list:shareList["list"][type]
            });
        }
    };


    /*
     ui控件封装
     */
    /*
     * alert弹窗
     * param(1):option:原来api.alert方法传入的参数
     * param(2):msg:提示文字
     *          call:确认后回调
     * */
    app.alert = function () {
        var opt = {
            title: "提示",
            msg: "",
            buttons: ["确定"]
        };
        var call;
        if (typeof arguments[0] === "object") {
            opt = $.extend(true, opt, arguments[0]);
        }
        else if (arguments.length === 1) {
            opt.msg = String(arguments[0]);
        }
        else if (arguments.length === 2) {
            if (typeof arguments[1] === "function") {
                opt.msg = String(arguments[0]);
                call = arguments[1];
                api.alert(opt, call);
                return this;
            }
            else {
                opt.title = String(arguments[0]);
                opt.msg = String(arguments[0]);
            }
        }
        api.alert(opt);
        return this;
    };
    /* confirm弹窗
     * param(1):option:原来api.alert方法传入的参数
     * param(2):msg:提示文字
     *          call:确认后回调
     * */
    app.confirm = function () {
        var opt = {
            title: "提示",
            msg: "",
            buttons: ["取消", "确定"]
        };
        var call;
        call = arguments[1];
        if (typeof arguments[0] === "object") {
            opt = $.extend(true, opt, arguments[0]);
            api.confirm(opt,function (index) {
                if (index.buttonIndex === 2) {
                    call();
                }
            });
        }
        else if (typeof arguments[0]==="string") {
            opt.msg = String(arguments[0]);
            api.confirm(opt, function (index) {
                if (index.buttonIndex === 2) {
                    call();
                }
            });
        }
        return this;
    };
    /*
     * toast弹窗
     * param:content:提示文字
     *       time:时间
     *       isGb:是否所有页面可见
     * */
    app.toast = function (content, time, isGb) {
        api.toast({
            msg: String(content),
            location: "middle",
            duration: time ? time * 1000 : 3000,
            global: !!isGb
        });
        return this;
    };
    /*
     * 打开模态框
     * param:显示的文字或配置对象
     * */
    app._hasDialog = false;
    app.openDialog = function () {
        var opt = {
            style: 'default',
            animationType: 'fade',
            title: '加载中',
            text: '请稍候',
            modal: false
        };
        //传入字符串
        if (typeof arguments[0] === "string") {
            opt.title = arguments[0];
        }
        //传入对象
        else if (app.isObj(arguments[0])) {
            opt = $.extend(true, opt, arguments[0])
        }
        app._hasDialog = true;
        api.showProgress(opt);
        return this
    };
    /*
     * 关闭模态框
     * */
    app.closeDialog = function () {
        app._hasDialog = false;
        api.hideProgress();
        return this
    };
    /*
     * 打开加载中(目前默认调用系统模态框，后面可改进此方法来更换ajax遮罩)
     * module:UILoading
     * param:显示文字(目前并不支持)
     * */
    app.loadingMd = null;
    app.loadingIds = [];
    app.loading = function (text) {
        if (!app.loadingMd) {
            app.loadingMd = api.require('UILoading')
        }
        var opt = {
            center: {
                x: api.winWidth / 2,
                y: api.winHeight / 2
            },
            size: 30,
            fixed: true
        };
        this.cover("transparent", "loadingCover");
        this.loadingMd.flower(opt, function (id) {
            app.loadingIds.push(id);
        });
        return this;
    };
    /*
     * 关闭加载中
     * */
    app.closeLoading = function () {
        if (!app.loadingMd) {
            app.loadingMd = api.require("UILoading")
        }
        for (var i = 0; i < app.loadingIds.length; i++) {
            app.loadingMd.closeFlower(app.loadingIds[i]);
        }
        app.loadingIds = [];
        app.closeCover("loadingCover");
        return this;
    };
    /*
     * cover div遮罩层
     * param:type:遮罩类型
     *       id:自定义id(可选)
     * */
    app.cover = function (type, id) {
        var bd = $("body");
        var cache = "appCoverLoading";
        if (typeof id === "string") {
            if ($("#" + cache).length) {
                return this;
            }
            cache = id;
        }
        else {
            if ($("#appCoverLoading").length) {
                return this;
            }
        }
        var opt = {
            'transparent': '<div id="' + cache + '" class="cover_loading cover_transparent"></div>',
            'gray': '<div id="' + cache + '" class="cover_loading cover_gray"></div>',
            'white': '<div id="' + cache + '" class="cover_loading cover_white"></div>'
        };
        type && opt[type] ? bd.append(opt[type]) : bd.append(opt["transparent"]);
        return this;
    };
    /*
     * close 关闭遮罩
     * param:id:指定id(不传表示关闭默认打开的cover)
     * */
    app.closeCover = function (id) {
        if (!id) {
            $("#appCoverLoading").remove();
        }
        else {
            $("#" + id + ".cover_loading").remove();
        }
        return this;
    };

    /*
     * msg toast 用户消息提示
     * ps:div..
     * */
    app.toastUserMsg = function (text, fn) {
        if (typeof text !== "string") {
            throw Error("参数错误");
        }
        var html = '<div id="userMsgToast" class="user_msg_toast" onclick="app._clickUserMsgToastModal(event,this)" tapmode>' + text + '<b>查看>></b></div>';
        var userMsgToastModal = $("#userMsgToast");
        if (userMsgToastModal.length) {
            clearTimeout(app._toastUserMsgTimes);
            app._toastUserMsgTimes = null;
            userMsgToastModal.remove();
        }
        $("body").append(html);
        app._toastUserMsgTimes = setTimeout(function () {
            $("#userMsgToast").remove();
        }, 4000);
        app._clickUserMsgToastModal = typeof fn === "function" ? fn : function () {};
        return this;
    };
    /*
     * 通过浏览器打开url
     * param:url:需要打开的url字符串
     * */
    app.openBrowser = function (url) {
        if (this.isIos) {
            api.openApp({
                iosUrl: url
            });
        }
        else if (this.isAndrod) {
            api.openApp({
                androidPkg: 'android.intent.action.VIEW',
                mimeType: 'text/html',
                uri: url
            }, function (ret, err) {
                if (err.msg) {
                    //据说某些华为去掉这两个参数就可以调起外部应用了
                    api.openApp({
                        uri: url
                    }, function (ret, err) {
                        if (err.msg) {
                            app.toast(err.msg);
                        }
                    });
                }
            });
            return false;
        }
    };
    /*
     * 打开内置浏览器url
     * page:browser
     * param:url:需要打开的url字符串
     * */
    app.openOwnBrowser = function (url) {
        if (typeof url === "string") {
            app.goWin("browser", {pageParam: {url: url}});
        }
        else {
            throw Error("url参数错误")
        }
        return this;
    };
    /*
     * 打开浏览器插件url
     * module:webBrowser
     * param:url:需要打开的url字符串
     * */
    app.openFixBrowser = function (url) {
        if (typeof url === "string") {
            var wbMd = api.require("webBrowser");
            wbMd.open({
                url: url,
                titleBar: {
                    bg: "#fff",
                    textColor: "#333"
                }
            });
        }
        else {
            throw Error("url参数错误")
        }
        return this;
    };



    /*
     * f>独立页面功能封装
     * */
    app.agency = {};//代理存储跨页面调用函数

    /*
     * 弹出frame白色遮罩(只能弹出一次)
     * page:white
     * */
    app.openFrameCover = function () {
        app.goFrame("white", {
            bgColor: "#fff",
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            animation: {
                type: "none"
            },
            reload: true
        });
        api.bringFrameToFront({
            from: "white"
        });
    };
    /*
     * 关闭frame白色遮罩
     * page:white
     * */
    app.closeFrameCover = function () {
        app.fire({
            event: "close",
            win: api.winName,
            frame: "white",
            param: {}
        });
    };
    /*
     * 使用新页面实现select(common/select.html来获取)
     * agency:_selectSomething
     * page:select
     * param:option 配置参数 property>title:标题栏显示文字
     *                               more:能否多选
     *                               list:列表数据 exp：["选项A","选项B","选项C"]
     *       call 选择后回调函数 arguments>ary:选项下标
     * */
    app.goSelect = function (option, call) {
        var opt = {};
        if (this.isObj(option) && this.isArray(option.list)) {
            opt = option
        }
        else {
            app.exportError("参数错误");
        }
        var param = {
            title: opt.title || "",//选择标题
            more: !!opt.more,//是否多选
            list: opt.list,//选择列表
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._selectSomething"
        };
        this.agency._selectSomething = function (json) {
            call && call(json);
            delete app.agency._selectSomething;
        };
        app.goWin("select", {
            pageParam: param
        });
    };
    /*
     * 调用多级联动选择器(最多二到三级)
     * module:UIActionSelector
     * param:title:标题 data:数据(按模块规则传入的data) call:处理回调(返回selectedInfo字段中的值)
     * */
    app.openSelect = function (title, data, call) {
        /*初始化选择器*/
        var uasMd = api.require("UIActionSelector");
        var param = {
            datas: data,
            layout: {
                row: 5,                            //（可选项）数字类型；每屏显示的数据行数，超出的数据可以滑动查看，只能是奇数；默认：5
                col: 3,                            //（可选项）数字类型；数据源的数据级数，最多3级；默认：3
                height: 30,                        //（可选项）数字类型；每行选项的高度；默认：30
                size: 14,                          //（可选项）数字类型；普通选项的字体大小；默认：12
                sizeActive: 14,                    //（可选项）数字类型；当前选项的字体大小；默认：同 size
                rowSpacing: 5,                     //（可选项）数字类型；行与行之间的距离；默认：5
                colSpacing: 10,                    //（可选项）数字类型；列与列之间的距离；默认：10
                maskBg: 'rgba(0,0,0,0.1)',         //（可选项）字符串类型；遮罩层背景，点击该区域隐藏选择器，支持 rgb，rgba，#，img；默认：rgba(0,0,0,0.2)
                bg: '#fff',                        //（可选项）字符串类型；选择器有效区域背景，支持 rgb，rgba，#，img；默认：#fff
                color: '#999',                     //（可选项）字符串类型；选项的文字颜色，支持 rgb，rgba，#；默认：#848484
                colorSelected: '#666'              //（可选项）字符串类型；已选项的文字颜色，支持 rgb，rgba，#；默认：同 colorActive
            },
            cancel: {
                text: '取消',                      //（可选项）字符串类型；取消按钮的显示文字；默认：未设置时只显示背景
                size: 12,                          //（可选项）数字类型；取消按钮的显示文字大小；默认：12
                w: 90,                             //（可选项）数字类型；取消按钮的宽；默认：90
                h: 35,                             //（可选项）数字类型；取消按钮的高；默认：35
                bg: '#fff',                        //（可选项）字符串类型；取消按钮的背景，支持 rgb，rgba，#，img；默认：'#fff'
                bgActive: '#ccc',                  //（可选项）字符串类型；取消按钮的背景高亮，支持 rgb，rgba，#，img；默认：同 bg
                color: '#888',                     //（可选项）字符串类型；取消按钮的文字颜色，支持 rgb，rgba，#；默认：'#848484'
                colorActive: '#fff'                //（可选项）字符串类型；取消按钮的文字颜色高亮，支持 rgb，rgba，#；默认：同 color
            },
            ok: {
                text: '确定',                      //（可选项）字符串类型；确定按钮的显示文字；默认：未设置时只显示背景
                size: 12,                          //（可选项）数字类型；确定按钮的显示文字大小；默认：12
                w: 90,                             //（可选项）数字类型；确定按钮的宽；默认：90
                h: 35,                             //（可选项）数字类型；确定按钮的高；默认：35
                bg: '#fff',                        //（可选项）字符串类型；确定按钮的背景，支持 rgb，rgba，#，img；默认：'#fff'
                bgActive: '#ccc',                  //（可选项）字符串类型；确定按钮的背景高亮，支持 rgb，rgba，#，img；默认：同 bg
                color: '#888',                     //（可选项）字符串类型；确定按钮的文字颜色，支持 rgb，rgba，#；默认：'#848484'
                colorActive: '#fff'                //（可选项）字符串类型；确定按钮的文字颜色高亮，支持 rgb，rgba，#；默认：同 color
            },
            title:{                                      //（可选项）JSON 对象类型；选择器顶部标题栏设置
                text: title,                    //（可选项）字符串类型；选择器的标题内容；默认：请选择
                size: 12,                          //（可选项）数字类型；标题内容的文字大小；默认：12
                h: 44,                             //（可选项）数字类型；标题栏的高；默认：44
                bg: '#eee',                        //（可选项）字符串类型；标题栏的背景，支持 rgb，rgba，#，img；默认：'#eee'
                color: '#888'                      //（可选项）字符串类型；标题内容的文字颜色，支持 rgb，rgba，#；默认：'#848484'
            }
        };
        !!api.frameName && (param.fixedOn = api.frameName);
        uasMd.open(param, function (r) {
            if (r["eventType"] && r["eventType"] === "ok") {
                call(r["selectedInfo"]);
            }
            else if (r["eventType"] && r["eventType"] === "cancel") {
                uasMd.close();
            }
        });
    };
//选择地址(在common/area.html中)
// app.areaChoose = function (call) {
//     var param = {
//         title: "选择地区",
//         backFrame: api.frameName,
//         backWin: api.winName,
//         call: "app._chooseArea"
//     };
//     this._chooseArea = function (json) {
//         call&&call(json);
//         delete app._chooseArea;
//     };
//     app.goWin("area",{
//         pageParam: param,
//         animation:{
//             type:"push",
//             subType:"from_right",
//             curve:"ease_out"
//         }
//     });
// };
    /*
     * 选择地址
     * module:UIActionSelector
     * page:area.js
     * param:call 选择回调 attr>province:省
     *                          province_id 省id
     *                          city 城市
     *                          city_id 城市id
     *                          area 地区(可能没有)
     *                          area_id 地区id(可能没有)
     * */
    app.areaChoose = function (call) {
        var callBack = function (r) {
            var data = r;
            var pp = ["province", "city", "area"];
            var backData = {}, temp = null;
            for (var i = 0; i < 3; i++) {
                temp = data[i] || {id: data[i - 1].id, name: ""};
                if (!!r[i]) {
                    backData[pp[i]] = temp.name;
                    backData[pp[i] + "_id"] = temp.id;
                }
                else {
                    backData[pp[i]] = "";
                    backData[pp[i] + "_id"] = backData[pp[i - 1] + "_id"]
                }
            }
            call(backData);
        };
        if (!app.areaChoose._areaData) {
            app.loadJs("area.js",function(){
                var data=window.nc_a;
                //拼装地址数据为模块所需json格式
                var cb = function (ncaId) {
                    var nca = [];
                    var ncaAry = data[parseInt(ncaId)];
                    if (app.isArray(ncaAry) && ncaAry.length) {
                        var temp = null, nextTemp = null;
                        for (var i = 0; i < ncaAry.length; i++) {
                            temp = {};
                            nextTemp = null;
                            temp["id"] = ncaAry[i][0];
                            temp["name"] = ncaAry[i][1];
                            nextTemp = cb(ncaAry[i][0]);
                            if (nextTemp.length) {
                                temp.sub = ([]).concat(nextTemp);
                            }
                            nca.push(temp);
                        }
                        return nca
                    }
                    else {
                        return [];
                    }
                };
                app.areaChoose._areaData = cb(0);
                app.copyText(app.toStr({data:app.areaChoose._areaData}));
                app.openSelect("选择地址", app.areaChoose._areaData, callBack);
            });

            //原来代码
            // var execParam = {name: api.winName};
            // !!api.frameName && (execParam.frameName = api.frameName);
            // //读取area.js的地址信息并重装对象
            // api.readFile({sync: false, path: api.wgtRootDir + "/script/area"}, function (r) {
            //     if (r.status) {
            //         execParam.script = r.data + ";window.ncaCallback(window.nc_a)";
            //         window.ncaCallback = function (data) {
            //             //拼装地址数据为模块所需json格式
            //             var cb = function (ncaId) {
            //                 var nca = [];
            //                 var ncaAry = data[parseInt(ncaId)];
            //                 if (app.isArray(ncaAry) && ncaAry.length) {
            //                     var temp = null, nextTemp = null;
            //                     for (var i = 0; i < ncaAry.length; i++) {
            //                         temp = {};
            //                         nextTemp = null;
            //                         temp["id"] = ncaAry[i][0];
            //                         temp["name"] = ncaAry[i][1];
            //                         nextTemp = cb(ncaAry[i][0]);
            //                         if (nextTemp.length) {
            //                             temp.sub = ([]).concat(nextTemp);
            //                         }
            //                         nca.push(temp);
            //                     }
            //                     return nca
            //                 }
            //                 else {
            //                     return [];
            //                 }
            //             };
            //             app.areaChoose._areaData = cb(0);
            //             app.openSelect("选择地址", app.areaChoose._areaData, callBack);
            //         };
            //         api.execScript(execParam);
            //     }
            // });
        }
        else {
            app.openSelect("选择地址", app.areaChoose._areaData, callBack);
        }
    };
    /*
     * 调用搜索功能(search/search.html)
     * page:search
     * param:page:搜索类型
     *       param:给search页的参数(key和placeholder) attr>key:默认关键字
     *                                                    placeholder:你懂得
     *       pageParam:给搜索列表页的参数(根据不同页面自定义)
     * */
    app.goSearch = function (page, param, pageParam) {
        if (page === undefined) {
            app.exportError("缺少page参数");
        }
        var p = {
            key: "",
            placeholder: "请输入搜索内容"
        };
        var pageP = {
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app._searchSomething"
        };
        var callBack = pageParam.call;
        this._searchSomething = function (o) {
            typeof callBack === "function" && callBack.apply(this, arguments);
            delete app._searchSomething;
        };
        if (app.isObj(param)) {
            $.extend(true, p, param);
        }
        if (app.isObj(param)) {
            $.extend(true, pageParam, pageP);
        }
        this.goWin("search", {
            pageParam: {
                page: String(page),
                key: p.key,
                placeholder: p.placeholder,
                focus: p.focus,
                pageParam: pageParam
            },
            animation: {
                type: "push",
                subType: "from_right",
                curve: "ease_out"
            }
        });
        return this;
    };
    /*
     * 选择月份
     * agency:_selectMonth
     * page:month
     * param:param:参数 attr>type:"right"目前仅支持右侧打开
     *                       start:1999.8 起始月份
     *                       end 1999.9 结束月份
     *                       title:头部文字
     *       call:选择回调 arguments>date: data:年-月格式字符串 或null exp:2005-9
     * */
    app.openMonthSelect = function (param, call) {
        //配置参数
        var p = {
            title: "月份选择",
            start: "1970.1",
            end: new Date().getFullYear() + "." + (new Date().getMonth() + 1)
        };
        if (app.isObj(param)) {
            $.extend(true, p, param);
        }
        var params = {
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._selectMonth"
        };
        $.extend(true, p, params);
        this.agency._selectMonth = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._selectMonth;
        };
        this.goFrame("month", {
            pageParam: p,
            bounces: false,
            bgColor: "rgba(0,0,0,0)",
            reload: true,
            rect: {
                x: 0,
                y: p.top || 0,
                w: api.winWidth,
                h: api.winHeight - (p.top || 0)
            },
            animation: {
                type: "fade",
                curve: "ease_out",
                duration: 100
            }
        });
        return this;
    };
    /*
     * 在当前页中切换站点
     * agency:_chooseCountry
     * page:countryAlertList
     * param:param:打开frame参数 call
     *       call:回调 arguments> index:一个索引值
     * ps:具体传参和功能没有封装在内，为主页封装的方法
     * */
    app.openChooseCountry = function (param, call) {
        var params = {
            pageParam: {},
            bounces: false,
            bgColor: "rgba(0,0,0,0)",
            reload: true,
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            animation: {
                type: "none",
            }
        };
        if (app.isObj(param)) {
            $.extend(true, params, param);
        }
        $.extend(true, params.pageParam, {
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._chooseCountry"
        });
        this.agency._chooseCountry = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._chooseCountry;
        };
        this.goFrame("countryAlertList", params);
        return this;
    };
    /*
     * 在当前页中切换分类
     * agency:_chooseCategory
     * page:categoryAlertList
     * param:param:打开frame参数 call
     *       call:回调 arguments> index:一个索引值
     * ps:具体传参和功能没有封装在内,为求购主页封装的方法
     * */
    app.openChooseCategory = function (param, call) {
        var params = {
            pageParam: {},
            bounces: false,
            bgColor: "rgba(0,0,0,0)",
            reload: true,
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            animation: {
                type: "none"
            }
        };
        if (app.isObj(param)) {
            $.extend(true, params, param);
        }
        $.extend(true, params.pageParam, {
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._chooseCategory"
        });
        this.agency._chooseCategory = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._chooseCategory;
        };
        this.goFrame("categoryAlertList", params);
        return this;
    };
    /*
     * 打开图片浏览器
     * page:picture
     * module:photoBrowser
     * param:param:配置参数 attr>ary:图片字符串数组
     *                          index：默认显示第几张
     *                          call：回调（暂无）}
     * */
    app.openPicView = function (param) {
        var dfP = {
            ary: [],
            index: 0,
            call: null
        };
        $.extend(true, dfP, param);
        if (!app.isArray(dfP.ary)) {
            return false
        }
        app.goWin("picture", {
            animation: {
                type: "fade",
                duration: 180,
                curve: "ease_out"
            },
            bgColor: "#000",
            pageParam: dfP
        });
        return this;
    };
    /*
     * 打开留言弹窗
     * attr:_leaveMsgText
     * param:opt:参数 attr >value:初始填充的内容
     *                      placeholder:你懂得
     *                      max:最大文字数量
     *                      ext:额外的附加参数，会在回调中传回
     *                      callback:你懂得 arguments>data:text:填写的文字
     *                                                     ext:传回的值
     * */
    app.openLeaveMsg=function(param,call){
        var params={
            pageParam: {},
            bounces: false,
            bgColor: "rgba(0,0,0,0)",
            reload: true,
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            animation: {
                type: "none"
            }
        };
        var pageParam={
            value:param.value||"",
            placeholder:param.placeholder||"",
            max:param.max||100,
            ext:app.isObj(param.ext)?param.ext:{},
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._leaveMsgText"
        };
        if (app.isObj(param)) {
            $.extend(true, params, param);
        }
        $.extend(true, params.pageParam,pageParam);
        this.agency._leaveMsgText = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._leaveMsgText;
        };
        this.goFrame("leaveMsg", params);
        return this;
    };
    /*
     * 打开报价弹窗
     * attr:_leaveNumberText
     * param:opt:参数 attr>num:初始填充的内容
     *                     placeholder:你懂得
     *                     min:最低数字（默认无）
     *                     max:最高数字（默认无）
     *                     callBack:你懂得 arguments>data:num:填写的数字
     *
     * */
    app.openLeaveNumber=function(param,call){
        var params={
            pageParam: {},
            bounces: false,
            bgColor: "rgba(0,0,0,0)",
            reload: true,
            rect: {
                x: 0,
                y: 0,
                w: api.winWidth,
                h: api.winHeight
            },
            animation: {
                type: "none"
            }
        };
        var pageParam={
            num:param.value||"",
            placeholder:param.placeholder||"",
            min:param.min!==undefined?Number(param.min):null,
            max:param.max!==undefined?Number(param.max):null,
            backFrame: api.frameName,
            backWin: api.winName,
            call: "app.agency._leaveNumberText"
        };
        if (app.isObj(param)) {
            $.extend(true, params, param);
        }
        $.extend(true, params.pageParam,pageParam);
        this.agency._leaveNumberText = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._leaveNumberText;
        };
        this.goFrame("leaveNumber", params);
        return this;
    };



//调用身份证扫描功能(仅支持ios)
// app.openIdCardScan=function(call){
//     if(app.isIos){
//         var doFn=function(){
//             if(app.openIdCardScan._cdMd==undefined){
//                 app.openIdCardScan._cdMd=api.require('idcard');
//             }
//             app.openIdCardScan._cdMd.cardInfo(function(ret) {
//                 call(ret);
//             });
//         };
//         if(!app.getStorage("isReadScanInfo")){
//             app.setStorage("isReadScanInfo",true);
//             app.alert("使用扫描功能提示：扫描时注意光照的影响，尽量避免反光和黑影;不要使扫描角度倾斜过大，以免造成图像严重变型；",doFn);
//         }
//     }
// };
    /*
     * 进入裁剪页
     * agency:_clipImg
     * page:clip
     * module:FNImageClip
     * param:param:参数 attr>path（要裁剪的图片）
     *       call（执行的回调函数）
     * */
    app.goClip = function (param, call) {
        if (!app.isObj(param)) {
            app.exportError("缺少param参数");
        }
        // else if(app._clipImg){
        //     return false;
        // }
        var p = {
            call: "app.agency._clipImg",
            backFrame: api.frameName,
            backWin: api.winName
        };
        this.agency._clipImg = function (o) {
            typeof call === "function" && call.apply(this, arguments);
            delete app.agency._clipImg;
        };
        $.extend(true, p, param);
        this.goWin("clip", {
            pageParam: p,
            animation: {
                type: "push",
                subType: "from_right",
                curve: "ease_out"
            }
        });
        return this;
    };

    /*
     * 识别某个url，并做内部跳转或者外部打开
     * page:browser
     * module:webBrowser
     * param:url url字符串
     * */
    app.adaptUrl = function (url) {
        var search = url.split("?");
        if (search.length === 2) {
            var tmp = null;
            for (var i in app.adaptLink._linkRule) {
                tmp = app.adaptLink._linkRule[i](search[1]);
                if (tmp) {
                    app.adaptLink._pageRule[i](tmp);
                    return this;
                }
            }
        }
        //无参数链接或无法识别的链接直接跳转
        app.openBrowser(url);
        return this
    };

    /*
     * a标签链接跳转识别
     * attr:_pageRule:跳转规则 _linkRule:解析规则
     * param:selector:容器选择器（会激活内部所有a标签）
     */
    app.adaptLink = function (selector) {
        var wrapper = $("" + selector);
        if (!wrapper.length) {
            return false;
        }
        var aNode = wrapper.find("a");
        aNode.each(function () {
            var _t = $(this);
            var hrefLink=_t.attr("href");
            _t.data("href",hrefLink);
            _t.attr({
                "tapmode": "tapmode",
                "href":"javascript:;"
            }).removeAttr("target");
            this.onclick = function (e) {
                e.preventDefault();
                e.stopPropagation();
                var href=$(this).data("href");
                var search = href.split("?");
                if (search.length === 2) {
                    var tmp = null;
                    for (var i in app.adaptLink._linkRule) {
                        tmp = app.adaptLink._linkRule[i](search[1]);
                        if (tmp) {
                            app.adaptLink._pageRule[i](tmp);
                            return false;
                        }
                    }
                }
                //无参数链接或无法识别的链接直接跳转
                app.openBrowser(href);
                return false;
            };
        });
        api.parseTapmode();
        return this;
    };
    //解析规则
    app.adaptLink._linkRule = {
        "articleList": function (searchStr) {
            if ((/article/).test(searchStr)) {
                var acId = searchStr.match(/ac_id\=\d+/);
                if (acId && acId.length) {
                    return {articlelist_id: acId[0].replace(/\D/g, "")};
                }
            }
            return false
        },
        "article": function (searchStr) {
            if ((/(article.*show)|(show.*article)/).test(searchStr)) {
                var articleId = searchStr.match(/article_id\=\d+/);
                if (articleId && articleId.length) {
                    return {article_id: articleId[0].replace(/\D/g, "")};
                }
            }
            return false
        },
        "goods": function (searchStr) {
            if ((/goods/).test(searchStr)) {
                var goodsId = searchStr.match(/goods_id\=\d+/);
                if (goodsId && goodsId.length) {
                    return {goods_id: goodsId[0].replace(/\D/g, "")};
                }
            }
            return false
        },
        "searchGoods": function (searchStr) {
            if ((/search/).test(searchStr)) {
                var cateId = searchStr.match(/cate_id\=\d+/);
                if (cateId && cateId.length) {
                    return {gc_id: cateId[0].replace(/\D/g, "")};
                }
            }
        }
    };
    //跳转规则
    app.adaptLink._pageRule = {
        "articleList": function (p) {
            app.goPage("title", {
                title: "文章列表",
                page: "articleList",
                pageParam: p
            });
        },
        "article": function (p) {
            app.goPage("article", p);
        },
        "goods": function (p) {
            app.goPage("shoppingInfo", p);
        },
        "searchGoods": function (p) {
            app.goPage("title", {
                title: "商品列表",
                page: "shoppingList",
                pageParam: p
            });
        }
    };
    /*
     * 新消息跳转方式识别
     * page:可能跳转多个页面
     * param:id:信息id,code:类型code,param:扩展参数
     * */
    app.adaptMsg = function (id, code, param) {
        var close = null, winId = null,  pp = {}, am = {
            type:"push",
            subType:"from_right",
            duration:300
            // type: "none"
        };
        //1:跳转到普通消息详情
        if (code == 1) {
            pp.msgId = id;
            winId = "msgInfo";
        }
        //2.跳转到求购详情
        else if (code == 2 || code == 4) {
            close = true;
            // mainIndex=2;//别想多了，到时候切换的时候闪屏给你提个bug过来看你怎么改
            //指定报价留言
            if(param["is_quotation"]==1){
                winId = "title";
                pp = {
                    title: "查看报价",
                    page: "quoteList",
                    pageParam: {pId: param["goods_id"]}
                };
            }
            //针对求购信息留言
            else {
                winId = "publishInfo";
                pp = {pId: param["goods_id"]};
            }
        }
        //3.跳转到报价列表页
        else if (code == 3) {
            close = true;
            winId = "title";
            pp = {
                title: "查看报价",
                page: "quoteList",
                pageParam: {pId: param["goods_id"]}
            };
        }
        // //4.跳转到我发布的列表
        // else if(code==4){
        //     close=true;
        //     // mainIndex=4;
        //     winId="myPublish";
        //     pp={open:param["goods_state"]==1?0:2}
        // }
        //5.跳转到订单详情
        else if (code == 5) {
            close = true;
            //mainIndex=3;
            pp = {order_id: param["order_id"]};
            if (param["is_seller"]) {
                winId = "sellerOrderInfo";
            }
            else {
                winId = "orderInfo"
            }
        }
        //6.跳转到退款详情
        else if (code == 6) {
            close = true;
            //mainIndex=3
            pp = {refund_id: param['refund_id']};
            if (param["is_seller"]) {
                winId = "sellerRefund";
            }
            else {
                winId = "orderAfterInfo"
            }
        }
        else {
            pp.msgId = id;
            winId = "msgInfo";
        }
        if (close) {//非消息详情
            //访问一下本消息详情，以更改消息访问状态
            app.post({
                url: app.config.url + "/index.php?act=member_message&op=detail",
                data: {"message_id": id},
                cover: false,
                success: function (r) {
                    //更新留言条数
                    // app.updateFetch("msgNum");
                    //通知主页刷新未读消息条数
                    app.fire({
                        event: "changeTag",
                        win: "main",
                        param: {}
                    });
                    app.goWin(winId,{
                        pageParam: pp,
                        animation: am
                    });
                }
            }, true);
        }
        else {
            //打开消息详情
            app.goWin(winId, {
                pageParam: pp,
                animation: am
            });
        }
    };
    /*
     * 打开浮窗提示消息
     * attr:_isOpen:是否已打开浮窗
     * agency:_clickFloatMsgFn,_hideFloatMsgFrame
     * page:floatMsg
     * param:title消息标题 msg消息内容 data消息内容 call点击回调
     * ps:必须在win上面使用，多次消息提醒会形成队列，最快1s一条
     * ps:如果在有浮窗的时候打开新的frame，会遮盖浮窗
     * ps:先打开frame，然后再次调用时调用fire，frame关闭时调用本页面的_hideFloatMsgFrame，点击消息时调用本页面的_clickFloatMsgFn
     * ps:坑爹指数：☆☆☆☆
     * */
    app.openFloatMsg = function (title, msg, callback) {
        var pg = {
            title: title,
            content: msg,
            call: "app.agency._clickFloatMsgFn",
            hide: "app.agency._hideFloatMsgFrame"
        };
        app.agency._clickFloatMsgFn = typeof callback == "function" ? callback : function () {
        };
        if (!app.openFloatMsg._isOpen) {
            app.openFloatMsg._isOpen = true;
            if (!app.agency._hideFloatMsgFrame) {
                app.agency._hideFloatMsgFrame = function () {
                    app.openFloatMsg._isOpen = false;
                };
            }
            //未打开浮窗，打开新frame
            app.goFrame("floatMsg", {
                pageParam: pg,
                bgColor: "rgba(0,0,0,0)",
                reload: true,
                bounces: false,
                rect: {
                    x: 0,
                    y: 0,
                    w: api.winWidth,
                    h: 65
                }
            });
        }
        else {
            //已打开浮窗，直接给浮窗内部通知刷新
            app.fire({
                event: "refresh",
                win: api.winName,
                frame: "floatMsg",
                param: pg
            });
        }
        api.bringFrameToFront({
            from: "floatMsg"
        });
    };

    /*
     * 打开提示遮罩
     * param: name:遮罩类型
     *        top:透明部分距离顶部高度
     *        h:透明部分高度
     *        call:点击透明部分回调
     *        extend:其他参数
     * ps:主要是用在用户首次进入给予一个提示引导遮罩
     * ps:目前有遮罩：shipmentsHint 发货人编辑 countryHint 首页分站切换
     * ps:HTML结构已在HTML中构建好
     * */
    app.openHint = function (name, top, h, call, extend) {
        var p = {
            call: "app._hintCall",
            top: 0,
            h: 0,
            backFrame: api.frameName,
            backWin: api.winName
        };
        this._hintCall = function () {
            typeof call === "function" && call.apply(this, arguments);
            delete app._hintCall;
        };
        $.extend(true, p, {top: top, h: h});

        stg = app.getStorage("hintCache");
        //更改默认发货人提示(extend:是否强制显示（用于测试）)
        if (name === "shipmentsHint") {
            if (!stg.shipments || extend) {
                stg.shipments = true;
                app.setStorage("hintCache", stg);
                $.extend(true, p, {type: "shipments"});
                this.goFrame("coverHint", {
                    rect: {
                        t: 0,
                        l: 0,
                        w: api.winWidth,
                        h: api.winHeight
                    },
                    reload: true,
                    pageParam: p,
                    bgColor: "rgba(0,0,0,0)",
                    animation: {
                        type: "none"
                    }
                });
            }
        }
        //首页分站选择提示(extend:是否强制显示（用于测试）)
        else if (name === "countryHint") {
            if (!stg.country || extend) {
                stg.country = true;
                app.setStorage("hintCache", stg);
                $.extend(true, p, {type: "country"});
                this.goFrame("coverHint", {
                    rect: {
                        t: 0,
                        l: 0,
                        w: api.winWidth,
                        h: api.winHeight
                    },
                    reload: true,
                    pageParam: p,
                    bgColor: "rgba(0,0,0,0)",
                    animation: {
                        type: "none"
                    }
                });
            }
        }
        //个人中心卖货标签设置提示(extend:是否强制显示（用于测试）)
        else if(name==="tagHint"){
            if (!stg.tag || extend) {
                stg.tag = true;
                app.setStorage("hintCache", stg);
                $.extend(true, p, {type: "tag"});
                this.goFrame("coverHint", {
                    rect: {
                        t: 0,
                        l: 0,
                        w: api.winWidth,
                        h: api.winHeight
                    },
                    reload: true,
                    pageParam: p,
                    bgColor: "rgba(0,0,0,0)",
                    animation: {
                        type: "none"
                    }
                });
            }
        }
        return this;
    };

    /*
    * 打开引导图片弹窗
    * param:src:图片地址
    * page:tool/img_alert
    * ps:这里的src地址是基于image文件夹路径
    * */
    app.openImgAlert=function(src){
        app.goFrame("imgAlert",{
            pageParam:{img:src},
            rect:{x:0,y:0,w: api.winWidth,h: api.winHeight},
            animation:{
                type:"fade",
                duration:300
            }
        });
        return this;
    };

    /*
    * 打开额外的固定弹窗
    * param:win:窗口id param:打开窗口的参数
    * ps:所有的内容在这个窗口内自己定义，这里只是简单给一个打开frame的方法
    * */
    app.openCustomAlert=function(win,p){
        app.goFrame(win,$.extend(true,{
            rect:{x:0,y:0,w: api.winWidth,h: api.winHeight},
            animation:{
                type:"fade",
                duration:300
            }
        },app.isObj(p)?p:{}));
        api.bringFrameToFront({
            from:win
        });
        return this;
    };

    /*
    * 检测用户是否打开了通知
    *
    * ps:仅ios
    * */
    app.checkDevNot=function(){
        // app.removeStorage("lastCheckNotTime");
        // app.removeStorage("checkNotJumpVersion");
        // return false;
        if(!app.isIos){
            return false;
        }
        var appSettings = api.require('appSettings');
        if(appSettings){
            var lastCheckNotTime=app.getStorage("lastCheckNotTime");
            var checkNotJumpVersion=app.getStorage("checkNotJumpVersion");
            var now=new Date().getTime();
            var ver,time,mack=true;
            var tp=String(lastCheckNotTime).split("&");
            if(tp.length!=2){
                ver=-1;
                time=0;
            }
            else {
                ver =tp[0];
                time=parseInt(tp[1]);
            }
            if(ver!=api.appVersion){
                //非当前版本，必然检测一次
                mack=false;
            }
            else if(now-time>86400000&&!checkNotJumpVersion){
                //当前版本，但是超过一天且未跳过此版本
                mack=false;
            }
            if(!mack){
                app.setStorage("lastCheckNotTime",api.appVersion+"&"+now);
                app.setStorage("checkNotJumpVersion",false);
                appSettings&&appSettings["checkNotification"](function(ret){
                    if (!ret.status) {
                        setTimeout(function(){
                            app.openCustomAlert("checkNot");
                        },500)
                    }
                });
            }
        }
    };



})(window.app||(window.app={}));